--------------------------------------------------
--                                              --
--                TDG - Crucia                  --
--                                              --
--    Set of warnings to ease the encoutner     --
--                                              --
--------------------------------------------------


-- Variables -----------------------------------------------------------

RWConfig.Crucia = {
	Active = true,

	WDispelNegatedText = "",
	WDispelColor = { r = 0.1, g = 0.5, b = 1.0, a = 1.0 },
	
	WBlindColor = { r = 0.8, g = 0.8, b = 0.1, a = 1.0 },
	WBlindNowColor = { r = 1.0, g = 0.1, b = 0.1, a = 1.0 },
	WBlindNowTime = 1.5,
	WBlindTime = 3,
	WBlindCheckTime = 3.5,

	WMCColor = { r = 1.0, g = 0.1, b = 0.1, a = 1.0 },
	WMCFreeColor = { r = 0.1, g = 1.0, b = 0.1, a = 1.0 },
	WMCFreeTime = 1.5,
	
	RFMaskColor = { r = 0.0, g = 0.0, b = 1.0, a = 0.4 },
	MCMaskColor = { r = 1.0, g = 0.0, b = 0.0, a = 0.4 },
	NegatedMaskColor = { r = 0.8, g = 0.0, b = 1.0, a = 0.4 },
	
	ShowBlinded = true,
}

RWData.Crucia = {
	WDispelText = RWRoot.locTxt.Crucia.WDispelText,
	WBlindText = RWRoot.locTxt.Crucia.WBlindText,

	WMCText = RWRoot.locTxt.Crucia.WMCText,
	WMCFreeText = RWRoot.locTxt.Crucia.WMCFreeText,
	
	NoBlindedMessage = RWRoot.locTxt.Crucia.NoBlindedMessage,
	BlindedFoundMessage = RWRoot.locTxt.Crucia.BlindedFoundMsg,

	ZoneName = RWRoot.locTxt.Crucia.ZoneName,

	CruciaBlindEmote = RWRoot.locTxt.Crucia.CruciaBlindEmote,
	
	--CruciaPhase2End = "Vous osez détruire mes machines ! Approchez... que je vous inculque le vrai sens du mot 'dévastation' !",
	--CruciaPhase3Begin = "Ces frivolités me lassent !",
	--CruciaPhase3End = "mmmmmmm",
	--CruciaPhase5Begin = "Impossible ! Même ébranlée, ma puissance dépasse de loin votre imagination.",
	--CruciaPhase5End = "mmmmmmm",
	
	NegateBuffName = RWRoot.locTxt.Crucia.NegateBuffName,
	--NegateBuffName = "Armure d'Anathema",
	--RobotNagateBuffID = "BFDCA1E70BEF2B24A", -- Linceul de negativité lancé par le robot
	--CruciaNagateBuffID = "BFCCCBAD0C6C612E6", -- Linceul de negativité lancé par Crucia
	
	LockedDebuffID = 	"BFC1EBB0C8732D8B8", 	-- cible verouillée
	
	--FreezeDebuff2ID = 	"BFF82C871C5EDAD5D",	-- Refroidissement stabilisé
	--BombDebuff = 	"BFEC181B5A316A493",	-- Paratonerre
	FreezeDebuffID = 	"BFBB93FBD79C85DEF",	-- Refroidissement instable
	MCDebuffID = 		"BFD3474BE4FFA4FC0",	-- Benediction de la reine des tempete
	
	--MCDebuffID = "BFD8E0560046EF0F5", -- arumre d'anathema
	--FreezeDebuffID = "BFE2D5BD9CD53C727", -- puissance de Neddra
	
	BlindDebuffID = 	"B32FAF7C4283BF5C6"		-- Fureur tempétueuse
}

RWRoot.Crucia = {

	EncounterActive = false,

	RaidFrameConf = 0,

	MCPlayerName = "",
	MCFound = nil,

	MCTimer = 0,
	BlindTimer = 0,
	BlindColorChanged = false,
	BlindRound = 0,
	nbBlinded = 0,
	BlindCheckTimer = 0,

	CruciaTimer = 0,

	DispelNeeded = 0
}

local DebuffActive = {}

-- Warnings Messages
local WBlind = nil
local WDispel = nil
local WMC = nil
-- RaidFrame Mask
local DebuffRaidFrame = nil
local MCFrame = nil


-- Init functions -----------------------------------------------------------


-- MC init function
local function InitMCWarning()
	
	RWRoot.Crucia.MCTimer = 0
	
	WMC:TextTo( string.format(RWData.Crucia.WMCText, RWRoot.Crucia.MCPlayerName) )
	WMC:SetFontColor(RWConfig.Crucia.WMCColor.r, RWConfig.Crucia.WMCColor.g, RWConfig.Crucia.WMCColor.b)
	
	MCFrame:SetCoordTo(MCPlayerName)
end

local function InitMCFree()
	WMC:TextTo( string.format(RWData.Crucia.WMCFreeText, RWRoot.Crucia.MCPlayerName) )
	WMC:SetFontColor(RWConfig.Crucia.WMCFreeColor.r, RWConfig.Crucia.WMCFreeColor.g, RWConfig.Crucia.WMCFreeColor.b)
	WMC:VisibleTo(true)
	RWRoot.Crucia.MCTimer = Inspect.Time.Frame() + RWConfig.Crucia.WMCFreeTime
	RWRoot.Crucia.MCFound = nil
	MCFrame:SetVisible(false)
end


-- Dispel init function
local function InitDispelWarning()
	RWRoot.Crucia.DispelNeeded = 0
	WDispel:VisibleTo(false)
end

local function InitDispelWarningPos()
	--WDispel:SetPoint("CENTER", UIParent, "CENTER", 0, -80)		
	--WDispel:InitShadowPos()
end


-- Blind init function
local function InitBlindWarning()
	RWRoot.Crucia.BlindColorChanged = false
	RWRoot.Crucia.BlindTimer = 0
	WBlind:VisibleTo(false)
	WBlind:SetFontColor(RWConfig.Crucia.WBlindColor.r, RWConfig.Crucia.WBlindColor.g, RWConfig.Crucia.WBlindColor.b)
end


-- Init all
local function InitData()

	InitDispelWarning()
	InitBlindWarning()
	
	DebuffActive = {}
	
	RWRoot.Crucia.MCFound = nil
	RWRoot.Crucia.MCTimer = 0
	RWRoot.Crucia.BlindRound = 0
	RWRoot.Crucia.BlindCheckTimer = 0
	
	RWRoot.Crucia.CruciaTimer = 0
	RWRoot.Crucia.EncounterActive = false
	
	WMC:VisibleTo(false)
	MCFrame:SetVisible(false)
	DebuffRaidFrame:SetVisible(false)
end


-- Initialize the addon

local function InitAddon()

	-- Warnings Messages
	WBlind = RWRoot.AssignRWText(1)
	WDispel = RWRoot.AssignRWText(2)
	WMC = RWRoot.AssignRWText(3)
	-- RaidFrame Mask
	DebuffRaidFrame = RWRoot.AssignRWRaidMask(1)
	MCFrame = RWRoot.AssignRWMask(1)

	-- BlindMessage Object
	WBlind:TextTo(RWData.Crucia.WBlindText)
	WBlind:SetFontColor(RWConfig.Crucia.WBlindColor.r, RWConfig.Crucia.WBlindColor.g, RWConfig.Crucia.WBlindColor.b)

	-- DispelMessage Object
	WDispel:SetFontColor(RWConfig.Crucia.WDispelColor.r, RWConfig.Crucia.WDispelColor.g, RWConfig.Crucia.WDispelColor.b)

	-- RaidMaskFrame object	
	MCFrame:SetMaskColor(RWConfig.Crucia.MCMaskColor.r, RWConfig.Crucia.MCMaskColor.g, RWConfig.Crucia.MCMaskColor.b, RWConfig.Crucia.MCMaskColor.a)
	
	-- Init the rest of the Data	
	InitData()

end


-- Handlers -----------------------------------------------------------


-- Boss emote handler

local function EventChatNotify(handle, info)

	if info.message:match(RWData.Crucia.CruciaBlindEmote) then
		local CurrentTime = Inspect.Time.Frame()
		RWRoot.Crucia.BlindTimer = CurrentTime + RWConfig.Crucia.WBlindTime
		RWRoot.Crucia.BlindRound = RWRoot.Crucia.BlindRound + 1
		if RWConfig.Crucia.ShowBlinded then 
			print(string.format(RWRoot.locTxt.Crucia.BlindRound, RWRoot.Crucia.BlindRound)) 
			RWRoot.Crucia.nbBlinded = 0
			RWRoot.Crucia.BlindCheckTimer = CurrentTime + RWConfig.Crucia.WBlindCheckTime
		end

	end
end


-- Buff Added handler

local function BuffsAdded(handle, id, buffs)

	local player = Inspect.Unit.Detail(id)
	if player.relation == "hostile" then return end
	
	local PBuffs = Inspect.Buff.Detail(id, buffs)

	for k, v in pairs(PBuffs) do
		if v.debuff then
		
			-- Gel? ou Negativité?
			local FreezeDebuff = (v.type == RWData.Crucia.FreezeDebuffID)
			if (FreezeDebuff) or (v.name == RWData.Crucia.NegateBuffName) then
				if not DebuffActive[k] then	
					local i, posInGroup = RWRoot.GetPlayerPos(player.name)
					if i then 
						if (FreezeDebuff) and (RWRoot.Crucia.RaidFrameConf ~= 1) then
							RWRoot.Crucia.RaidFrameConf = 1
							WDispel:TextTo(RWData.Crucia.WDispelText)
							DebuffRaidFrame:SetColor(RWConfig.Crucia.RFMaskColor.r, RWConfig.Crucia.RFMaskColor.g, RWConfig.Crucia.RFMaskColor.b, RWConfig.Crucia.RFMaskColor.a)
						end
					
						DebuffActive[k] = DebuffRaidFrame:Highlight(i, posInGroup)

						RWRoot.Crucia.DispelNeeded = RWRoot.Crucia.DispelNeeded + 1
						if RWRoot.Crucia.DispelNeeded == 1 then InitDispelWarningPos() end
					end
				end
				
			-- MC?
			elseif v.type == RWData.Crucia.MCDebuffID then
				if not RWRoot.Crucia.MCFound then
					RWRoot.Crucia.MCFound = k
					RWRoot.Crucia.MCPlayerName = player.name
					InitMCWarning()
				end				
				
			-- Blind?
			elseif v.type == RWData.Crucia.BlindDebuffID then
				if RWConfig.Crucia.ShowBlinded then 
					print(player.name .. RWRoot.locTxt.Crucia.isBlinded) 
					RWRoot.Crucia.nbBlinded = RWRoot.Crucia.nbBlinded + 1				
				end
				
			end
			
		end		
	end
  
end


-- Buffs Removed handler

local function BuffsRemoved(handle, id, buffs)
  
	for k in pairs(buffs) do
	
		if DebuffActive[k] then
			DebuffRaidFrame.Mask[DebuffActive[k]]:SetVisible(false)
			DebuffActive[k] = nil
			RWRoot.Crucia.DispelNeeded = RWRoot.Crucia.DispelNeeded - 1
			if RWRoot.Crucia.DispelNeeded <= 0 then InitDispelWarning() end
		
		elseif RWRoot.Crucia.MCFound == k then 
			InitMCFree() 
		
		end
	end
  
end


-- Executed every frame

local function Update(handle)

	local CurrentTime = Inspect.Time.Frame()
	
	-- Blind Message active?
	if RWRoot.Crucia.BlindTimer ~= 0 then 
		local remaining = RWRoot.Crucia.BlindTimer - CurrentTime
		if remaining <= 0 then
			InitBlindWarning()
		else
			if (remaining <= RWConfig.Crucia.WBlindNowTime) and (not RWRoot.Crucia.BlindColorChanged) then
				RWRoot.Crucia.BlindColorChanged = true
				WBlind:SetFontColor(RWConfig.Crucia.WBlindNowColor.r, RWConfig.Crucia.WBlindNowColor.g, RWConfig.Crucia.WBlindNowColor.b)
			end
			WBlind:FlashText()
		end
	elseif RWConfig.Crucia.ShowBlinded and (RWRoot.Crucia.BlindCheckTimer ~= 0) then
		if RWRoot.Crucia.BlindCheckTimer < CurrentTime then
			RWRoot.Crucia.BlindCheckTimer = 0
			if RWRoot.Crucia.nbBlinded == 0 then
				print(RWData.Crucia.NoBlindedMessage)
			else
				print( string.format(RWData.Crucia.BlindedFoundMessage, RWRoot.Crucia.nbBlinded) )
			end	
		end
	end
	
	-- Dispel needed?
	if RWRoot.Crucia.DispelNeeded > 0 then 
		WDispel:FlashText() 
	end
	
	-- Joueur MC?
	if RWRoot.Crucia.MCFound then
		WMC:FlashText()
	end

	if RWRoot.Crucia.MCTimer ~= 0 then 
		if (RWRoot.Crucia.MCTimer - CurrentTime) <= 0 then
			RWRoot.Crucia.MCTimer = 0
			WMC:VisibleTo(false)
		end
	end
	
end


-- Combat ends

local function EndEncounter()

	RWRoot.UpdateHandler = nil
	RWRoot.ChatNotifyHandler = nil
	RWRoot.BuffsAddedHandler = nil
	RWRoot.BuffsRemovedHandler = nil
	RWRoot.EndCombatHandler = nil
	
	InitData()
	
	print(RWRoot.locTxt.CombatEnds)
end


local function EndCombat()

	EndEncounter()
end


-- Start Encounter functions

local function InitEncounter()

	print(RWRoot.locTxt.Crucia.CombatStarted)
	print(RWRoot.locTxt.GoodLuck)

	InitAddon()

	RWRoot.Crucia.EncounterActive = true
	
	RWRoot.Crucia.RaidFrameConf = 0
	WDispel:TextTo(RWConfig.Crucia.WDispelNegatedText)
	DebuffRaidFrame:SetColor(RWConfig.Crucia.NegatedMaskColor.r, RWConfig.Crucia.NegatedMaskColor.g, RWConfig.Crucia.NegatedMaskColor.b, RWConfig.Crucia.NegatedMaskColor.a)

	RWRoot.UpdateHandler = Update
	RWRoot.ChatNotifyHandler = EventChatNotify
	RWRoot.BuffsAddedHandler = BuffsAdded
	RWRoot.BuffsRemovedHandler = BuffsRemoved
	RWRoot.EndCombatHandler = EndCombat
end



-- Combat starts handler
function RWRoot.Crucia.StartCombat()

	InitEncounter()	
end


-- Activate/Desactivate -----------------------------------------------------------

-- Activate
function RWRoot.Crucia.Activate()
	if not RWConfig.Crucia.Active then
	
	RWConfig.Crucia.Active = true
	print (RWRoot.locTxt.Crucia.ModActivated)
	
	end
end

-- Desactivate
function RWRoot.Crucia.Desactivate()
	if RWConfig.Crucia.Active then
	
	RWConfig.Crucia.Active = false
	print (RWRoot.locTxt.Crucia.ModDesactivated)
	
	if RWRoot.Crucia.EncounterActive then EndEncounter() end
	
	end
end

