-------------------------------------------------
--                                             --
--                 Matriarche                  --
--                                             --
--    Set of warnings to ease the encoutner     --
--                                              --
-------------------------------------------------


-- Variables -----------------------------------------------------------

RWConfig.Matriarche = {
	Active = true,

	InfectTextColor = { r = 0.8, g = 0.1, b = 1.0, a = 1.0 },
	InfectFrameColor = { r = 0.8, g = 0.1, b = 1.0, a = 0.3 },
	InfectDoneColor = { r = 0.1, g = 1.0, b = 0.1, a = 1.0 },
	
	SporeTextColor = { r = 0.8, g = 0.6, b = 0.25, a = 1.0 },
	SporeFrameColor = { r = 0.8, g = 0.5, b = 0.2, a = 0.4 },
	SporeDoneColor = { r = 0.1, g = 1.0, b = 0.1, a = 1.0 },
	
	GreenTime = 1,

	DevoreurTextColor = { r = 1.0, g = 0.1, b = 0.1, a = 1.0 },
	
	DSpawnTextColor = { r = 0.8, g = 0.8, b = 0.1, a = 1.0 },
	DSpawnNowTextColor = { r = 1.0, g = 0.1, b = 0.1, a = 1.0 },
	DSpawnFrameColor = { r = 0.1, g = 0.1, b = 1.0, a = 0.3 },
	DSpawnIntroTime = 20 - 3,
	DSpawnWarningTime = 4,
	
	ChildTextColor = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
	
	MissedKickTTL = 4,
	MaxETTL = 6		
}

RWData.Matriarche = {

	InfectText = RWRoot.locTxt.Matriarche.InfectText,
	InfectDoneText = RWRoot.locTxt.Matriarche.InfectDoneText,
	SporeText = RWRoot.locTxt.Matriarche.SporeText,
	SporeDoneText = RWRoot.locTxt.Matriarche.SporeDoneText,

	DevoreurText = RWRoot.locTxt.Matriarche.DevoreurText,
	DSpawnText = RWRoot.locTxt.Matriarche.DSpawnText,
	ChildText = RWRoot.locTxt.Matriarche.ChildText,

	MissInterruptText = RWRoot.locTxt.Matriarche.MissInterruptText,
	SelfHealText = RWRoot.locTxt.Matriarche.SelfHealText,

	ZoneName = RWRoot.locTxt.Matriarche.ZoneName,
	MatriarcheName = RWRoot.locTxt.Matriarche.MatriarcheName,
	
	ChildSpawn = RWRoot.locTxt.Matriarche.ChildSpawn,
	
	ChildName = RWRoot.locTxt.Matriarche.ChildName,
	DevoreurName = RWRoot.locTxt.Matriarche.DevoreurName,
	
	InterruptSpell = RWRoot.locTxt.Matriarche.InterruptSpell,
	MaxEnergySpell = RWRoot.locTxt.Matriarche.MaxEnergySpell,
	
	InfectDebuffID = "BFCA0D417422934A3", -- Infection volatile
	SporeDebuffID = "BFA79924F81628DB5", -- Spore nécrotiques
	TourmentDebuffID = "B37919B37A85C43F9", -- Tourmente
	
	--InfectDebuffID = "BFD8E0560046EF0F5", -- arumre d'anathema
	--SporeDebuffID = "BFE2D5BD9CD53C727", -- puissance de Neddra
	--InfectDebuffID = "B07517B5538C2C8D3", -- Egide d'arcane
	--SporeDebuffID = "BFDEA53519837425E", -- Vigeur partagée
	--TourmentDebuffID = "B40B9609C0DF37AF1", -- bombe volcanique
	
}

RWRoot.Matriarche = {

	EncounterActive = false,
	
	SporeTimer = 0,
	InfectTimer = 0,
	SporeGreenTimer = 0,
	InfectGreenTimer = 0,
	
	nbChild = 0,
	nbDevoreur = 0,
	TotalChild = 0,
	TotalDevoreur = 0,
	
	DSpawnTimer = 0,
	DSpawnPhase = 0,
	
	nbMissedKick = 0,
	MissedCheckTime = 0,
	nbMaxEnergy = 0,
	MaxECheckTime = 0,
	TotalSelfHeal = 0
}

local DebuffActive = {}

-- Warnings Messages
local WInfect = nil
local WSpore = nil
local WDevoreur = nil
local WDSpawn = nil
local WChild = nil
-- RaidFrame Mask
local SporeRaidFrame = nil
local DSpawnRaidFrame = nil
local InfectFrame = nil


-- Init functions -----------------------------------------------------------

-- DSpawn
local function InitDSpawnWarning()
	RWRoot.Matriarche.DSpawnPhase = 0
	WDSpawn:SetFontColor(RWConfig.Matriarche.DSpawnTextColor.r, RWConfig.Matriarche.DSpawnTextColor.g, RWConfig.Matriarche.DSpawnTextColor.b)
end

local function InitDSpawnDone()
	RWRoot.Matriarche.DSpawnTimer = 0
	WDSpawn:VisibleTo(false)
end

-- Spore
local function InitSporeWarning()
	RWRoot.Matriarche.SporeGreenTimer = 0
	WSpore:SetFontColor(RWConfig.Matriarche.SporeTextColor.r, RWConfig.Matriarche.SporeTextColor.g, RWConfig.Matriarche.SporeTextColor.b)
end

local function InitSporeDone()
	RWRoot.Matriarche.SporeGreenTimer = Inspect.Time.Frame() + RWConfig.Matriarche.GreenTime
	RWRoot.Matriarche.SporeTimer = 0
	WSpore:TextTo(RWData.Matriarche.SporeDoneText)
	WSpore:SetFontColor(RWConfig.Matriarche.SporeDoneColor.r, RWConfig.Matriarche.SporeDoneColor.g, RWConfig.Matriarche.SporeDoneColor.b)
	WSpore:VisibleTo(true)
end

-- Infect
local function InitInfectWarning()
	RWRoot.Matriarche.InfectGreenTimer = 0
	WInfect:SetFontColor(RWConfig.Matriarche.InfectTextColor.r, RWConfig.Matriarche.InfectTextColor.g, RWConfig.Matriarche.InfectTextColor.b)
end

local function InitInfectDone()
	RWRoot.Matriarche.InfectGreenTimer = Inspect.Time.Frame() + RWConfig.Matriarche.GreenTime
	RWRoot.Matriarche.InfectTimer = 0
	WInfect:TextTo(RWData.Matriarche.InfectDoneText)
	WInfect:SetFontColor(RWConfig.Matriarche.InfectDoneColor.r, RWConfig.Matriarche.InfectDoneColor.g, RWConfig.Matriarche.InfectDoneColor.b)
	WInfect:VisibleTo(true)
end

-- Init all
local function InitData()
	
	DebuffActive = {}

	RWRoot.Matriarche.EncounterActive = false
	
	RWRoot.Matriarche.SporeTimer = 0
	RWRoot.Matriarche.InfectTimer = 0
	RWRoot.Matriarche.SporeGreenTimer = 0
	RWRoot.Matriarche.InfectGreenTimer = 0

	RWRoot.Matriarche.nbChild = 0
	RWRoot.Matriarche.nbDevoreur = 0
	RWRoot.Matriarche.TotalChild = 0
	RWRoot.Matriarche.TotalDevoreur = 0
	
	RWRoot.Matriarche.DSpawnTimer = 0
	RWRoot.Matriarche.DSpawnPhase = 0
	
	RWRoot.Matriarche.nbMissedKick = 0
	RWRoot.Matriarche.MissedCheckTime = 0
	
	RWRoot.Matriarche.nbMaxEnergy = 0
	RWRoot.Matriarche.MaxECheckTime = 0
	RWRoot.Matriarche.TotalSelfHeal = 0
	
	InfectFrame:SetVisible(false)
	SporeRaidFrame:SetVisible(false)
	DSpawnRaidFrame:SetVisible(false)
	WInfect:VisibleTo(false)
	WSpore:VisibleTo(false)
	WDevoreur:VisibleTo(false)
	WDSpawn:VisibleTo(false)
	WChild:VisibleTo(false)
end


-- Initialize the addon

local function InitAddon()

	-- Warnings Messages
	WInfect = RWRoot.AssignRWText(1)
	WSpore = RWRoot.AssignRWText(2)
	WDevoreur = RWRoot.AssignRWText(3)
	WDSpawn = RWRoot.AssignRWText(4)
	WChild = RWRoot.AssignRWText(5)
	-- RaidFrame Mask
	DSpawnRaidFrame = RWRoot.AssignRWRaidMask(1, true)
	SporeRaidFrame = RWRoot.AssignRWRaidMask(2, true)
	InfectFrame = RWRoot.AssignRWMask(1, true)
	
	WDevoreur:SetFontColor(RWConfig.Matriarche.DevoreurTextColor.r, RWConfig.Matriarche.DevoreurTextColor.g, RWConfig.Matriarche.DevoreurTextColor.b)
	WChild:SetFontColor(RWConfig.Matriarche.ChildTextColor.r, RWConfig.Matriarche.ChildTextColor.g, RWConfig.Matriarche.ChildTextColor.b)
	
	InfectFrame:SetMaskColor(RWConfig.Matriarche.InfectFrameColor.r, RWConfig.Matriarche.InfectFrameColor.g, 
									RWConfig.Matriarche.InfectFrameColor.b, RWConfig.Matriarche.InfectFrameColor.a)
									
	SporeRaidFrame:SetColor(RWConfig.Matriarche.SporeFrameColor.r, RWConfig.Matriarche.SporeFrameColor.g, 
									RWConfig.Matriarche.SporeFrameColor.b, RWConfig.Matriarche.SporeFrameColor.a)

	DSpawnRaidFrame:SetColor(RWConfig.Matriarche.DSpawnFrameColor.r, RWConfig.Matriarche.DSpawnFrameColor.g, 
									RWConfig.Matriarche.DSpawnFrameColor.b, RWConfig.Matriarche.DSpawnFrameColor.a)
									
	-- Init the rest of the Data	
	InitData()

end


-- Handlers -----------------------------------------------------------


local function EventChatNpc(handle, info)

	if info.message == RWData.Matriarche.ChildSpawn then
		RWRoot.Matriarche.nbChild = RWRoot.Matriarche.nbChild + 1
		RWRoot.Matriarche.TotalChild = RWRoot.Matriarche.TotalChild + 1
		WChild:TextTo( string.format( RWData.Matriarche.ChildText, RWRoot.Matriarche.nbChild) )
		if RWRoot.Matriarche.nbChild == 1 then WChild:VisibleTo(true) end	
	end
end

local function EventCombatDeath(handle, info)

	if info.targetName == RWData.Matriarche.ChildName then
		RWRoot.Matriarche.nbChild = RWRoot.Matriarche.nbChild - 1
		if RWRoot.Matriarche.nbChild == 0 then WChild:VisibleTo(false) return end
		WChild:TextTo( string.format( RWData.Matriarche.ChildText, RWRoot.Matriarche.nbChild) )
	
	elseif info.targetName == RWData.Matriarche.DevoreurName then
		RWRoot.Matriarche.nbDevoreur = RWRoot.Matriarche.nbDevoreur - 1
		if RWRoot.Matriarche.nbDevoreur == 0 then WDevoreur:VisibleTo(false) return end
		WDevoreur:TextTo( string.format( RWData.Matriarche.DevoreurText, RWRoot.Matriarche.nbDevoreur) )		
	
	end
end

-- Combat damage handler
local function EventCombatDamage(handle, info)

	if info.abilityName == RWData.Matriarche.InterruptSpell then
		local CurrentTime = Inspect.Time.Frame()
		if CurrentTime > RWRoot.Matriarche.MissedCheckTime then
			RWRoot.Matriarche.MissedCheckTime = CurrentTime + RWConfig.Matriarche.MissedKickTTL
			RWRoot.Matriarche.nbMissedKick = RWRoot.Matriarche.nbMissedKick + 1
			print(RWData.Matriarche.MissInterruptText)
		end
	
	elseif info.abilityName == RWData.Matriarche.MaxEnergySpell then
		local CurrentTime = Inspect.Time.Frame()
		if CurrentTime > RWRoot.Matriarche.MaxECheckTime then
			RWRoot.Matriarche.MaxECheckTime = CurrentTime + RWConfig.Matriarche.MaxETTL
			RWRoot.Matriarche.nbMaxEnergy = RWRoot.Matriarche.nbMaxEnergy + 1
		end
		
	end
end

-- Combat heal handler
local function EventCombatHeal(handle, info)

	if info.targetName == RWData.Matriarche.MatriarcheName then
		local heal = info.heal / 1000
		RWRoot.Matriarche.TotalSelfHeal = RWRoot.Matriarche.TotalSelfHeal + heal
		print(string.format( RWData.Matriarche.SelfHealText, math.floor(heal) ))
	end
end

-- Buff Added handler

local function BuffsAdded(handle, id, buffs)

	local player = Inspect.Unit.Detail(id)
	if player.relation == "hostile" then return end
	
	local CurrentTime = Inspect.Time.Frame()
	local PBuffs = Inspect.Buff.Detail(id, buffs)

	for k, v in pairs(PBuffs) do
		if v.debuff then
		
			-- Spore?
			if v.type == RWData.Matriarche.SporeDebuffID then
				if not DebuffActive[k] then	
					local i, posInGroup = RWRoot.GetPlayerPos(player.name)
					if i then
						local r = CurrentTime + v.remaining
						if id == RWRoot.playerId then 
							RWRoot.Matriarche.SporeTimer = r
							InitSporeWarning()
						end
						
						local n = SporeRaidFrame:Highlight(i, posInGroup)
						SporeRaidFrame.Mask[n].Timer = r
						DebuffActive[k] = n
					end
				end
				
			-- Tourmente?
			elseif v.type == RWData.Matriarche.TourmentDebuffID then
				if not DebuffActive[k] then	
					local i, posInGroup = RWRoot.GetPlayerPos(player.name)
					if i then
						local r = CurrentTime + v.remaining
						if id == RWRoot.playerId then 
							RWRoot.Matriarche.DSpawnTimer = r
							InitDSpawnWarning()
						end
						
						local n = DSpawnRaidFrame:Highlight(i, posInGroup)
						DSpawnRaidFrame.Mask[n].Timer = r
						DebuffActive[k] = n + 32
					end
				end
				
			-- Infection?
			elseif v.type == RWData.Matriarche.InfectDebuffID then
				if not DebuffActive[k] then
					if id == RWRoot.playerId then 
						RWRoot.Matriarche.InfectTimer = Inspect.Time.Frame() + v.remaining
						InitInfectWarning()
					end
					
					DebuffActive[k] = 64
					InfectFrame.Timer = CurrentTime + v.remaining
					InfectFrame:SetCoordTo(player.name)				
				end				
				
			end
			
		end		
	end
  
end


-- Buffs Removed handler

local function BuffsRemoved(handle, id, buffs)
  
	for k in pairs(buffs) do
	
		if DebuffActive[k] then

			-- spore?
			if DebuffActive[k] < 32 then
				SporeRaidFrame.Mask[DebuffActive[k]]:SetVisible(false)
				DebuffActive[k] = nil
				if id == RWRoot.playerId then InitSporeDone() end

			else
				local i = bit.band(DebuffActive[k], 0xE0)
				local v = bit.band(DebuffActive[k], 0x1F)
						
				-- Tourmente?
				if i == 32 then
					DSpawnRaidFrame.Mask[v]:SetVisible(false)
					DebuffActive[k] = nil
					RWRoot.Matriarche.nbDevoreur = RWRoot.Matriarche.nbDevoreur + 1
					RWRoot.Matriarche.TotalDevoreur = RWRoot.Matriarche.TotalDevoreur + 1
					WDevoreur:TextTo( string.format( RWData.Matriarche.DevoreurText, RWRoot.Matriarche.nbDevoreur) )
					if RWRoot.Matriarche.nbDevoreur == 1 then WDevoreur:VisibleTo(true) end
					if id == RWRoot.playerId then InitDSpawnDone() end

				else --if i == 64 then -- Infection!
					InfectFrame:SetVisible(false)
					DebuffActive[k] = nil
					if id == RWRoot.playerId then InitInfectDone() end
				
				end			
			end		
		end
	end
  
end


-- Executed every frame

local function Update(handle)

	local CurrentTime = Inspect.Time.Frame()
	
	-- Spore Message active?
	if RWRoot.Matriarche.SporeTimer ~= 0 then 
		local remaining = RWRoot.Matriarche.SporeTimer - CurrentTime
		WSpore:TextTo(string.format(RWData.Matriarche.SporeText, math.floor(remaining)))
		WSpore:FlashText()
		
	elseif RWRoot.Matriarche.SporeGreenTimer ~= 0 then
		if RWRoot.Matriarche.SporeGreenTimer < CurrentTime then
			RWRoot.Matriarche.SporeGreenTimer = 0
			WSpore:VisibleTo(false)
		end
	end
		
	-- Infect Message active?
	if RWRoot.Matriarche.InfectTimer ~= 0 then 
		local remaining = RWRoot.Matriarche.InfectTimer - CurrentTime
		WInfect:TextTo(string.format(RWData.Matriarche.InfectText, math.floor(remaining)))
		WInfect:FlashText()
		
	elseif RWRoot.Matriarche.InfectGreenTimer ~= 0 then
		if RWRoot.Matriarche.InfectGreenTimer < CurrentTime then
			RWRoot.Matriarche.InfectGreenTimer = 0
			WInfect:VisibleTo(false)
		end
	end

	-- DSpawn Message active?
	if RWRoot.Matriarche.DSpawnTimer ~= 0 then 
		local r = RWRoot.Matriarche.DSpawnTimer - CurrentTime
		WDSpawn:TextTo(string.format(RWData.Matriarche.DSpawnText, math.floor(r)))
		
		if r > RWConfig.Matriarche.DSpawnIntroTime then
			WDSpawn:FlashText()
		
		elseif r > RWConfig.Matriarche.DSpawnWarningTime then
			if RWRoot.Matriarche.DSpawnPhase ~= 1 then
				RWRoot.Matriarche.DSpawnPhase = 1
				WDSpawn:VisibleTo(true)
			end
			
		else 
			if RWRoot.Matriarche.DSpawnPhase ~= 2 then
				RWRoot.Matriarche.DSpawnPhase = 2
				WDSpawn:SetFontColor(RWConfig.Matriarche.DSpawnNowTextColor.r, RWConfig.Matriarche.DSpawnNowTextColor.g, RWConfig.Matriarche.DSpawnNowTextColor.b)
			end
			WDSpawn:FlashText()

		end	
	end	
	
	-- Devoreur alive?
	if RWRoot.Matriarche.nbDevoreur > 0 then 
		WDevoreur:FlashText()
	end
	
	-- refresh Frame timers
	SporeRaidFrame:UpdateTimers()
	DSpawnRaidFrame:UpdateTimers()
	InfectFrame:UpdateTimer()

end



-- Combat ends

local function ShowReport()
	print(RWRoot.locTxt.Matriarche.CombatReport)
	print(RWRoot.locTxt.Matriarche.repMissedKick .. tostring(RWRoot.Matriarche.nbMissedKick))
	print(string.format(RWRoot.locTxt.Matriarche.repNbMaxEnergy, RWRoot.Matriarche.nbMaxEnergy))
	print(string.format(RWRoot.locTxt.Matriarche.repSelfHeal, math.floor(RWRoot.Matriarche.TotalSelfHeal)))
	print(string.format(RWRoot.locTxt.Matriarche.repAddPopData, RWRoot.Matriarche.TotalDevoreur, RWRoot.Matriarche.TotalChild, RWRoot.Matriarche.TotalDevoreur+RWRoot.Matriarche.TotalChild))		
end

local function EndEncounter()

	RWRoot.UpdateHandler = nil
	RWRoot.BuffsAddedHandler = nil
	RWRoot.BuffsRemovedHandler = nil
	RWRoot.ChatNpcHandler = nil
	RWRoot.CombatDeathHandler = nil
	RWRoot.CombatDamageHandler = nil
	RWRoot.EndCombatHandler = nil
		
	ShowReport()
	print(RWRoot.locTxt.CombatEnds)

	InitData()
end

local function EndCombat()

	EndEncounter()
end

-- Start Encounter functions
local function InitEncounter()
	
	print(RWRoot.locTxt.Matriarche.CombatStarted)
	print(RWRoot.locTxt.GoodLuck)

	InitAddon()

	RWRoot.Matriarche.EncounterActive = true	
	
	RWRoot.UpdateHandler = Update
	RWRoot.BuffsAddedHandler = BuffsAdded
	RWRoot.BuffsRemovedHandler = BuffsRemoved
	RWRoot.ChatNpcHandler = EventChatNpc
	RWRoot.CombatDeathHandler = EventCombatDeath
	RWRoot.CombatDamageHandler = EventCombatDamage
	RWRoot.EndCombatHandler = EndCombat
end

function RWRoot.Matriarche.StartCombat()

	InitEncounter()

end



-- Activate/Desactivate -----------------------------------------------------------

-- Activate
function RWRoot.Matriarche.Activate()
	if not RWConfig.Matriarche.Active then
	
	RWConfig.Matriarche.Active = true
	print (RWRoot.locTxt.Matriarche.ModActivated)
	
	end
end

-- Desactivate
function RWRoot.Matriarche.Desactivate()
	if RWConfig.Matriarche.Active then
	
	RWConfig.Matriarche.Active = false
	print (RWRoot.locTxt.Matriarche.ModDesactivated)
	
	if RWRoot.Matriarche.EncounterActive then EndEncounter() end
	
	end
end

