--------------------------------------------------
--                                              --
--                    Hestia                    --
--              The patron Goddess              --
--                                              --
--    Check that your sacred fire never ends    --
--           (check your consumables!)          --
--                                              --
--------------------------------------------------

-- TODO:
-- fill the Data.BuffList table (scan all needed ID)
-- Help window
-- Male frame
-- small frame
-- resizing the frame
-- Enchant check
-- popup cast icon (to cast the spell)
-- scan optimisation! (new approach?)


-- Variables -----------------------------------------------------------

RWConfig.Hestia = {

	Active = false,
	
	Location = { x = 100, y = 100 },

	Scale = 1.0,

	DataOffColor = { 0.7, 0.7, 0.7, 1.0 },
	RaidGreenColor = { 0.1, 0.7, 0.1, 1.0 },
	SelfGreenColor = { 0.1, 0.9, 0.1, 1.0 },
	WarningColor = { 0.9, 0.3, 0.3, 1.0 },

	WalkMsgColor = { 0.1, 0.9, 0.1, 1.0 },
	NoWalkMsgColor = { 0.9, 0.1, 0.1, 1.0 },
	WarningMsgColor = { 0.9, 0.1, 0.1, 1.0 },
	
	ActiveIcon = {
		Cool = {
			self = {
				true,	false,	false,	true,	false,	false,	false,	false,
				false,	false,	true,	false,	false,	false,	false,	false
			},
			raid = {
				false,	false,	false,	true,	false,	false,	false,	false,
				false,	false,	true,	false,	false,	false,	false,	false
			}
		},
		Opti = {
			self = {
				true,	true,	true,	true,	false,	false,	false,	false,
				false,	false,	true,	true,	false,	false,	false,	false
			},
			raid = {
				false,	true,	true,	true,	false,	false,	false,	false,
				false,	false,	true,	true,	false,	false,	false,	false
			}
		}		
	},
	
	VitalityWarnLimit = 30,
	LongBuffWarnLimit = 8*60,
	ShortBuffWarnLimit = 3*60,
	PotionWarnLimit = 10,
	BagWarnLimit = 10,
	
	DoMedicWarning = true,
	DoFoodWarning = true,

	Mode = "Cool",
	autoOn = true,
	OffMode = false,
	ledState = 3,
	
	autoSwitchCfg = 2,			-- 1-group, 2-raid10, 3-raid20
	ReactivateCondition = 2,	-- 1-in 5min, 2-ready check, 3-next combat, 4-desactivate
	onHoldonAuto = true,
	CoolJoinReact = true,
	SoloFightReact = true,
	onHoldonSolo = true,
	
	PSpellWarnOnly = true,
	WarnIfNotFull = true,
	ShowSessionReport = false,
	DontCloseOnFight = false,
	
	DoRaidScan = false,
	FrameSkip = 3	
}

RWConst.Hestia = {

	msgOff = RWRoot.locTxt.Hestia.Off,
	msgReady = RWRoot.locTxt.Hestia.Ready,

	RaidCheckPerFrame = 1,
	BagFastCheck = 10,	
	BagSlowCheck = 2,	
	
	MedicTime = 20,
	FoodTime = 20,
	FestinMinWarnTime = 27*60,
	FoodStartTTL = 5,
	FoodStatUpdateTTL = 120,
	NotFullWarnTime = 30,
	PSpellGCDTTL = 4,
	GroupJoinTTL = 20,
	BattleTimeTTL = 3,
	LongFightTime = 120,
	noSoloFightTTL = 30*60,

	ClassGroup = {
		mage = "MageCleric",
		cleric = "MageCleric",
		warrior = "WarRogue",
		rogue = "WarRogue"
	},

	IconSlot = {
		Planar 		= 1,
		Elixir 		= 2,
		Food 		= 3,
		MainHand 	= 4,
		Gloves		= 5,
		Feet		= 6,
		PGraine		= 7,
		PTablette	= 8,
		PRune		= 9,
		ShadowWalk	= 10,
		SoulHealth	= 11,
		OffHand		= 12,
		Mount		= 13,
		HealthPtn	= 14,
		ManaPtn		= 15,
		BagSlot		= 16,
		TankMain	= 4,
		TOffhand	= 12
	},
	ledState = {
		SelfWarn = 1,
		RaidWarn = 2,
		Green = 3,
		OnHold = 4,
		Off	= 5,
	},
	FrameStatus = {
		Nothing = 0,
		inCombat = 1,
		MemberLost = 2,
		RaidLost = 3,
		DeadInRead = 4,
		Loading = 5
	},
	
	ShowRaidData = {
		true,	true,	true,	true,	true,	true,	true,	true,
		true,	false,	true,	true,	true,	false,	false,	false	
	},
	CanActiveRaid = {
		false,	true,	true,	true,	true,	true,	true,	true,
		true,	false,	true,	true,	true,	false,	false,	false	
	},

	FrameData = {
		TotalIcon = 16,
		TotalBtn = 4,
		TotalFrameBtn = 8,
		LastBigBtnIndex = 6,
		
		DataTextSize = 16,
		InfoTextSize = 16,
		InfoMinSize = 10,
	
		InfoFrameBackColor = { 0, 0, 0, 0.7 },
	
		btnWidth = 50,
		btnHeight = 21,
		bigBtnSize = 34,
		smallBtnSize = 24,
		IconSize = 44,
		DataWidth = 44,
		DataHeight = 20,
		DataDY = 24,
		InfoFrameX0 = 5,
		InfoFrameY0 = 2,
		
		btnPath = {
			"Resources\\Hestia\\btnAuto.png",
			"Resources\\Hestia\\btnOpti.png",
			"Resources\\Hestia\\btnCool.png",
			"Resources\\Hestia\\btnOff.png"
		},
		ledPath = {
			"Resources\\Hestia\\LRed.png",
			"Resources\\Hestia\\LOrange.png",
			"Resources\\Hestia\\LGreen.png",
			"Resources\\Hestia\\LYellow.png"		
		},
		IconDefault = {
			{ID = "Hermes", Path = "Resources\\Hestia\\IconPlanarCharge.png"},
			{ID = "BFA86D7A4886FCED5", Path = "Data/\\UI\\item_icons\\epic_potion_cylindrical_3.dds"},
			{ID = "B0A0A47828BC4BC5E", Path = "Data/\\UI\\item_icons\\food_8.dds"},
			{ID = "r3A5D56170B3171F5", Path = "Data/\\UI\\item_icons\\spellstone_03_a.dds"},
			{ID = "r7CBC6A1B6F0FA6B8", Path = "Data/\\UI\\item_icons\\grips_02_a.dds"},
			{ID = "r3BD9C00A2128287F", Path = "Data/\\UI\\item_icons\\insoles_04_b.dds"},
			{ID = "BFE99BE5C86F00017", Path = "Data/\\UI\\item_icons\\rift_consumable_life_05.dds"},
			{ID = "BFC9090B041EDC6D8", Path = "Data/\\UI\\item_icons\\rift_consumable_water_05.dds"},
			{ID = "BFB6C4912575535FC", Path = "Data/\\UI\\item_icons\\rift_consumable_earth_05.dds"},
			{ID = "10", Path = "Data/\\UI\\item_icons\\"},
			{ID = "Hermes", Path = "Resources\\Hestia\\IconSoulHealth.png"},
			{ID = "r475DBE8E7EACE1D1", Path = "Data/\\UI\\item_icons\\manastone_04_a.dds"},
			{ID = "r5CA82CE601097767", Path = "Data/\\UI\\item_icons\\chaps_04.dds"},
			{ID = "Rift", Path = "Data/\\UI\\item_icons\\major_potion_rectangular_1.dds"},
			{ID = "Rift", Path = "Data/\\UI\\item_icons\\major_potion_rectangular_6.dds"},
			{ID = "Rift", Path = "Data/\\UI\\item_icons\\bag20.dds"}
		},
		WarnIconPath = {
			self = "Resources\\Hestia\\WSelfIcon.png",
			raid = "Resources\\Hestia\\WRaidIcon.png"
		},
		StateIconPath = {
			"Resources\\Hestia\\CombatIcon.png",
			"Resources\\Hestia\\SomeRaidMissIcon.png",
			"Resources\\Hestia\\NoRaidScanIcon.png",
			"Resources\\Hestia\\Tombstone-icon.png",
			"Resources\\Hestia\\stLoading.png"			
		},
		
		Female = {
			FramePath = "Resources\\Hestia\\FemaleFrame.jpg",
			height = 470,
			width = 401,
			btnCoord = {
				{70, 442},	-- 1-auto
				{126, 442},	-- 2-Opti
				{182, 442},	-- 3-Cool
				{238, 442},	-- 4-Off
				{360, 6},	-- 5-X
				{352, 77},	-- 6-led
				{372, 44},	-- 7-Config
				{347, 44}	-- 8-Help
			},
			Icon = {
				{Coord = {9, 9}, DataCoord = {77, 19}},			-- 01-Planar
				{Coord = {56, 117}, DataCoord = {30, 127}},		-- 02-Elixir
				{Coord = {56, 168},	DataCoord = {30, 178}},		-- 03-Food
				{Coord = {56, 220},	DataCoord = {30, 230}},		-- 04-Main Hand
				{Coord = {56, 320},	DataCoord = {30, 330}},		-- 05-Gloves
				{Coord = {56, 376},	DataCoord = {30, 386}},		-- 06-Feet
				{Coord = {125, 55},	DataCoord = {146, 19}},		-- 07-Planar Graine du renouveau
				{Coord = {172, 55},	DataCoord = {193, 19}},		-- 08-Planar Tablette archaique
				{Coord = {219, 55},	DataCoord = {240, 19}},		-- 09-Planar Rune petrifiée
				{Coord = {300, 8}, DataCoord = {321, 64}},		-- 10-Shadow walk
				{Coord = {300, 117}, DataCoord = {368, 127}},	-- 11-Soul Health
				{Coord = {301, 218}, DataCoord = {369, 228}},	-- 12-Off hand
				{Coord = {301, 268}, DataCoord = {369, 278}},	-- 13-Mount
				{Coord = {300, 317}, DataCoord = {322, 374}},	-- 14-Health potions
				{Coord = {347, 317}, DataCoord = {369, 374}},	-- 15-Mana potions
				{Coord = {347, 387}, DataCoord = {369, 444}}	-- 16-Bag slots
			},
			StateIcon = {294, 440}
		},
		Male = {		
		
		}, 
		Small = {
		
		}
	},	
	
	SelfWarnMsg = RWRoot.locTxt.Hestia.SelfWarnMsg,
	RaidWarnMsg = RWRoot.locTxt.Hestia.RaidWarnMsg,
	
	AutoMsg = {
		Opti = RWRoot.locTxt.Hestia.AutoSwitchOpti,
		Cool = RWRoot.locTxt.Hestia.AutoSwitchCool
	},
	ReactCondMsg = RWRoot.locTxt.Hestia.reactCondition,
	
	SessionReportLine = RWRoot.locTxt.Hestia.repBuffLine
	
}
--RWConst.Hestia.FrameData.TotalIcon = #RWConst.Hestia.FrameData.Female.Icon

-- Icon registration:
--	TotalIcon in RWConst.Hestia.FrameData
--	Static data:
--		Icon {Coord, DataCoord} in RWConst.Hestia.FrameData {Female, Male}
--		SelfWarnMsg, RaidWarnMsg in RWConst.Hestia
--		IconDefault {ID, Path} in RWConst.Hestia.FrameData
--		IconSlot in RWConst.Hestia
--		ShowRaidData, CanActiveRaid in RWConst.Hestia
--		CanBeActivated in RWRoot.Hestia
--		SelfCheckFunction, SelfNoUpdateFunction, RaidCheckFunction, RaidNoUpdateFunction buff handlers
--	Dynamic data:
--		ActiveIcon {Cool, Opti} {self, raid} in RWConfig.Hestia
--	Temporary data:
-- 		IconNeedUpdate used in function RWRoot.Hestia.Update()


RWData.Hestia = {
	
	SLPSpellIDNew 	= "A798550D8AF79AEFC",	-- Sacrifice de vie: Charge planaire
	
	PlanarSpellID = {
		"A43208D51B719197B",	-- Graine du renouveau
		"A380335F647FF73DD",	-- Tablette archaique
		"A26BB9B197E0F382A"		-- Rune petrifiée
	},
	PlanarSpellBuffID = {
		B34270C2D381E7F35 = "PTablette",	-- Tablette archaique, +60 sagesse/force (spell)
		B3855E38EC2578847 = "PRune", 		-- Rune petrifiée, +60 intel/dex (spell)
		B5CB095134CDDC4C1 = "PGraine" 		-- Graine du renouveau, +70 endu (spell)
	},
	
	WalkedBuffIDNew = "B68465D242F609512",	-- Marche des âmes
	WalkSpellIDNew 	= "A5EECF6A771DF52E9",	

	BuffList = {
		MageCleric = {
			Cool = {
				r61C14C434DDF615D = "MainHand",		-- sceau flamboyant 160 ps
				r7EB204B07078508D = "MainHand",		-- Pierre de sorciere de mercenaire (+600 degat si critique (sort))
				r73664BEA191E5FC2 = "OffHand",		-- Pierre de mana du mercenaire (+380 mana)
				r3C3161FA59C6ECF3 = "MainHand",		-- Sceau du vent (+60 sagesse) 

			},
	
			Opti = {
				r3A5D56170B3171F5 = "MainHand",		-- pierre de puissance luminescente, +200ps
				BFA86D7A4886FCED5 = "Elixir",		-- Fioles +50 intel/sagesse
				BFBD8A9BDCF3270E6 = "Elixir",		-- Fioles stellaires +55 intel/sagesse
				r475DBE8E7EACE1D1 = "OffHand",		-- sceau glacial 360 mana
				i054D000018125563 = "ManaPtn",		-- Potion de mana stellaire (lvl53)
				r3C3161FA59C6ECF3 = "TankMain",		-- Sceau du vent (+60 sagesse) 

			}
		},
		WarRogue = { -- buff tank? sur bouclier?
			Cool = {
				rFAAE2DA0756C6986 = "MainHand",		-- Pierre de combat du mercenaire (+600 degat si critique (physique))
				r0CAE4B8D4FCFDF0A = "MainHand",		-- Pierre a aiguiser du mercenaire (+100 vengence)
				r712EF6F7297AB9ED = "MainHand",		-- Sceau de tempete (+60 force)
				r0B48C387131E79A8 = "MainHand",		-- Sceau de foudre (+60 dexterité)
				r2FF8E88943EBC5AA = "MainHand",		-- Tanchant planaire, (+160 pa)
				rFBF770FC7EEEB915 = "MainHand",		-- Tanchant aigisé, (+80 pa)
				r4DC9EA70785C58C4 = "Gloves",		-- Garde d'arme, (harmo)

				--r6E62417B4895A639 = "MainHand",		-- ?
			},
	
			Opti = {
				r712EF6F7297AB9ED = "TankMain",		-- Sceau de tempete (+60 force)
				r0B48C387131E79A8 = "TankMain",		-- Sceau de foudre (+60 dexterité)
				BFAE680B5BBA2DB8E = "Elixir",		-- Fioles +50 force/dexterité
				BFF3177D56B3A82D6 = "Elixir",		-- Fioles stellaires +55 force/desxterité
				r5812508956871CF3 = "MainHand",		-- Pierre a aiguiser remarquable, +100pa
				r5E26E8C025B2C3BB = "MainHand",		-- Pierre d'huile remarquables, +200pa
			}		
		},
		All = {
			Cool = {
				B48C551A2ECEDB737 = "Food", 		-- vengence +41, PC +43, +975 pv (festin de vengence)
				r53908695527CACAB = "Mount",		-- Protege pantalon de mercenaire (+10%)
				rFA1390E570C6AFDD = "Feet",			-- Semelles de mercenaire (+10%)
				r2CB239FC6A74F88D = "MainHand",		-- Pierre de puissance du mercenaire (+200 vengence)
				r36E23CF74112D284 = "MainHand",		-- Essence vampirique, self heal!
				r48866ED901E28FED = "Gloves",		-- Poignes tres collantes, (-2s desarm)
				r0BBA6691632B040C = "Feet",			-- Semelles interieures de performance, (+5% mouvement)
				r4732534573B5542A = "Mount",		-- Protege pantalon leger (+5% vitesse)
	
			},
			Opti = {
				BFB84FF67D7824324 = "Elixir",		-- Fioles +55 endu
				B0A0A47828BC4BC5E = "Food", 		-- puissance +41, PC +43, +975 pv
				B0A0A478464C0BADE = "Food", 		-- puissance +41, PC +43, +975 pv
				r3BD9C00A2128287F = "Feet",			-- semelle confortables +10%	
				r7CBC6A1B6F0FA6B8 = "Gloves",		-- desarm reduit de 3s (pve)
				r3B802F2A6E26B6B4 = "Gloves",		-- bouclier d'arme, -1s desarm, +10 endurence
				r5CA82CE601097767 = "Mount",		-- Vitesse monture +10% (pve)

				BFB6C4912575535FC = "PRune", 		-- Rune petrifiée, +60 intel/dex
				B3855E38EC2578847 = "PRune", 		-- Rune petrifiée, +60 intel/dex (spell)
				BFC9090B041EDC6D8 = "PTablette",	-- Tablette archaique, +60 sagesse/force (consommable)
				B34270C2D381E7F35 = "PTablette",	-- Tablette archaique, +60 sagesse/force (spell)
				BFE99BE5C86F00017 = "PGraine", 		-- Graine du renouveau, +70 endu
				B5CB095134CDDC4C1 = "PGraine", 		-- Graine du renouveau, +70 endu (spell)
				
				r7D2E9A6369EEA0D9 = "TOffhand",		-- Piques terrestres, +80 degats aux attaquants en cas de degat
				--r41F696A45738BD77 = "OffHand",		-- pics barbelées
				
				i054D00001E7FA375 = "HealthPtn",	-- Potion de vie stellaire (lvl53)
			}				
		}		
	},
	
	Weapon2H = {
		r3A5D56170B3171F5 = true,		-- pierre de puissance luminescente, +200ps
		r61C14C434DDF615D = true,		-- sceau flamboyant 160 ps
		r5E26E8C025B2C3BB = true,		-- Pierre d'huile remarquables, +200pa
		r7EB204B07078508D = true,		-- Pierre de sorciere de mercenaire (+600 degat si critique (sort))
		rFAAE2DA0756C6986 = true,		-- Pierre de combat du mercenaire (+600 degat si critique (physique))
		r2CB239FC6A74F88D = true,		-- Pierre de puissance du mercenaire (+200 vengence)
		r2FF8E88943EBC5AA = true,		-- Tanchant planaire, +160 pa
		
	},
	FestinFood = {
		B0A0A47828BC4BC5E = true,		-- puissance +41, PC +43, +975 pv
		B0A0A478464C0BADE = true, 		-- puissance +41, PC +43, +975 pv
		B48C551A2ECEDB737 = true, 		-- vengence +41, PC +43, +975 pv (festin de vengence)
	
	}
	
}
MTools.AddNewFields( RWData.Hestia.BuffList.MageCleric.Opti, RWData.Hestia.BuffList.All.Opti )
MTools.AddNewFields( RWData.Hestia.BuffList.MageCleric.Cool, RWData.Hestia.BuffList.All.Cool )
MTools.AddNewFields( RWData.Hestia.BuffList.MageCleric.Cool, RWData.Hestia.BuffList.MageCleric.Opti )
MTools.AddNewFields( RWData.Hestia.BuffList.WarRogue.Opti, RWData.Hestia.BuffList.All.Opti )
MTools.AddNewFields( RWData.Hestia.BuffList.WarRogue.Cool, RWData.Hestia.BuffList.All.Cool )
MTools.AddNewFields( RWData.Hestia.BuffList.WarRogue.Cool, RWData.Hestia.BuffList.WarRogue.Opti )

local FrameCoord = {
	height = 0,
	width = 0,
	
	DataHeight = 20,
	DataWidth = 44,
	DataDY = 24,
	DataTextSize = 14,
	IconSize = 44,
	FontSize = 14,

	btnWidth = 50,
	btnHeight = 21,
	bigBtnSize = 34,
	smallBtnSize = 34,
	
	InfoTextSize = 14,
	InfoFrameHeight = 30,
	InfoFrameQHeight = 7,
	InfoFrameX0 = 5,
	InfoFrame2X = 10,
	InfoFrameY0 = 5,
	InfoFrame3Y = 6,
	InfoFontSize = 14,
	
	btnCoord = {},
	IconCoord = {},
	DataCoord = {},
	StateIcon = {}
}
for i = 1, RWConst.Hestia.FrameData.TotalFrameBtn do FrameCoord.btnCoord[i] = {} end
for i = 1, RWConst.Hestia.FrameData.TotalIcon do FrameCoord.IconCoord[i] = {} FrameCoord.DataCoord[i] = {} end

RWRoot.Hestia = {

	ConfigWindow = nil,
	Frame = nil,
	Update = nil,
	
	CanDoAction = {
		UseManaPotion = false,
		SLPlanar = false,						-- Sacrifice de vie: charge planaire
		PlanarSpell = {	false, false, false }	-- Planar buff spell (harmonisation)
	},	
	CanBeActivated = {
		true,	true,	true,	true,	true,	true,	true,	true,
		true,	false,	true,	true,	true,	true,	false,	true	
	},

	SessionReport = nil,
	
	FrameSkip = 3,
	
	MedicUp = false,
	MedicTimeLimit = 0,	
	FoodUp = false,
	FoodTimeLimit = 0,
	
	FestinUp = false,
	FestinTimeLimit = 0,
	
	SLPSpellUpTime = 0,
	PlanarSpellTime = { 0, 0, 0 },
	VitaWarnTimeLimit = 0,
	PlanarWarnTimeLimit = 0,
	NotFullVitaWarn = false,
	NorFullPlanarWarn = false,
	
	totalPlanar = 0,
	totalPlanarMax = 0,
	totalPlanar3 = 0,
	
	BuffTimeLimit = {},
	
	nbMembers = 0,
	DeathDetected = false,
	AllRaidDead = false,
	
	WalkedMember = "",
	SWalkTimeLimit = 0,
	
	Index = 1,
	BagIndex = 99,
	nBag = 0,
	CurrentBag = "",
	nBagSize = 0,
	
	BagCheckPerFrame = RWConst.Hestia.BagFastCheck,
	
	QueuedCheck = {},
	nbQueuedCheck = 0,
	
	MemberLost = {}
}

local FrameData = RWConst.Hestia.FrameData["Female"]

local SelfCheckFunction = {}
local RaidCheckFunction = {}
local SelfNoUpdateFunction = {}
local RaidNoUpdateFunction = {}
local BagCheckFunction = {}
local FrameBtnFunction = {}
local onHoldCheckFunction = {}
local onHoldInitFunction = {}
local UpdateFunction = {}

local IconNeedUpdate = {}
local doPlayerCheck = true
local ActualPlanar = 0
local ActualPlanarMax = 0
local ActualPlanar3 = 0
local nbMembers = 0
local ReadyCheckDetected = false
local ReadyCheckInProgress = false
local onHoldTimeLimit = 0
local DeathDetected = false
local AllRaidDead = false
local GroupState = 0
local PCheckList = nil
local MemberIndex = 0
local RaidChecked = false
local DoAutoCheck = true
local DoRaidScan = true
local MemberMissed = false
local MedicWarnDone = false
local FestinWarnDone = false
local scLoadingDetected = true
local DoGroupJoinWarn = RWConfig.Hestia.WarnIfNotFull
local SoloFightWarned = false
local InitSoloFightWarn = false
local InvalidateCycle = false

local HWarnMessage = nil
local NoWalkYet = true
local scScanAvailable = false
local FlashWarnText = false

local FreeBagSlot = 0
local nbHealthPotion = 0
local nbManaPotion = 0
local bgScanAvailable = false

local FPSIndex = 0

local SessionCombatStartTime = 0


-- Hestia Frame -------------------------------------------------------------

-- Frame Button object -----

local function buildFrameButton(parent, i)
	
	local Button = UI.CreateFrame("Texture", "HestiaButton", parent)
	
	Button.Index = i
	Button:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.btnPath[i])
	
	function Button.Event:LeftDown()
		if (self.Index >= 2) and (self.Index <= 3) and (RWConfig.Hestia.autoOn) then RWRoot.Hestia.SetAutoOff() end	
	end
	
	function Button:AdjustSize()
		self:SetWidth(FrameCoord.btnWidth)
		self:SetHeight(FrameCoord.btnHeight)
		MTools.ClearPoints(self)
		self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", unpack(FrameCoord.btnCoord[self.Index]))	
	end	
	
	Button:AdjustSize()
	
	return Button
end


-- Frame Icon Object -----

local function buildFrameIcon(parent, i)
	local Icon = UI.CreateFrame("Texture", "HestiaIcon", parent)
	
	Icon.SelfData = UI.CreateFrame("Text", "HestiaIconSelfText", parent)
	
	Icon.RaidAvailable = RWConst.Hestia.ShowRaidData[i]
	if RWConst.Hestia.ShowRaidData[i] then
		Icon.RaidData = UI.CreateFrame("Text", "HestiaIconRaidText", parent)
	
	end
	
	Icon.ID = ""	
	Icon.Index = i
	Icon.source = ""
	Icon.path = ""

	Icon.RaidActive = false
	Icon.SelfWarning = false
	Icon.RaidWarning = false
	
	Icon.SelfWarnText1 = ""
	Icon.SelfWarnText2 = ""
	Icon.RaidWarnText1 = ""
	Icon.RaidWarnText2 = ""
		
	Icon.PlayerValue = 0x7FFF
	Icon.RaidValue = {}
	Icon.RaidID = {}
	Icon.RaidMinValue = 0
	Icon.RaidMinValueStr = ""
	Icon.RaidMinIndex = 0
	Icon.RaidMinName = ""	

	-- Set Values
	function Icon:SetRaidMinValue(i, v, s)
		if (s == RWConst.Hestia.msgOff) and (not self.RaidActive) then self.RaidMinValueStr = "" else self.RaidMinValueStr = s end
		self.RaidMinIndex = i
		self.RaidMinValue = v
		self.RaidData:SetText(self.RaidMinValueStr)
		if i ~= 0 then self.RaidMinName = RWRoot.RaidMember[i].name end
	end
		
	function Icon:SetPlayerValue(v, s)		
		if (s == RWConst.Hestia.msgOff) and (not RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[self.Index]) then s = "" end
		self.PlayerValue = v
		self.SelfData:SetText(s)
	end
	
	-- Raid warning functions
	function Icon:CanWarnRaid()
		return (not self.RaidWarning) and self.RaidActive
	end
	
	function Icon:SetRaidWarning(text1, text2)
		self.RaidWarning = true
		self.RaidWarnText1 = text1
		self.RaidWarnText2 = text2
		self.RaidData:SetFontColor(unpack(RWConfig.Hestia.WarningColor))
		self:GetParent():DoRaidWarning(self.Index)
	end
	
	function Icon:ClearRaidWarning()
		self.RaidWarning = false
		self.RaidData:SetFontColor(unpack(RWConfig.Hestia.RaidGreenColor))
		self.RaidData:SetText(self.RaidMinValueStr)
		self:SetTexture(self.source, self.path)
		self:GetParent():DoneRaidWarning(self.Index)
	end

	-- Self warning functions
	function Icon:CanWarnSelf()
		return (not self.SelfWarning) and RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[self.Index]
	end

	function Icon:OverrideSelfWarning(text1, text2)
		self.SelfWarnText1 = text1
		self.SelfWarnText2 = text2			
		if self.SelfWarning then
			self:GetParent():ShowIconWarning(self.Index, false)
		else
			self.SelfWarning = true
			self.SelfData:SetFontColor(unpack(RWConfig.Hestia.WarningColor))
			self:GetParent():DoSelfWarning(self.Index)
			self:GetParent():ShowIconWarning(self.Index, false)
		end			
	end	
	
	function Icon:SetSelfWarning(text1, text2)
		self.SelfWarning = true
		self.SelfWarnText1 = text1
		self.SelfWarnText2 = text2			
		self.SelfData:SetFontColor(unpack(RWConfig.Hestia.WarningColor))
		self:GetParent():DoSelfWarning(self.Index)
	end
	
	function Icon:ClearSelfWarning()
		self.SelfWarning = false
		self.SelfData:SetFontColor(unpack(RWConfig.Hestia.SelfGreenColor))
		self:SetTexture(self.source, self.path)
		self:GetParent():DoneSelfWarning(self.Index)
	end
	
	-- Activate/Desactivate the raid data text	
	function Icon:DisableRaid()	
		self.RaidActive = false
		if self.RaidAvailable then
			if self.RaidWarning then self:ClearRaidWarning() end
			self.RaidData:SetFontColor(unpack(RWConfig.Hestia.DataOffColor))
			if self.RaidMinValueStr == RWConst.Hestia.msgOff then self.RaidData:SetText("") self.RaidMinValueStr = "" end
		end
	end
	
	function Icon:EnableRaid()
		self.RaidActive = true
		if self.RaidAvailable then
			self.RaidData:SetFontColor(unpack(RWConfig.Hestia.RaidGreenColor))
			if (self.RaidMinValueStr == "") and RWConfig.Hestia.DoRaidScan then self.RaidData:SetText(RWConst.Hestia.msgOff) self.RaidMinValueStr = RWConst.Hestia.msgOff end
		end
	end	
	
	function Icon:DesactivateRaid()	
		RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].raid[self.Index] = false
		self:DisableRaid()
	end
	
	function Icon:ActivateRaid()
		RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].raid[self.Index] = true
		self:EnableRaid()
	end
	
	-- Activate/Desactivate the icon and the player data text	
	function Icon:Disable()
		self:DisableRaid()
		self:SetVisible(false)
		if self.SelfWarning then self:ClearSelfWarning() end	
		self.SelfData:SetFontColor(unpack(RWConfig.Hestia.DataOffColor))
		if self.SelfData:GetText() == RWConst.Hestia.msgOff then self.SelfData:SetText("") end
	end

	function Icon:Enable()
		self:LoadIcon()
		self.SelfData:SetFontColor(unpack(RWConfig.Hestia.SelfGreenColor))	
		self:SetVisible(true)	
		if RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].raid[self.Index] then self:EnableRaid() end
		if self.SelfData:GetText() == "" then self.SelfData:SetText(RWConst.Hestia.msgOff) end
	end

	function Icon:Desactivate()
		RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[self.Index] = false
		self:Disable()
	end
	
	function Icon:Activate()
		RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[self.Index] = true
		self:Enable()
	end
		
	-- Set the Icon image
	function Icon:LoadIcon(id, path)
		if id then
			self.ID = id
			self.path = path		
			self.source = "Rift"
		elseif self.ID == "" then
			self.ID = RWConst.Hestia.FrameData.IconDefault[self.Index].ID
			if self.ID == "" then return end
			self.path = RWConst.Hestia.FrameData.IconDefault[self.Index].Path
			if self.ID == "Hermes" then
				self.source = RWData.AddonIdentifier			
			else
				self.source = "Rift"
			end	
		end	
		if RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[self.Index] then 
			self:SetTexture(self.source, self.path) 
		end
	end
	
	-- Event handlers
	function Icon.Event:LeftDown()
		self:Desactivate()	
	end
	
	function Icon.Event:RightDown()
		if RWConfig.Hestia.DoRaidScan then 
			if self.RaidActive then 
				self:DesactivateRaid()
			elseif RWConst.Hestia.CanActiveRaid[self.Index] then
				self:ActivateRaid()
			else
				print(RWRoot.locTxt.Hestia.NoRaidWarnForThis)
			end	
		else
			print(RWRoot.locTxt.Hestia.NoRaidScanMsg)
		end
	end
	
	-- Adjust to the new size
	function Icon:AdjustSize()
		self:SetHeight(FrameCoord.IconSize)
		self:SetWidth(FrameCoord.IconSize)	
		
		MTools.ClearPoints(self)
		self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", unpack(FrameCoord.IconCoord[self.Index]))
				
		self.SelfData:SetFontSize(FrameCoord.DataTextSize)
		MTools.ClearPoints(self.SelfData)
		self.SelfData:SetPoint("CENTER", self:GetParent(), "TOPLEFT", unpack(FrameCoord.DataCoord[self.Index]))
		if self.RaidAvailable then
			self.RaidData:SetFontSize(FrameCoord.DataTextSize)
			MTools.ClearPoints(self.RaidData)
			self.RaidData:SetPoint("CENTER", self:GetParent(), "TOPLEFT", FrameCoord.DataCoord[self.Index][1], FrameCoord.DataCoord[self.Index][2]+FrameCoord.DataDY)
		end				
	end
	
	-- Flash the Icon (warning!)
	function Icon:FlashRaidWarnText(FlashOn)
		if FlashOn then
			self.RaidData:SetText(self.RaidMinValueStr)
		else
			self.RaidData:SetText(self.RaidMinName)
		end
	end
	
	function Icon:FlashRaidWarnIcon(FlashOn)
		self:FlashRaidWarnText(FlashOn)	
		if FlashOn then
			self:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.WarnIconPath.raid)
		else
			self:SetTexture(self.source, self.path)
		end		
	end
	
	function Icon:FlashSelfWarnIcon(FlashOn)
		if FlashOn then
			self:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.WarnIconPath.self)
		else
			self:SetTexture(self.source, self.path)
		end		
		if self.RaidWarning then self:FlashRaidWarnText(FlashOn) end
	end	

	-- Initialization!
	function Icon:InitRaidValue()
		self.RaidMinIndex = 0
		self.RaidMinValue = 0x7FFF
		self.RaidMinName = ""

		if self.RaidActive and RWConfig.Hestia.DoRaidScan then
			self.RaidData:SetText(RWConst.Hestia.msgOff)
			self.RaidMinValueStr = RWConst.Hestia.msgOff
		else
			self.RaidMinValueStr = ""
			if self.RaidAvailable then self.RaidData:SetText("") end
		end		
	end

	function Icon:InitIcon()
		local ActiveIcon = RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode]
	
		if ActiveIcon.self[self.Index] then
			self:Enable()
			if not ActiveIcon.raid[self.Index] then self:DisableRaid() end
		else
			self:Disable()
		end		
	end	
	
	
	Icon:AdjustSize()
	Icon:InitIcon()
	
	return Icon
end

-- Led Object ------

local function buildLedObject(parent)

	local led = UI.CreateFrame("Texture", "HestiaFrame", parent)
	led:SetVisible(false)
	
	led.state = 0
	
	function led:SetState(v)
		if self.state ~= v then
			RWConfig.Hestia.ledState = v
			self.state = v
			if v == RWConst.Hestia.ledState["Off"] then
				self.flashOn = false
				self:SetVisible(false)
			else
				self:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.ledPath[v])				
				self.flashOn = true
				self:SetVisible(true)		
			end
		end	
	end
	
	function led:Update(flashOn)
		if self.state < 3 then
			if flashOn then
				self:SetVisible(true)		
			else 
				self:SetVisible(false)			
			end		
		end	
	end

	function led:Clicked()
		if self.state > 3 then
			self:GetParent():SetLedOn()
		else
			self:GetParent():SetLedOff()
		end			
	end
	
	function led.Event:LeftDown()
		self:Clicked()
	end
	
	function led:ForceFlashOn()
		if (self.state < 3) and (not self.flashOn) then
			self.flashOn = true
			self:SetVisible(true)		
		end
	end
	
	function led:AdjustSize()
		self:SetHeight(FrameCoord.bigBtnSize)
		self:SetWidth(FrameCoord.bigBtnSize)
		MTools.ClearPoints(self)
		self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", unpack(FrameCoord.btnCoord[6]))	
	end	
	
	led:AdjustSize()
	led:SetState(RWConfig.Hestia.ledState)
	
	return led
end

-- Hestia main frame ------

local function buildHestiaFrame()

	local Frame = UI.CreateFrame("Texture", "HestiaFrame", RWRoot.context)
	Frame:SetVisible(false)
	
	Frame:SetTexture(RWData.AddonIdentifier, FrameData.FramePath)
	Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", RWConfig.Hestia.Location.x, RWConfig.Hestia.Location.y)
	
	-- State Icons
	Frame.StateIcon = UI.CreateFrame("Texture", "HestiaFrame", Frame)
	Frame.StateIcon:SetVisible(false)
			
	-- Init InfoFrame
	Frame.InfoFrame = UI.CreateFrame("Frame", "HestiaInfoFrame", Frame)
	Frame.InfoFrame:SetVisible(false)
	Frame.InfoFrame:SetBackgroundColor(unpack(RWConst.Hestia.FrameData.InfoFrameBackColor))
	Frame.InfoFrame:SetPoint("TOPLEFT", Frame, "BOTTOMLEFT", 0, 2)

	Frame.InfoFrame.Text1 = UI.CreateFrame("Text", "HestiaInfoText1", Frame.InfoFrame)
	Frame.InfoFrame.Text2 = UI.CreateFrame("Text", "HestiaInfoText2", Frame.InfoFrame)

	-- Init led
	Frame.led = buildLedObject(Frame)
	
	-- Init buttons
	Frame.Button = {}	
	for i = 1, RWConst.Hestia.FrameData.TotalBtn do 
		Frame.Button[i] = buildFrameButton(Frame, i)
	end
	
	-- InitIcons	
	Frame.Icon = {}
	for i = 1, RWConst.Hestia.FrameData.TotalIcon do
		Frame.Icon[i] = buildFrameIcon(Frame, i)	
	end
	
	-- Data
	Frame.SelfWarnCounter = 0
	Frame.SelfWarnIndex = 0
	Frame.RaidWarnCounter = 0
	Frame.RaidWarnIndex = 0
	
	Frame.FlashOn = false
	Frame.UserOpened = false
	
	Frame.MouseDown = false
	Frame.MouseX0 = 0
	Frame.MouseY0 = 0
	
	Frame.Status = 0 -- 0-nothing, 1-in combat, 2-some raidmembers lost, 3-all raidmembers lost, 4-dead in the raid!, 5-Loading in progress
	
	
	-- Functions ------------------

	-- Set led
	function Frame:SetLedOn()
		if self.SelfWarnCounter > 0 then
			self.led:SetState(RWConst.Hestia.ledState["SelfWarn"])
		elseif self.RaidWarnCounter > 0 then
			self.led:SetState(RWConst.Hestia.ledState["RaidWarn"])		
		else
			self.led:SetState(RWConst.Hestia.ledState["Green"])				
		end
	end

	function Frame:SetLedOff()
		self.led:SetState(RWConst.Hestia.ledState["Off"])		
	end
	
	-- InfoFrame
	function Frame:AdjustInfoFrame()
		self.InfoFrame:SetWidth( math.max( 
			self.InfoFrame.Text1:GetWidth()+FrameCoord.InfoFrame2X, 
			self.InfoFrame.Text2:GetWidth()+FrameCoord.InfoFrame2X,
			FrameCoord.width) )		
		self.InfoFrame:SetHeight(self.InfoFrame.Text1:GetHeight() + self.InfoFrame.Text2:GetHeight() + FrameCoord.InfoFrame3Y)
	end

	-- Status management
	function Frame:ClearStatus()
		if (self.led.state < 3) and (self.Status == RWConst.Hestia.FrameStatus["DeadInRead"]) then 
			self:SetVisible(true) -- popup the frame if we were holding it because of dead members!
		end
		self.Status = 0
		self.StateIcon:SetVisible(false)	
	end
	
	function Frame:SetStatus(i)
		if i ~= 0 then
			if (self.led.state < 3) and (self.Status == RWConst.Hestia.FrameStatus["DeadInRead"]) then 
				self:SetVisible(true) -- popup the frame if we were holding it because of dead members!
			end
			self.Status = i
			Frame.StateIcon:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.StateIconPath[i])
			self.StateIcon:SetVisible(true)
		else
			Frame:ClearStatus()
		end			
	end
	
	-- combat enter/leave
	function Frame:SetInCombatState()
		if not RWConfig.Hestia.DontCloseOnFight then self:CloseFrame() end
		self.led:ForceFlashOn()
		self:SetStatus(RWConst.Hestia.FrameStatus["inCombat"])
	end

	function Frame:InitAll()
		self:ClearAllWarnings()
		self:ClearStatus()
	end
	
	-- Warnings popup functions
	function Frame:PopUpWarning(state)
		if self.led.state <= 3 then
			self.led:SetState(state) 
			if self.Status ~= RWConst.Hestia.FrameStatus["DeadInRead"] then self:SetVisible(true) end -- dont popup if someone is dead!
		end		
	end
	
	function Frame:DoneAllWarnings()
		self.InfoFrame:SetVisible(false)
		if self.led.state <= 3 then
			self.led:SetState(RWConst.Hestia.ledState["Green"]) 
			if (not self.UserOpened) and (not self.MouseDown) then self:SetVisible(false) end
		end		
	end

	function Frame:ClearAllWarnings()
		if (self.SelfWarnCounter + self.RaidWarnCounter) > 0 then 
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do 
			if self.Icon[i].RaidWarning then self.Icon[i]:ClearRaidWarning() end
			if self.Icon[i].SelfWarning then self.Icon[i]:ClearSelfWarning() end
		end
		end
	end
	
	function Frame:ShowIconWarning(i, popup)
		if self.Icon[i].SelfWarning then
			self.InfoFrame.Text1:SetText(self.Icon[i].SelfWarnText1)
			self.InfoFrame.Text2:SetText(self.Icon[i].SelfWarnText2)
			self:AdjustInfoFrame()			
			if popup then self:SetVisible(true) end
		end
	end
	
	-- Raid Warning 
	function Frame:StartRaidWarning(i)
		if self.SelfWarnIndex == 0 then
			self.InfoFrame.Text1:SetText(self.Icon[i].RaidWarnText1)
			self.InfoFrame.Text2:SetText(self.Icon[i].RaidWarnText2)
			self:AdjustInfoFrame()
			self:PopUpWarning(RWConst.Hestia.ledState["RaidWarn"]) 
			if self.RaidWarnIndex == 0 then 
				self.InfoFrame:SetVisible(true)
			end
		end
		self.RaidWarnIndex = i
	end
	
	function Frame:CheckRaidWarnings()
		local i = 1				
		while not self.Icon[i].RaidWarning do i = i + 1 end -- no limit check! (because we must have a warning)
		self:StartRaidWarning(i)	
	end
	
	function Frame:DoRaidWarning(i)
		self.RaidWarnCounter = self.RaidWarnCounter + 1
		if self.RaidWarnIndex == 0 then
			self:StartRaidWarning(i)
		end	
	end
	
	function Frame:DoneRaidWarning(i)
		self.RaidWarnCounter = self.RaidWarnCounter - 1
		if self.RaidWarnIndex == i then
			if self.RaidWarnCounter == 0 then
				self.RaidWarnIndex = 0
				if self.SelfWarnCounter == 0 then self:DoneAllWarnings() end
			else
				self:CheckRaidWarnings()
			end
		end	
	end

	-- Self Warning 
	function Frame:StartSelfWarning(i)
		self.InfoFrame.Text1:SetText(self.Icon[i].SelfWarnText1)
		self.InfoFrame.Text2:SetText(self.Icon[i].SelfWarnText2)
		self:AdjustInfoFrame()
		if self.SelfWarnIndex == 0 then 
			self.InfoFrame:SetVisible(true)
			self:PopUpWarning(RWConst.Hestia.ledState["SelfWarn"]) 
		end
		self.SelfWarnIndex = i
	end	
	
	function Frame:CheckSelfWarnings()
		local i = 1				
		while not self.Icon[i].SelfWarning do i = i + 1 end -- no limit check! (because we must have a warning)
		self:StartSelfWarning(i)	
	end

	function Frame:DoSelfWarning(i)
		self.SelfWarnCounter = self.SelfWarnCounter + 1
		if self.SelfWarnIndex == 0 then
			self:StartSelfWarning(i)			
		end	
	end
	
	function Frame:DoneSelfWarning(i)
		self.SelfWarnCounter = self.SelfWarnCounter - 1
		if self.SelfWarnIndex == i then
			if self.SelfWarnCounter == 0 then
				self.SelfWarnIndex = 0
				if self.RaidWarnCounter > 0 then 
					self:CheckRaidWarnings()
				else
					self:DoneAllWarnings()				
				end
			else
				self:CheckSelfWarnings()			
			end
		end
	end
	
	-- Update the frame (flashing elements!)
	function Frame:Update()
		if ((self.SelfWarnCounter + self.RaidWarnCounter) > 0) and (self.FlashOn ~= RWRoot.FlashVisible()) then
			self.FlashOn = not self.FlashOn			
			self.led:Update(self.FlashOn)	
			for i = 1, RWConst.Hestia.FrameData.TotalIcon do	
				if self.Icon[i].SelfWarning then 
					self.Icon[i]:FlashSelfWarnIcon(self.FlashOn)
				elseif self.Icon[i].RaidWarning then 
					self.Icon[i]:FlashRaidWarnIcon(self.FlashOn) 
				end
			end
		end
	end	
	
	-- Handlers
	function Frame.Event:RightDown()
		RWRoot.Hestia.PrintSessionReport(true)
	end
	
	function Frame.Event:LeftDown()
		local mouseData = Inspect.Mouse()
		local x = mouseData.x - self:GetLeft()
		local y = mouseData.y - self:GetTop()
		
		-- check if a button zone is clicked
		local i = 1
		while i <= RWConst.Hestia.FrameData.TotalBtn do -- mode button check
			if MTools.InsideZone(x, y, FrameCoord.btnCoord[i][1], FrameCoord.btnCoord[i][2], FrameCoord.btnWidth, FrameCoord.btnHeight) then 
				FrameBtnFunction[i]()
				return
			end
			i = i + 1
		end
		while i <= RWConst.Hestia.FrameData.LastBigBtnIndex do -- big button check
			if MTools.InsideSquare(x, y, FrameCoord.btnCoord[i][1], FrameCoord.btnCoord[i][2], FrameCoord.bigBtnSize) then 
				FrameBtnFunction[i]()
				return
			end
			i = i + 1		
		end
		while i <= RWConst.Hestia.FrameData.TotalFrameBtn do -- small button check
			if MTools.InsideSquare(x, y, FrameCoord.btnCoord[i][1], FrameCoord.btnCoord[i][2], FrameCoord.smallBtnSize) then 
				FrameBtnFunction[i]()
				return
			end
			i = i + 1		
		end
		
		-- check if an Icon zone is clicked
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do 
			if MTools.InsideSquare(x, y, FrameCoord.IconCoord[i][1], FrameCoord.IconCoord[i][2], FrameCoord.IconSize) then
				if RWConfig.Hestia.OffMode then return end
				if RWRoot.Hestia.CanBeActivated[i] then 
					self.Icon[i]:Activate()				
				else
					print(RWRoot.locTxt.Hestia.NoWarnForThisIcon)
				end				
				return
			end
		end
		
		-- click on the frame body! start the moving process
		self.MouseDown = true
		self.MouseX0 = x
		self.MouseY0 = y	
	end	
	
	function Frame.Event:MouseMove(mouseX, mouseY)
		if self.MouseDown then
			MTools.ClearPoints(self)
			self:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (mouseX - self.MouseX0), (mouseY - self.MouseY0))
		end
	end
	
	function Frame.Event:LeftUp()
		if self.MouseDown then
			RWConfig.Hestia.Location.x = self:GetLeft()
			RWConfig.Hestia.Location.y = self:GetTop()			
			self.MouseDown = false
			if (self.led.state >= 3) and (not self.UserOpened) then self:SetVisible(false) end
		end
	end
	
	-- Init functions
	function Frame:DisableAllIcon()
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do 
			if RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[i] then self.Icon[i]:Disable() end
		end	
	end

	function Frame:EnableAllIcon()
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do 
			if RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[i] then self.Icon[i]:Enable() end
		end	
	end
	
	function Frame:InitAllIconRaidValue()
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do
			self.Icon[i]:InitRaidValue()
		end
	end

	function Frame:OpenFrame()
		self.UserOpened = true
		self:SetVisible(true)
	end
	
	function Frame:CloseFrame()
		self.UserOpened = false
		self:SetVisible(false)
	end
	
	function Frame:InitBtnStatus()
		if RWConfig.Hestia.OffMode then
			self.Button[1]:SetVisible(false)
			self.Button[2]:SetVisible(false) 
			self.Button[3]:SetVisible(false)
			self.Button[4]:SetVisible(true)		
		else
			self.Button[4]:SetVisible(false)
			if RWConfig.Hestia.Mode == "Opti" then
				self.Button[2]:SetVisible(true) 
				self.Button[3]:SetVisible(false)
			else
				self.Button[2]:SetVisible(false) 
				self.Button[3]:SetVisible(true)
			end
		
			if RWConfig.Hestia.autoOn then 
				self.Button[1]:SetVisible(true)
			else
				self.Button[1]:SetVisible(false)
			end
		end	
	end
	
	function Frame:AdjustSize()
		self:SetHeight(FrameCoord.height)
		self:SetWidth(FrameCoord.width)
		
		self.InfoFrame:SetWidth(FrameCoord.width)
		self.InfoFrame:SetHeight(FrameCoord.InfoFrameHeight)
		self.InfoFrame.Text1:SetFontSize(FrameCoord.InfoTextSize)
		self.InfoFrame.Text2:SetFontSize(FrameCoord.InfoTextSize)
		MTools.ClearPoints(self.InfoFrame.Text1)
		self.InfoFrame.Text1:SetPoint("TOPLEFT", self.InfoFrame, "TOPLEFT", FrameCoord.InfoFrameX0, FrameCoord.InfoFrameY0)
		MTools.ClearPoints(self.InfoFrame.Text2)
		self.InfoFrame.Text2:SetPoint("BOTTOMLEFT", self.InfoFrame, "BOTTOMLEFT", FrameCoord.InfoFrameX0, -FrameCoord.InfoFrameY0)
		self.led:AdjustSize()

		MTools.ClearPoints(self.StateIcon)
		self.StateIcon:SetPoint("TOPLEFT", self, "TOPLEFT", unpack(FrameCoord.StateIcon))
		self.StateIcon:SetWidth(FrameCoord.smallBtnSize)
		self.StateIcon:SetHeight(FrameCoord.smallBtnSize)
		for i = 1, RWConst.Hestia.FrameData.TotalBtn do self.Button[i]:AdjustSize()	end
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do self.Icon[i]:AdjustSize() end	
	end
	
	
	Frame:AdjustSize()
	Frame:InitBtnStatus()

	RWRoot.Hestia.Frame = Frame
end

-- Hestia Session Report
function RWRoot.Hestia.InitSessionReport(show)

	function GetBuffTable()
		local t = {}
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do t[i] = 0 end
		return {
			nbTimeTaken = t,
			TotalSoulHealed = 0,
			TotalPlanarGained = 0,
			PBuffWithSpell = {0, 0, 0}
		}
	end

	RWRoot.Hestia.SessionReport = {
		JoinTime = RWRoot.CurrentTime,
		LeaveTime = 0,
		FirstCombatBeginTime = 0,
		LastCombatEndTime = 0,
		TotalCombatTime = 0,
		LongestFightTime = 0,
		nbCombats = 0,
		nbLongCombats = 0,
		selfBuffStat = GetBuffTable(),
		raidBuffStat = GetBuffTable()	
	}
	if show or RWConfig.Hestia.ShowSessionReport then print(RWRoot.locTxt.Hestia.repDataInit) end
end

function RWRoot.Hestia.PrintSessionReport(warnIfEmpty)

	if RWRoot.Hestia.SessionReport then

	if RWRoot.Hestia.SessionReport.LastCombatEndTime == 0 then
		if warnIfEmpty then
			print(RWRoot.locTxt.Hestia.repNoCombatData)
			print(RWRoot.locTxt.Hestia.repNoStatsData)
		end
	else
		Command.Console.Display("general", true, "<font color=\"#44AAff\"><u>" .. RWRoot.locTxt.Hestia.repTitle .. "</u></font>", true)

		-- buff report
		local stat = RWRoot.Hestia.SessionReport.selfBuffStat
		local t = 0
		for i = 1, RWConst.Hestia.FrameData.TotalIcon do
			if stat.nbTimeTaken[i] > 0 then
				local s = tostring(stat.nbTimeTaken[i])
				if i == 1 then
					s = s .. " ,(" .. tostring(stat.TotalPlanarGained) .. ")"
				elseif i == 11 then
					s = s .. " ,(" .. tostring(stat.TotalSoulHealed) .. "%)"				
				elseif (i >= 7) and (i <= 9) then
					t = t + stat.nbTimeTaken[i]
					s = s .. " ,(" .. tostring(stat.PBuffWithSpell[i-6]) .. ")"
				elseif i < 14 then
					t = t + stat.nbTimeTaken[i]
				end
				Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWConst.Hestia.SessionReportLine[i] .. "</font>" ..
					s, true)
			end		
		end
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repTotalBuff .. "</font>" .. 
			tostring(t), true)

		-- Time report
		RWRoot.Hestia.SessionReport.LeaveTime = RWRoot.CurrentTime
		stat = RWRoot.Hestia.SessionReport
		t = RWRoot.CurrentTime - stat.JoinTime
		local t2 = stat.LastCombatEndTime - stat.FirstCombatBeginTime
		local t3 = stat.FirstCombatBeginTime - stat.JoinTime
		
		Command.Console.Display("general", true, "<font color=\"#44AAff\"><i><b><u>" .. RWRoot.locTxt.Hestia.repSubTitle1 .. "</u></b></i></font>", true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine1 .. "</font>" ..
			MTools.GetTimeString(t), true)
		--Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. "Temps avant le premier pull: " .. "</font>" ..
			--MTools.GetTimeString(t3) ..", (" ..
			--tostring(math.floor(t3*100/t)) .. "% de t1)", true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine2 .. "</font>" ..
			MTools.GetTimeString(t2), true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine3 .. "</font>" ..
			tostring(math.floor((t-t2)*100/t)) .. "%", true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine4 .. "</font>" ..
			MTools.GetTimeString(stat.TotalCombatTime), true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine5 .. "</font>" ..
			tostring(math.floor(stat.TotalCombatTime*100/t)) .."%, " .. 
			tostring(math.floor(stat.TotalCombatTime*100/t2)) .. "%", true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine6 .. "</font>" ..
			tostring(stat.nbCombats), true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine7 .. "</font>" ..
			tostring(stat.nbLongCombats), true)
		Command.Console.Display("general", true, "<font color=\"#7788AA\">" .. RWRoot.locTxt.Hestia.repStatLine8 .. "</font>" ..
			MTools.GetTimeString(stat.LongestFightTime), true)

	end
	end
end


-- General functions --------------------------------------------------------------------------------------

local function InitWarningMessage()
	DeadWarnActive = false
	MedicWarnDone = false
	FestinWarnDone = false
	RWRoot.Hestia.NotFullVitaWarn = false
	RWRoot.Hestia.NotFullPlanarWarn = false			
	HWarnMessage:VisibleTo(false)
end

-- Shadow Walk management
local function UpdateShadowWalkMsg()
	if RWRoot.CurrentTime < RWRoot.Hestia.SWalkTimeLimit then
		FlashWarnText = false
		HWarnMessage:TextTo(string.format(RWRoot.locTxt.Hestia.ShadowWalk, RWRoot.Hestia.WalkedMember))
		HWarnMessage:SetFontColor(unpack(RWConfig.Hestia.WalkMsgColor))
		NoWalkYet = false
	else
		FlashWarnText = true
		HWarnMessage:TextTo(RWRoot.locTxt.Hestia.NoShadowWalk)
		HWarnMessage:SetFontColor(unpack(RWConfig.Hestia.NoWalkMsgColor))		
		NoWalkYet = true
	end
end

-- Show warning message
local function ShowWarningMessage()
	-- Walk message
	if DeadWarnActive then
		UpdateShadowWalkMsg()
		if not HWarnMessage:GetVisible() then HWarnMessage:VisibleTo(true) end
	
	-- Health not full message
	elseif RWRoot.Hestia.NotFullVitaWarn then
		FlashWarnText = true
		HWarnMessage:TextTo(RWRoot.locTxt.Hestia.VitalityNotFull)
		HWarnMessage:SetFontColor(unpack(RWConfig.Hestia.WarningMsgColor))
		if not HWarnMessage:GetVisible() then HWarnMessage:VisibleTo(true) end
	
	-- Planar not full message
	elseif RWRoot.Hestia.NotFullPlanarWarn then
		FlashWarnText = true
		HWarnMessage:TextTo(RWRoot.locTxt.Hestia.PlanarNotFull)
		HWarnMessage:SetFontColor(unpack(RWConfig.Hestia.WarningMsgColor))
		if not HWarnMessage:GetVisible() then HWarnMessage:VisibleTo(true) end
	
	-- Medic up message
	elseif MedicWarnDone then
		FlashWarnText = true
		HWarnMessage:TextTo(RWRoot.locTxt.Hestia.MedicIsUp)
		HWarnMessage:SetFontColor(unpack(RWConfig.Hestia.WarningMsgColor))
		if not HWarnMessage:GetVisible() then HWarnMessage:VisibleTo(true) end
	
	-- Festin up message
	elseif FestinWarnDone then
		FlashWarnText = true
		HWarnMessage:TextTo(RWRoot.locTxt.Hestia.FeastIsUp)
		HWarnMessage:SetFontColor(unpack(RWConfig.Hestia.WarningMsgColor))
		if not HWarnMessage:GetVisible() then HWarnMessage:VisibleTo(true) end
	
	-- no message to be shown!
	else
		FlashWarnText = false	
		if HWarnMessage:GetVisible() then HWarnMessage:VisibleTo(false)	end
	end	
end

local function ClearWarningMessage()
	RWRoot.Hestia.NotFullVitaWarn = false
	RWRoot.Hestia.NotFullPlanarWarn = false
	MedicWarnDone = false
	FestinWarnDone = false
	ShowWarningMessage()
end

-- Queue functions ! ----
local function QueueCheck(checkFunc)
	table.insert(RWRoot.Hestia.QueuedCheck, checkFunc)
	RWRoot.Hestia.nbQueuedCheck = RWRoot.Hestia.nbQueuedCheck + 1
end

local function DoneQueueCheck(i)
	table.remove(RWRoot.Hestia.QueuedCheck, i)
	RWRoot.Hestia.nbQueuedCheck = RWRoot.Hestia.nbQueuedCheck - 1
end

local function RemoveFromQueue(Func)
	for k, v in pairs(RWRoot.Hestia.QueuedCheck) do
		if v == Func then
			RWRoot.Hestia.nbQueuedCheck = RWRoot.Hestia.nbQueuedCheck - 1
			table.remove(RWRoot.Hestia.QueuedCheck, k)
			return
		end
	end
end

-- Scan player capabilities
local function ScanPlayerCapabilities()
	local ScanNeeded = true
	if RWRoot.player and RWRoot.player.calling then 
	-- Sacrifice life: Planar charge!
	local detail = Inspect.Ability.New.Detail(RWData.Hestia.SLPSpellIDNew)
	ScanNeeded = (detail == nil)
	RWRoot.Hestia.CanDoAction.SLPlanar = (detail and (not detail.unusable))
	-- Planar buff spells (harmo)
	for i = 1, 3 do
		detail = Inspect.Ability.New.Detail(RWData.Hestia.PlanarSpellID[i])
		if detail then
			RWRoot.Hestia.CanDoAction.PlanarSpell[i] = (not detail.unusable)
		else
			ScanNeeded = true
		end
	end
	-- Can use mana potions?
	RWRoot.Hestia.CanDoAction.UseManaPotion = (RWConst.Hestia.ClassGroup[RWRoot.player.calling] == "MageCleric")
	RWRoot.Hestia.CanBeActivated[RWConst.Hestia.IconSlot["ManaPtn"]] = RWRoot.Hestia.CanDoAction.UseManaPotion
	end
	return not ScanNeeded
end

-- onHold management
local function onHoldInit5min()
	onHoldTimeLimit = RWRoot.CurrentTime + 5*60	
end

local function onHoldInitNextRCheck()
end

local function onHoldInitNextFight()
end

local function onHoldCheck5min()
	return RWRoot.CurrentTime >= onHoldTimeLimit
end

local function onHoldCheckNextRCheck()
	return ReadyCheckDetected and (not ReadyCheckInProgress)
end

local function onHoldCheckNextFight()
end

onHoldInitFunction[1] = onHoldInit5min
onHoldInitFunction[2] = onHoldInitNextRCheck
onHoldInitFunction[3] = onHoldInitNextFight
onHoldCheckFunction[1] = onHoldCheck5min
onHoldCheckFunction[2] = onHoldCheckNextRCheck
onHoldCheckFunction[3] = onHoldCheckNextFight

local function ClearOnHold()
	RWRoot.Hestia.Frame:SetLedOn()
	if RWRoot.Hestia.Frame.led.state < 3 then
		RWRoot.Hestia.Frame:SetVisible(true)
	end
end

local function CheckOnHold()
	if onHoldCheckFunction[RWConfig.Hestia.ReactivateCondition]() then ClearOnHold() end
end

local function SetFrameOnHold()
	print(RWRoot.locTxt.Hestia.OnHoldActivated)
	print(RWConst.Hestia.ReactCondMsg[RWConfig.Hestia.ReactivateCondition])
	RWRoot.Hestia.Frame.led:SetState(RWConst.Hestia.ledState["OnHold"])
	onHoldInitFunction[RWConfig.Hestia.ReactivateCondition]()
end

local function SetFramePopupOff()
	print(RWConst.Hestia.ReactCondMsg[4])
	RWRoot.Hestia.Frame.led:SetState(RWConst.Hestia.ledState["Off"])
end

-- switch mode
local function SwitchAutoOff()
	if RWConfig.Hestia.autoOn then
		RWConfig.Hestia.autoOn = false
		RWRoot.Hestia.Frame.Button[1]:SetVisible(false)
	end
end

local function NoMoreOff()
	if RWConfig.Hestia.OffMode then
		RWConfig.Hestia.OffMode = false
		RWRoot.Hestia.Frame.Button[4]:SetVisible(false)
	end
end

local function SwitchToMode(mode, auto, ignoreOnHold)
	local save = RWRoot.Hestia.Frame.UserOpened
	RWRoot.Hestia.Frame.UserOpened = true -- to prevent Hestia from closing
	RWRoot.Hestia.Frame:DisableAllIcon()
	RWConfig.Hestia.Mode = mode
	RWRoot.Hestia.Frame:EnableAllIcon()
	RWRoot.Hestia.Frame.UserOpened = save
	if mode == "Opti" then
		RWRoot.Hestia.Frame.Button[2]:SetVisible(true)
		RWRoot.Hestia.Frame.Button[3]:SetVisible(false)
	else
		RWRoot.Hestia.Frame.Button[2]:SetVisible(false)
		RWRoot.Hestia.Frame.Button[3]:SetVisible(true)
		if RWRoot.Hestia.NotFullVitaWarn or RWRoot.Hestia.NotFullPlanarWarn then
			RWRoot.Hestia.NotFullVitaWarn = false
			RWRoot.Hestia.NotFullPlanarWarn = false
			ShowWarningMessage()			
		end
	end	
	if auto then 
		print(RWConst.Hestia.AutoMsg[mode]) 
		if (not ignoreOnHold) and (RWConfig.Hestia.onHoldonAuto) and (RWRoot.Hestia.Frame.led.state <= 3) 
		and (RWConfig.Hestia.ReactivateCondition ~= 4) 
		then
			SetFrameOnHold()
		end	
	end
end

function RWRoot.Hestia.SetAutoOff() 
	SwitchAutoOff()
end

-- Frame buttons functions ----
local function autoActivated()
	RWRoot.Hestia.Frame.Button[1]:SetVisible(true)
	RWConfig.Hestia.autoOn = true
	NoMoreOff()
	SwitchToMode(RWConfig.Hestia.Mode)
	DoAutoCheck = true
end

local function OptiActivated()
	RWRoot.Hestia.Frame.Button[2]:SetVisible(true)
	SwitchAutoOff()
	NoMoreOff()
	SwitchToMode("Opti")
end

local function CoolActivated()
	RWRoot.Hestia.Frame.Button[3]:SetVisible(true)
	SwitchAutoOff()
	NoMoreOff()
	SwitchToMode("Cool")
end

local function OffActivated()
	SwitchAutoOff()
	RWRoot.Hestia.Frame:DisableAllIcon()
	RWRoot.Hestia.Frame.Button[2]:SetVisible(false)
	RWRoot.Hestia.Frame.Button[3]:SetVisible(false)
	RWRoot.Hestia.Frame.Button[4]:SetVisible(true)
	RWConfig.Hestia.OffMode = true
	ClearWarningMessage()			
end

local function xClicked()
	if not RWRoot.RaidInCombat then
	if RWRoot.Hestia.Frame.led.state < 3 then
		print(RWRoot.locTxt.Hestia.ForcedClosure)
		if RWConfig.Hestia.ReactivateCondition == 4 then
			SetFramePopupOff()
		else
			SetFrameOnHold()
		end
	end 
	end
	RWRoot.Hestia.Frame:CloseFrame()
end

local function ledClicked()
	RWRoot.Hestia.Frame.led:Clicked()
end

local function ConfigClicked()
	RWRoot.ConfigWinManager:ShowWindow("HestiaConfigWin")
end

local function HelpClicked()
end

FrameBtnFunction[1] = autoActivated
FrameBtnFunction[2] = OptiActivated
FrameBtnFunction[3] = CoolActivated
FrameBtnFunction[4] = OffActivated
FrameBtnFunction[5] = xClicked
FrameBtnFunction[6] = ledClicked
FrameBtnFunction[7] = ConfigClicked
FrameBtnFunction[8] = HelpClicked

-- Check time between fight when solo!
local function CheckSoloFightTTL()

	if RWConfig.Hestia.SoloFightReact then
		if (GroupState ~= 0) or (RWRoot.CurrentTime > (RWRoot.LastFightTime + RWConst.Hestia.noSoloFightTTL)) then
			SoloFightWarned = false
			return true
		else
			return false
		end
	else
		SoloFightWarned = false
		return true
	end	
end

-- Medeic/Feast detection ----

local function MedicGone()
	RWRoot.Hestia.MedicUp = false
	if MedicWarnDone then
		MedicWarnDone = false
		ShowWarningMessage()
	end
end

local function MedicCheck()
	if RWRoot.CurrentTime < RWRoot.Hestia.MedicTimeLimit then return false 
	else
		MedicGone()
		return true		
	end
end

local function MedicDetected()

	if (not RWRoot.Hestia.MedicUp) and RWConfig.Hestia.DoMedicWarning then
		RWRoot.Hestia.MedicUp = true
		RWRoot.Hestia.MedicTimeLimit = RWRoot.CurrentTime + RWConst.Hestia.MedicTime
		QueueCheck(MedicCheck)	
	end
end

local function FoodGone()
	RWRoot.Hestia.FoodUp = false
	if FestinWarnDone then
		FestinWarnDone = false
		ShowWarningMessage()
	end
end

local function FoodCheck()
	if RWRoot.CurrentTime < RWRoot.Hestia.FoodTimeLimit then return false
	else
		FoodGone()
		return true		
	end
end

local function FoodDetected()

	if (not RWRoot.Hestia.FoodUp) and RWConfig.Hestia.DoFoodWarning then
		RWRoot.Hestia.FoodUp = true
		RWRoot.Hestia.FoodTimeLimit = RWRoot.CurrentTime + RWConst.Hestia.FoodTime
		QueueCheck(FoodCheck)
	end
end

-- Check if the player is prepared! (max planar and vita!)
local function CheckMaxPlanar() 
	if RWRoot.player and RWRoot.player.planar then
		local j = RWConst.Hestia.IconSlot["Planar"]
		local Icon = RWRoot.Hestia.Frame.Icon[j]
		if RWRoot.player.planar < RWRoot.player.planarMax then
			RWRoot.Hestia.PlanarWarnTimeLimit = RWRoot.CurrentTime + RWConst.Hestia.NotFullWarnTime
			RWRoot.Hestia.NotFullPlanarWarn = true
			Icon:OverrideSelfWarning(RWConst.Hestia.SelfWarnMsg[j].NotFull[1], RWConst.Hestia.SelfWarnMsg[j].NotFull[2])
			ShowWarningMessage()
		end
		return true
	else
		return false
	end
end

local function CheckMaxVitality() 
	if RWRoot.player and RWRoot.player.planar then
		local j = RWConst.Hestia.IconSlot["SoulHealth"]
		local Icon = RWRoot.Hestia.Frame.Icon[j]
		if RWRoot.player.vitality < 100 then
			RWRoot.Hestia.VitaWarnTimeLimit = RWRoot.CurrentTime + RWConst.Hestia.NotFullWarnTime
			RWRoot.Hestia.NotFullVitaWarn = true
			ShowWarningMessage()
			Icon:OverrideSelfWarning(RWConst.Hestia.SelfWarnMsg[j].NotFull[1], RWConst.Hestia.SelfWarnMsg[j].NotFull[2])
		end	
		return true
	else
		return false
	end
end

-- Joining a new group!
local function InitGroupJoin(n)
	if n ~= 0 then
		if GroupState == 0 then -- switching from solo to group!
			RWRoot.Hestia.InitSessionReport() -- if we were alone and we are joining a group, init the report!
			if RWConfig.Hestia.CoolJoinReact and (RWRoot.Hestia.Frame.led.state == RWConst.Hestia.ledState["OnHold"]) 
			and (RWConfig.Hestia.Mode == "Cool") then
				ClearOnHold()		
			end
		end
	elseif RWConfig.Hestia.onHoldonSolo then -- We are alone! set the frame to onHold if configured this way
		if RWRoot.Hestia.Frame.led.state ~= RWConst.Hestia.ledState["OnHold"] then
			if RWConfig.Hestia.ReactivateCondition ~= 4 then
				SetFrameOnHold()
			else
				SetFramePopupOff()
			end			
		end
		if SoloFightWarned then -- reinitilize the after combat solo check
			InitSoloFightWarn = false
			RemoveFromQueue(CheckSoloFightTTL)
		end
	end

	GroupState = n
	RWRoot.Hestia.Frame:ClearStatus()
	RWRoot.Hestia.Frame:ClearAllWarnings()
	if (GroupState > 0) and DoGroupJoinWarn and (RWConfig.Hestia.Mode == "Opti") 
	and (RWRoot.CurrentTime > (RWRoot.LastAvailableTime + RWConst.Hestia.GroupJoinTTL)) 
	then
		if RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[RWConst.Hestia.IconSlot["Planar"]] then QueueCheck(CheckMaxPlanar) end
		if RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[RWConst.Hestia.IconSlot["SoulHealth"]] then QueueCheck(CheckMaxVitality) end
		DoGroupJoinWarn = false
	end
	
	RWRoot.Hestia.Frame:InitAllIconRaidValue()
	RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["SoulHealth"]].RaidValue = {
		0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
		0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF
	}
	RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["Food"]].RaidValue = {
		0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
		0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF
	}
	RWRoot.Hestia.MemberLost = {
		true,	true,	true,	true,	true,	true,	true,	true,	true,	true,
		true,	true,	true,	true,	true,	true,	true,	true,	true,	true
	}
end

-- Check lists ---------------------------------------------------------------------------------------------------------------

-- Player check list --------------------------------------------------------------------------------------------------

-- Planar check
local function UpdatePlayerPlanar()

	local v = RWRoot.player.planar
	local j = RWConst.Hestia.IconSlot["Planar"]
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false
	
	if v ~= Icon.PlayerValue then -- data changed, update!
		local n = Icon.PlayerValue - v
		Icon:SetPlayerValue(v, tostring(v))
		local stat = RWRoot.Hestia.SessionReport.selfBuffStat
		if n < 0 then
			stat.TotalPlanarGained = stat.TotalPlanarGained - n
		elseif n < 50 then 
			stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + n
		end		
	end
	
	-- check if we can recharge our planar with the SLP spell
	if v < RWRoot.player.planarMax then
		if RWRoot.Hestia.CanDoAction.SLPlanar and (RWRoot.CurrentTime >= RWRoot.Hestia.SLPSpellUpTime) then -- spell is ready
			local detail = Inspect.Ability.New.Detail(RWData.Hestia.SLPSpellIDNew)
			if detail and detail.currentCooldownRemaining and (detail.currentCooldownRemaining > RWConst.Hestia.PSpellGCDTTL) then -- the spell was casted!
				RWRoot.Hestia.SLPSpellUpTime = RWRoot.CurrentTime + detail.currentCooldownRemaining
				if Icon.SelfWarning then Icon:ClearSelfWarning() end
			elseif Icon:CanWarnSelf() then -- Spell is ready! issue a warning
				Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2])
			end
		end	
	elseif Icon.SelfWarning then Icon:ClearSelfWarning() end -- we are at max, clear the warning if set
	
	if RWRoot.Hestia.NotFullPlanarWarn and
		((not RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[j]) or (RWRoot.CurrentTime > RWRoot.Hestia.PlanarWarnTimeLimit) or (v == RWRoot.player.planarMax)) 
	then
		RWRoot.Hestia.NotFullPlanarWarn = false
		ShowWarningMessage()
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end
	
	-- update raid data
	ActualPlanar = ActualPlanar + v
	ActualPlanarMax = ActualPlanarMax + RWRoot.player.planarMax
	if v >= 3 then ActualPlanar3 = ActualPlanar3 + 1 end
end

-- ShadowWalk check
local function UpdatePlayerSWalk(detail)
	local j = RWConst.Hestia.IconSlot["ShadowWalk"]
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false

	if detail.currentCooldownRemaining then 
		local v = math.floor(detail.currentCooldownRemaining)
		if v ~= Icon.PlayerValue then Icon:SetPlayerValue(v, MTools.GetShortTimeStr(v))	end
	elseif Icon.PlayerValue ~= -1 then
		Icon:SetPlayerValue(-1, RWConst.Hestia.msgReady)		
	end
end

-- Vitality check
local function UpdatePlayerVitality()

	local v = RWRoot.player.vitality
	local j = RWConst.Hestia.IconSlot["SoulHealth"]
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false
		
	-- Update value!
	if Icon.PlayerValue ~= v then -- data changed, update!
		if (v == 100) and (Icon.PlayerValue < 100) then 
			MedicDetected()
			local stat = RWRoot.Hestia.SessionReport.selfBuffStat
			stat.TotalSoulHealed = stat.TotalSoulHealed + 100 - Icon.PlayerValue
			stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1
		end
		local s = tostring(v) .. "%"
		Icon:SetPlayerValue(v, s)
	end	
	
	-- "Your vita is not full for an opti raid" end check!
	if RWRoot.Hestia.NotFullVitaWarn and
		((not RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[j]) or (RWRoot.CurrentTime > RWRoot.Hestia.VitaWarnTimeLimit) or (v == 100)) 
	then
		RWRoot.Hestia.NotFullVitaWarn = false
		MedicWarnDone = false -- to force the check
		ShowWarningMessage()
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end
	
	-- "A medic is up" end check!
	if MedicWarnDone and 
		((not RWRoot.Hestia.MedicUp) or (v == 100) or (not RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[j]))
	then
		MedicWarnDone = false
		ShowWarningMessage()
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end

	-- warnings check
	if (v < 100) then
		if RWRoot.Hestia.MedicUp then -- Medic is up and our health is low
			if (not MedicWarnDone) and RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[j] then 
				MedicWarnDone = true
				Icon:OverrideSelfWarning(RWConst.Hestia.SelfWarnMsg[j].MedicUp[1], RWConst.Hestia.SelfWarnMsg[j].MedicUp[2])
				ShowWarningMessage()
			end
	
		elseif (v <= RWConfig.Hestia.VitalityWarnLimit) and Icon:CanWarnSelf() then -- Vitality low!
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2]) 
		end
	
	elseif Icon.SelfWarning then -- v = 100, all is good!
		Icon:ClearSelfWarning() 
	end
end

-- common Buff check
local function UpdatePlayerBuff(detail, j, id)
	
	local v = math.floor(detail.remaining)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false

	-- Update value
	if v ~= Icon.PlayerValue then
		if v > Icon.PlayerValue then -- buff taken!
			if Icon.ID ~= id then Icon:LoadIcon(id, detail.icon) end -- New buff type!
			if not InvalidateCycle then
				local stat = RWRoot.Hestia.SessionReport.selfBuffStat
				stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1
			end
		end
		Icon:SetPlayerValue(v, MTools.GetShortTimeStr(v)) 
	end
		
	-- check the time limit
	if v <= RWRoot.Hestia.BuffTimeLimit[j] then
		if Icon:CanWarnSelf() then Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2]) end
	
	elseif Icon.SelfWarning then
		Icon:ClearSelfWarning()
	end	
	
end

local function NoUpdatePlayerBuff(j)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	if Icon.PlayerValue ~= -1 then Icon:SetPlayerValue(-1, RWConst.Hestia.msgOff) end		
	if Icon:CanWarnSelf() then Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].NoUpdate[1], RWConst.Hestia.SelfWarnMsg[j].NoUpdate[2]) end
end

-- Food check (extra check actions needed! detect feast!)
local function UpdatePlayerFood(detail, j)
	
	local v = math.floor(detail.remaining)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false

	-- Update value
	if v ~= Icon.PlayerValue then
		if v > Icon.PlayerValue then -- Food Taken
			if Icon.ID ~= detail.type then Icon:LoadIcon(detail.type, detail.icon) end -- New Food type!
			if not InvalidateCycle then
				if RWData.Hestia.FestinFood[detail.type] and (detail.begin > (RWRoot.CurrentTime - RWConst.Hestia.FoodStartTTL)) then FoodDetected() end
				if (v - Icon.PlayerValue) > RWConst.Hestia.FoodStatUpdateTTL then -- to count only once for players spamming the feast! (like me^^)
					local stat = RWRoot.Hestia.SessionReport.selfBuffStat
					stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1
				end
			end			
		end
		Icon:SetPlayerValue(v, MTools.GetShortTimeStr(v))	
	end	
		
	-- "A feast is up" end check
	if FestinWarnDone and 
		((not RWRoot.Hestia.FoodUp) or (v > RWConst.Hestia.FestinMinWarnTime) or (not RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[j]))
	then
		FestinWarnDone = false
		ShowWarningMessage()
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end
		
	-- Warnings check
	if v <= RWConst.Hestia.FestinMinWarnTime then
		if RWRoot.Hestia.FoodUp then -- Feast detected and ou food buff is low
			if (not FestinWarnDone) and RWConfig.Hestia.ActiveIcon[RWConfig.Hestia.Mode].self[j] then 
				FestinWarnDone = true
				ShowWarningMessage()
				Icon:OverrideSelfWarning(RWConst.Hestia.SelfWarnMsg[j].FestinUp[1], RWConst.Hestia.SelfWarnMsg[j].FestinUp[2])
			end
	
		elseif (v <= RWConfig.Hestia.LongBuffWarnLimit) and Icon:CanWarnSelf() then -- Food time low!
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2]) 
		end 
	
	elseif Icon.SelfWarning then -- all is good!
		Icon:ClearSelfWarning()
	end	
end

-- Planar buff update (extra check actions needed! detect if the harmonisation spell is up!)
local function UpdatePlayerPlanarBuff(detail, j, id)
	
	local v = math.floor(detail.remaining)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false

	-- Check the time limit and if the planar spell is ready to be cast!
	if v <= RWRoot.Hestia.BuffTimeLimit[j] then
		local i = j - RWConst.Hestia.IconSlot["PGraine"] + 1
		if RWRoot.Hestia.CanDoAction.PlanarSpell[i] and (RWRoot.CurrentTime >= RWRoot.Hestia.PlanarSpellTime[i]) then -- spell is ready
			local detail = Inspect.Ability.New.Detail(RWData.Hestia.PlanarSpellID[i])
			if detail and detail.currentCooldownRemaining and (detail.currentCooldownRemaining > RWConst.Hestia.PSpellGCDTTL) then -- the spell was casted!
				RWRoot.Hestia.PlanarSpellTime[i] = RWRoot.CurrentTime + detail.currentCooldownRemaining				
				if Icon.SelfWarning then Icon:ClearSelfWarning() end	
			elseif Icon:CanWarnSelf() then -- Spell is ready! issue a warning
				Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].PSplReady[1], RWConst.Hestia.SelfWarnMsg[j].PSplReady[2])
			end
		elseif (not RWConfig.Hestia.PSpellWarnOnly) and Icon:CanWarnSelf() then -- the spell cant be cast, warn to use a consumable if configured
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2]) 
		end		
	elseif Icon.SelfWarning then Icon:ClearSelfWarning() end -- we are at max, clear the warning if set	
	
	-- Update value
	if v ~= Icon.PlayerValue then 
		if v > Icon.PlayerValue then -- buff taken!
			if Icon.ID ~= id then Icon:LoadIcon(id, detail.icon) end -- New buff type!
			if not InvalidateCycle then
				local stat = RWRoot.Hestia.SessionReport.selfBuffStat
				stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1
				if RWData.Hestia.PlanarSpellBuffID[id] then -- a spell was used!
					local i = j - RWConst.Hestia.IconSlot["PGraine"] + 1
					stat.PBuffWithSpell[i] = stat.PBuffWithSpell[i] + 1
				end
			end
		end
		Icon:SetPlayerValue(v, MTools.GetShortTimeStr(v))
	end	
	
end

-- Planar buff not updated! (extra check actions needed! detect if the harmonisation spell is up!)
local function NoUpdatePlayerPlanarBuff(j)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	local i = j - RWConst.Hestia.IconSlot["PGraine"] + 1
	
	if RWRoot.Hestia.CanDoAction.PlanarSpell[i] and (RWRoot.CurrentTime >= RWRoot.Hestia.PlanarSpellTime[i]) then -- spell is ready
		if Icon.PlayerValue ~= -2 then Icon:SetPlayerValue(-2, RWConst.Hestia.msgReady) end
		local detail = Inspect.Ability.New.Detail(RWData.Hestia.PlanarSpellID[i])
		if detail and detail.currentCooldownRemaining then -- the spell was casted!
			RWRoot.Hestia.PlanarSpellTime[i] = RWRoot.CurrentTime + detail.currentCooldownRemaining				
			if Icon.SelfWarning then Icon:ClearSelfWarning() end	
		elseif Icon:CanWarnSelf() then -- Spell is ready! issue a warning
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].PSplReady[1], RWConst.Hestia.SelfWarnMsg[j].PSplReady[2])
		end
	else
		if Icon.PlayerValue ~= -1 then Icon:SetPlayerValue(-1, RWConst.Hestia.msgOff) end
		if (not RWConfig.Hestia.PSpellWarnOnly) and Icon:CanWarnSelf() then -- the spell cant be cast, warn to use a consumable if configured
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].NoUpdate[1], RWConst.Hestia.SelfWarnMsg[j].NoUpdate[2])
		end
	end		
end

-- Main hand check (extra check actions needed! detect offhand actions!)
local function UpdatePlayerMainHand(detail, j, id)
	if IconNeedUpdate[j] then -- not updated yet! do the update!
		UpdatePlayerBuff(detail, j, id)
	else -- already updated! 2nd buff must be for the offhand, directing to it!
		UpdatePlayerBuff(detail, RWConst.Hestia.IconSlot["OffHand"], id)
	end	
end

-- Player OffHand not updated, check it!
local function NoUpdatePlayerOffHand(j)	
	if Inspect.Item.Detail("seqp.hof") then -- Offhand equiped! do the warning!
		NoUpdatePlayerBuff(j) 
	else -- No Offhand equiped
		local Icon = RWRoot.Hestia.Frame.Icon[j]
		if Icon.PlayerValue ~= -1 then Icon:SetPlayerValue(-1, RWConst.Hestia.msgOff) end
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end 
end

-- Main hand extra check (if the player is tanking!)
local function UpdatePlayerTankBuff(detail, j, id)
	if RWRoot.player.role and (RWRoot.player.role == "tank") then
		UpdatePlayerBuff(detail, j, id)	
	end
end


local function UpdatePlayerPotion()
end

local function UpdatePlayerBag()
end


-- Raid check list ------------------------------------------------------------------------------------------------------

-- Planar check
local function UpdateRaidPlanar(i)

	local v = RWRoot.RaidMember[i].planar
	IconNeedUpdate[RWConst.Hestia.IconSlot["Planar"]] = false
	
	-- update raid data
	ActualPlanar = ActualPlanar + v
	ActualPlanarMax = ActualPlanarMax + RWRoot.RaidMember[i].planarMax
	if v >= 3 then ActualPlanar3 = ActualPlanar3 + 1 end
end

-- Vitality check
function UpdateRaidVitality(i)

	local v = RWRoot.RaidMember[i].vitality
	local j = RWConst.Hestia.IconSlot["SoulHealth"]
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false
	
	if v == 100 then	-- Member have healed!
		if Icon.RaidValue[i] < 100 then 
			local stat = RWRoot.Hestia.SessionReport.raidBuffStat
			stat.TotalSoulHealed = stat.TotalSoulHealed + 100 - Icon.RaidValue[i]
			stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1			
			if (not RWRoot.RaidMember[i].blocked) and (Icon.RaidID[i] == RWRoot.RaidMember[i].id) then -- the member is near! Medic detected!
				MedicDetected() 
			end 
		end 
	elseif RWRoot.Hestia.MedicUp and Icon:CanWarnRaid() then	-- soul health not full and medic up!
		Icon:SetRaidWarning(RWConst.Hestia.RaidWarnMsg[j].MedicUp[1], 
			string.format(RWConst.Hestia.RaidWarnMsg[j].MedicUp[2], RWRoot.RaidMember[i].name, v))
	end
	Icon.RaidValue[i] = v
	Icon.RaidID[i] = RWRoot.RaidMember[i].id
	
	if (v < Icon.RaidMinValue) or ((i == Icon.RaidMinIndex) and (v ~= Icon.RaidMinValue)) then -- Min value changed
		local s = tostring(v) .. "%"
		Icon:SetRaidMinValue(i, v, s)
	end
	
	if i == Icon.RaidMinIndex then
		if v <= RWConfig.Hestia.VitalityWarnLimit then -- Vitality low!
			if Icon:CanWarnRaid() then Icon:SetRaidWarning(
				string.format(RWConst.Hestia.RaidWarnMsg[j].Warning[1], RWRoot.RaidMember[i].name, v), 
				RWConst.Hestia.RaidWarnMsg[j].Warning[2])
			end
		
		elseif Icon.RaidWarning and ((v == 100) or (not RWRoot.Hestia.MedicUp)) then -- all is good!
			Icon:ClearRaidWarning()
		end
	end
	
end

-- common buff check
local function UpdateRaidBuff(i, detail, j)
	
	local v = math.floor(detail.remaining)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false

	-- Report stat update
	--if (v > Icon.RaidValue[i]) then
	--	local stat = RWRoot.Hestia.SessionReport.raidBuffStat
	--	stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1		
	--end
	--Icon.RaidValue[i] = v
	
	-- Update Value
	if (v < Icon.RaidMinValue) or ((i == Icon.RaidMinIndex) and (v ~= Icon.RaidMinValue)) then -- Min value changed
		Icon:SetRaidMinValue(i, v, MTools.GetShortTimeStr(v))
	end
	
	-- check the time limit
	if i == Icon.RaidMinIndex then
		if v <= RWRoot.Hestia.BuffTimeLimit[j] then
			if Icon:CanWarnRaid() then Icon:SetRaidWarning(
				string.format(RWConst.Hestia.RaidWarnMsg[j].Warning[1], RWRoot.RaidMember[i].name, MTools.GetShortTimeStr(v)), 
				RWConst.Hestia.RaidWarnMsg[j].Warning[2]) 
			end
		
		elseif Icon.RaidWarning then -- all is good!
			Icon:ClearRaidWarning()
		end
	end
end

local function NoUpdateRaidBuff(i, j)
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	if Icon.RaidMinValue ~= -1 then Icon:SetRaidMinValue(i, -1, RWConst.Hestia.msgOff) end		
	if Icon:CanWarnRaid() then Icon:SetRaidWarning(
		string.format(RWConst.Hestia.RaidWarnMsg[j].NoUpdate[1], RWRoot.RaidMember[i].name), RWConst.Hestia.RaidWarnMsg[j].NoUpdate[2]) end
end

-- Food check
local function UpdateRaidFood(i,detail)
	
	local v = math.floor(detail.remaining)
	local j = RWConst.Hestia.IconSlot["Food"]
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	IconNeedUpdate[j] = false
	
	if (v > Icon.RaidValue[i]) then -- new food taken!
		if RWData.Hestia.FestinFood[detail.type] and (not RWRoot.RaidMember[i].blocked) and (RWRoot.RaidMember[i].id == Icon.RaidID[i]) 
		and (not InvalidateCycle)
		then 
			FoodDetected() 
		end
		if (v - Icon.RaidValue[i]) > RWConst.Hestia.FoodStatUpdateTTL then -- to count only once for players spamming the feast!
			local stat = RWRoot.Hestia.SessionReport.raidBuffStat
			stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + 1		
		end		
	elseif (v < RWConst.Hestia.FestinMinWarnTime) and RWRoot.Hestia.FoodUp and (not RWRoot.RaidMember[i].blocked) and Icon:CanWarnRaid() then
		Icon:SetRaidWarning(RWConst.Hestia.RaidWarnMsg[j].FestinUp[1], string.format(RWConst.Hestia.RaidWarnMsg[j].FestinUp[2], RWRoot.RaidMember[i].name, MTools.GetShortTimeStr(v)))
	end
	Icon.RaidValue[i] = v
	Icon.RaidID[i] = RWRoot.RaidMember[i].id
	
	if (v < Icon.RaidMinValue) or ((i == Icon.RaidMinIndex) and (v ~= Icon.RaidMinValue)) then -- Min value changed
		Icon:SetRaidMinValue(i, v, MTools.GetShortTimeStr(v))
	end		
		
	-- check the time limit
	if i == Icon.RaidMinIndex then
		if v <= RWConfig.Hestia.LongBuffWarnLimit then
			if Icon:CanWarnRaid() then Icon:SetRaidWarning(
				string.format(RWConst.Hestia.RaidWarnMsg[j].Warning[1], RWRoot.RaidMember[i].name, MTools.GetShortTimeStr(v)), 
				RWConst.Hestia.RaidWarnMsg[j].Warning[2]) end
		
		elseif Icon.RaidWarning and ((v > RWConst.Hestia.FestinMinWarnTime) or (not RWRoot.Hestia.FoodUp)) then -- all is good!
			Icon:ClearRaidWarning()
		end
	end
end

-- Main hand check (extra check actions needed! detect offhand actions!)
local function UpdateRaidMainHand(i, detail, j)
	if IconNeedUpdate[j] then -- not updated yet! do the update!
		UpdateRaidBuff(i, detail, j)
		if RWData.Hestia.Weapon2H[detail.rune] then -- Two hand weapon buff detected! disable the NeedUpdate for the Offhand
			IconNeedUpdate[RWConst.Hestia.IconSlot["OffHand"]] = false
		end		
	else -- already updated! 2nd buff must be for the offhand, directing to it!
		UpdateRaidBuff(i, detail, RWConst.Hestia.IconSlot["OffHand"])
	end	
end

-- Tank buff extra check (if the member is tanking!)
local function UpdateRaidTankBuff(i, detail, j)
	if RWRoot.RaidMember[i].role and (RWRoot.RaidMember[i].role == "tank") then
		UpdateRaidBuff(i, detail, j)	
	end
end

-- Check Functions init ------------------------------------------------------------------------

-- Self

-- Update
SelfCheckFunction["Planar"] 	= nil
SelfCheckFunction["Elixir"] 	= UpdatePlayerBuff
SelfCheckFunction["Food"] 		= UpdatePlayerFood
SelfCheckFunction["MainHand"] 	= UpdatePlayerMainHand
SelfCheckFunction["Gloves"] 	= UpdatePlayerBuff
SelfCheckFunction["Feet"] 		= UpdatePlayerBuff
SelfCheckFunction["PGraine"] 	= UpdatePlayerPlanarBuff
SelfCheckFunction["PTablette"] 	= UpdatePlayerPlanarBuff
SelfCheckFunction["PRune"] 		= UpdatePlayerPlanarBuff
SelfCheckFunction["ShadowWalk"] = nil
SelfCheckFunction["SoulHealth"] = nil
SelfCheckFunction["OffHand"] 	= UpdatePlayerBuff
SelfCheckFunction["Mount"] 		= UpdatePlayerBuff
SelfCheckFunction["HealthPtn"]	= nil
SelfCheckFunction["ManaPtn"] 	= nil
SelfCheckFunction["BagSlot"] 	= nil
SelfCheckFunction["TankMain"]	= UpdatePlayerTankBuff
SelfCheckFunction["TOffhand"]= UpdatePlayerTankBuff
-- NoUpdate
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["Planar"]]		= nil
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["Elixir"]]		= NoUpdatePlayerBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["Food"]]		= NoUpdatePlayerBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["MainHand"]]	= NoUpdatePlayerBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["Gloves"]]		= NoUpdatePlayerBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["Feet"]]		= NoUpdatePlayerBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["PGraine"]]	= NoUpdatePlayerPlanarBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["PTablette"]]	= NoUpdatePlayerPlanarBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["PRune"]]		= NoUpdatePlayerPlanarBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["ShadowWalk"]]	= nil
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["SoulHealth"]]	= nil
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["OffHand"]]	= NoUpdatePlayerOffHand
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["Mount"]]		= NoUpdatePlayerBuff
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["HealthPtn"]]	= nil
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["ManaPtn"]]	= nil
SelfNoUpdateFunction[RWConst.Hestia.IconSlot["BagSlot"]]	= nil

-- Raid

-- Update
RaidCheckFunction["Planar"] 	= nil
RaidCheckFunction["Elixir"] 	= UpdateRaidBuff
RaidCheckFunction["Food"] 		= UpdateRaidFood
RaidCheckFunction["MainHand"] 	= UpdateRaidMainHand
RaidCheckFunction["Gloves"] 	= UpdateRaidBuff
RaidCheckFunction["Feet"] 		= UpdateRaidBuff
RaidCheckFunction["PGraine"] 	= UpdateRaidBuff
RaidCheckFunction["PTablette"] 	= UpdateRaidBuff
RaidCheckFunction["PRune"] 		= UpdateRaidBuff
RaidCheckFunction["ShadowWalk"] = nil
RaidCheckFunction["SoulHealth"] = nil
RaidCheckFunction["OffHand"] 	= UpdateRaidBuff
RaidCheckFunction["Mount"] 		= UpdateRaidBuff
RaidCheckFunction["HealthPtn"]	= nil
RaidCheckFunction["ManaPtn"] 	= nil
RaidCheckFunction["BagSlot"] 	= nil
RaidCheckFunction["TankWeapon"]	= nil
RaidCheckFunction["TankMain"]	= UpdateRaidTankBuff
RaidCheckFunction["TOffhand"]= UpdateRaidTankBuff
-- NoUpdate
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["Planar"]]		= nil
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["Elixir"]]		= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["Food"]]		= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["MainHand"]]	= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["Gloves"]]		= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["Feet"]]		= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["PGraine"]]	= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["PTablette"]]	= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["PRune"]]		= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["ShadowWalk"]]	= nil
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["SoulHealth"]]	= nil
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["OffHand"]]	= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["Mount"]]		= NoUpdateRaidBuff
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["HealthPtn"]]	= nil
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["ManaPtn"]]	= nil
RaidNoUpdateFunction[RWConst.Hestia.IconSlot["BagSlot"]]	= nil

-- Bag Item check
local function UpdateHealthPotion(n)
	nbHealthPotion = nbHealthPotion + n
end

local function UpdateManaPotion(n)
	nbManaPotion = nbManaPotion + n
end

BagCheckFunction["HealthPtn"]	= UpdateHealthPotion
BagCheckFunction["ManaPtn"] 	= UpdateManaPotion

-- Buff Add Handler 
function RWRoot.Hestia.BuffsAdded(handle, id, buffs)
	if GroupState > 0 then
	local PBuffs = Inspect.Buff.Detail(id, buffs)
	for k, v in pairs(PBuffs) do
		if v.type == RWData.Hestia.WalkedBuffIDNew then
			local name = RWRoot.idInRaid(id)
			if name then -- someone have SW! 
				RWRoot.Hestia.WalkedMember = name
				RWRoot.Hestia.SWalkTimeLimit = v.begin + v.remaining
				if DeadWarnActive then ShowWarningMessage() end
			end
		end
	end
	end
end

-- Remove member data 
local function RemoveMemberData(Index)
	RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["SoulHealth"]].RaidValue[Index] = 0x7FFF -- to prevent medic warning 
	RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["Food"]].RaidValue[Index] = 0x7FFF -- to prevent food warning 
	--for i = 1, RWConst.Hestia.FrameData.TotalIcon do
	for i = 2, 13 do
		if RWRoot.Hestia.Frame.Icon[i].RaidMinIndex == Index then 
			RWRoot.Hestia.Frame.Icon[i]:InitRaidValue()
			if RWRoot.Hestia.Frame.Icon[i].RaidWarning then
				RWRoot.Hestia.Frame.Icon[i]:ClearRaidWarning()
			end
		end	
	end
end


-- Refresh main loop ----------------------------------------------------------------

local function InitCheckLoopData()
	doPlayerCheck = true
	ActualPlanar = 0
	ActualPlanarMax = 0
	ActualPlanar3 = 0
	nbMembers = 0
	ReadyCheckDetected = false
	DeathDetected = false
	AllRaidDead = true
	MemberIndex = 0
	RaidChecked = false
	MemberMissed = false
	scScanAvailable = RWRoot.PlayerAvailable
	InvalidateCycle = false
end

-- Bag update cycle finished
local function InitBagLoopData()
	FreeBagSlot = 0
	nbHealthPotion = 0
	nbManaPotion = 0
	RWRoot.Hestia.BagCheckPerFrame = RWConst.Hestia.BagSlowCheck
	bgScanAvailable = RWRoot.PlayerAvailable
end

local function InitCheck()
	ClearWarningMessage()
	RWRoot.Hestia.Frame:InitAll()
	InitCheckLoopData() -- start raid check from the begining
	RWRoot.Hestia.Index = 1 
	InitBagLoopData() -- start bag check from the begining 
	RWRoot.Hestia.BagIndex = 99
	RWRoot.Hestia.nBag = 0
end

local function InvalidateBagCheck()
	
	local Icon = RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["HealthPtn"]]
	if Icon.PlayerValue ~= 0x7FFE then 
		Icon:SetPlayerValue(0x7FFE, "--")
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end
	
	Icon = RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["ManaPtn"]]
	if Icon.PlayerValue ~= 0x7FFE then 
		Icon:SetPlayerValue(0x7FFE, "--")
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end
	
	Icon = RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["BagSlot"]]
	if Icon.PlayerValue ~= 0x7FFE then 
		Icon:SetPlayerValue(0x7FFE, "--")
		if Icon.SelfWarning then Icon:ClearSelfWarning() end
	end	
end

local function UpdateBagCycleDone()
	
	if bgScanAvailable then

	-- all is good, process the data!
	local j = RWConst.Hestia.IconSlot["HealthPtn"]
	local Icon = RWRoot.Hestia.Frame.Icon[j]
	if nbHealthPotion ~= Icon.PlayerValue then 
		local stat = RWRoot.Hestia.SessionReport.selfBuffStat
		local n = Icon.PlayerValue - nbHealthPotion
		Icon:SetPlayerValue(nbHealthPotion, tostring(nbHealthPotion))
		if (n > 0) and (n < 1024) then
			stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + n		
		end
	end	
	if nbHealthPotion <= RWConfig.Hestia.PotionWarnLimit then
		if Icon:CanWarnSelf() then
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2])
		end
	elseif Icon.SelfWarning then
		Icon:ClearSelfWarning()
	end

	j = RWConst.Hestia.IconSlot["ManaPtn"]
	Icon = RWRoot.Hestia.Frame.Icon[j]
	if nbManaPotion ~= Icon.PlayerValue then 
		local stat = RWRoot.Hestia.SessionReport.selfBuffStat
		local n = Icon.PlayerValue - nbHealthPotion
		Icon:SetPlayerValue(nbManaPotion, tostring(nbManaPotion)) 
		if (n > 0) and (n < 1024) then
			stat.nbTimeTaken[j] = stat.nbTimeTaken[j] + n		
		end
	end
	if nbManaPotion <= RWConfig.Hestia.PotionWarnLimit then
		if Icon:CanWarnSelf() then
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2])
		end
	elseif Icon.SelfWarning then
		Icon:ClearSelfWarning()
	end

	j = RWConst.Hestia.IconSlot["BagSlot"]
	Icon = RWRoot.Hestia.Frame.Icon[j]
	if FreeBagSlot ~= Icon.PlayerValue then Icon:SetPlayerValue(FreeBagSlot, tostring(FreeBagSlot)) end
	if FreeBagSlot <= RWConfig.Hestia.BagWarnLimit then
		if Icon:CanWarnSelf() then
			Icon:SetSelfWarning(RWConst.Hestia.SelfWarnMsg[j].Warning[1], RWConst.Hestia.SelfWarnMsg[j].Warning[2])		
		end
	elseif Icon.SelfWarning then
		Icon:ClearSelfWarning()
	end
	
	else -- Loading detected!
		InvalidateBagCheck()
	end
	
end

-- Data update cycle finished
local function UpdateCycleDone()
	RWRoot.Hestia.FrameSkip = RWConfig.Hestia.FrameSkip -- back to normal speed!
	
	-- Queued check processing
	if RWRoot.Hestia.nbQueuedCheck > 0 then
		local i = RWRoot.Hestia.nbQueuedCheck
		while i > 0 do
			if RWRoot.Hestia.QueuedCheck[i]() then DoneQueueCheck(i) end
			i = i - 1
		end	
	end
	
	-- check the raid status and set the raid planar value, issue a walk warning if needed too
	local status = 0

	if scScanAvailable and RaidChecked then
	
	if GroupState > 0 then

		if MemberIndex ~= 0 then -- Raid members in contact and alive!
			local Icon = RWRoot.Hestia.Frame.Icon[RWConst.Hestia.IconSlot["Planar"]]
			if ActualPlanar ~= Icon.RaidMinValue then 
				local n = Icon.RaidMinValue - ActualPlanar
				local stat = RWRoot.Hestia.SessionReport.raidBuffStat
				if n > 0 then
					stat.nbTimeTaken[RWConst.Hestia.IconSlot["Planar"]] = stat.nbTimeTaken[RWConst.Hestia.IconSlot["Planar"]] + n
				else
					stat.TotalPlanarGained = stat.TotalPlanarGained - n
				end			
				Icon:SetRaidMinValue(0, ActualPlanar, tostring(ActualPlanar)) 
			end			
			if MemberMissed then status = RWConst.Hestia.FrameStatus["MemberLost"] end
			if DeadWarnActive then
				DeadWarnActive = false
				ShowWarningMessage()	
			end			
		
		else -- no raid member alive in contact!
			status = RWConst.Hestia.FrameStatus["RaidLost"]	
			if AllRaidDead then
				if not DeadWarnActive then
					DeadWarnActive = true
					ShowWarningMessage()
				end
			elseif DeadWarnActive then
				DeadWarnActive = false
				ShowWarningMessage()	
			end
		end

	end
	-- check the dead!
	if DeathDetected then status = RWConst.Hestia.FrameStatus["DeadInRead"] end

	else -- scan functions were unavailable! setting the loading state!
		status = RWConst.Hestia.FrameStatus["Loading"]
	end

	--RWRoot.Hestia.DeathDetected = DeathDetected
	DoRaidScan = RWConfig.Hestia.DoRaidScan
	if RWRoot.Hestia.Frame.Status ~= status then RWRoot.Hestia.Frame:SetStatus(status) end
	
	--RWRoot.Hestia.ActualPlanar = ActualPlanar
	--RWRoot.Hestia.ActualPlanarMax = ActualPlanarMax
	--RWRoot.Hestia.ActualPlanar3 = ActualPlanarMax	

	-- check the onHold status of the frame
	if (RWRoot.Hestia.Frame.led.state == RWConst.Hestia.ledState["OnHold"]) then CheckOnHold() end
	ReadyCheckInProgress = ReadyCheckDetected
	
	-- Group size check, and auto switch if needed
	if (nbMembers ~= RWRoot.Hestia.nbMembers) or DoAutoCheck then
	RWRoot.Hestia.nbMembers = nbMembers
	DoAutoCheck = false
	if nbMembers >= 11 then -- raid 20
		if RWConfig.Hestia.autoOn and (RWConfig.Hestia.autoSwitchCfg <= 3) and (RWConfig.Hestia.Mode ~= "Opti") then
			SwitchToMode("Opti", true)
		end	
		if GroupState ~= 3 then InitGroupJoin(3) end
		
	elseif nbMembers >= 5 then -- raid 10
		if RWConfig.Hestia.autoOn then
			if RWConfig.Hestia.autoSwitchCfg >= 3 then
				if RWConfig.Hestia.Mode ~= "Cool" then SwitchToMode("Cool", true, RWConfig.Hestia.CoolJoinReact and (GroupState == 0)) end
			elseif (RWConfig.Hestia.autoSwitchCfg <= 2) and (RWConfig.Hestia.Mode ~= "Opti") then
				SwitchToMode("Opti", true)
			end
		end	
		if GroupState ~= 2 then InitGroupJoin(2) end
		
	elseif nbMembers >= 1 then -- group
		if RWConfig.Hestia.autoOn then
			if RWConfig.Hestia.autoSwitchCfg >= 2 then
				if RWConfig.Hestia.Mode ~= "Cool" then SwitchToMode("Cool", true, RWConfig.Hestia.CoolJoinReact and (GroupState == 0)) end
			elseif RWConfig.Hestia.Mode ~= "Opti" then
				SwitchToMode("Opti", true)
			end
		end	
		if GroupState ~= 1 then InitGroupJoin(1) end
	
	else -- alone!
		if RWConfig.Hestia.autoOn and (RWConfig.Hestia.Mode ~= "Cool") then SwitchToMode("Cool", true) end
		if GroupState ~= 0 then
			DoGroupJoinWarn = RWConfig.Hestia.WarnIfNotFull
			InitWarningMessage()
			if RWConfig.Hestia.ShowSessionReport then RWRoot.Hestia.PrintSessionReport() end
			InitGroupJoin(0) 
		end	
	end 
	end
	
end

-- Update cycle!
local function Update1()

	-- check list ---------------------

	-- check self ----------------
	local j = RWConst.Hestia.RaidCheckPerFrame
	local i = RWRoot.Hestia.Index
	local detail, DataList, CheckList
	
	if doPlayerCheck then
		RWRoot.CheckPlayer()
		j = j - 1
		doPlayerCheck = false
		if RWRoot.player and RWRoot.player.health then
			RaidChecked = true
			if RWRoot.player.health > 0 then 
				AllRaidDead = false
				if RWRoot.player.ready ~= nil then ReadyCheckDetected = true end
				IconNeedUpdate = {
					true,	true,	true,	true,	true,	true,	true,	true,
					true,	true,	true,	true,	true,	true,	true,	true				
				}
				-- Check the data --
				-- vitality check
				if RWRoot.player.vitality then UpdatePlayerVitality() end
				-- planar check
				if RWRoot.player.planar then UpdatePlayerPlanar() end
				-- Shadow walk check
				detail = Inspect.Ability.New.Detail(RWData.Hestia.WalkSpellIDNew)
				if detail then UpdatePlayerSWalk(detail) end
				-- Buff & rune check
				if RWRoot.player.calling then
					PCheckList = RWData.Hestia.BuffList[RWConst.Hestia.ClassGroup[RWRoot.player.calling]][RWConfig.Hestia.Mode]
					DataList = Inspect.Buff.List(RWRoot.playerId)
					if DataList then
					detail = Inspect.Buff.Detail(RWRoot.playerId, DataList)
					for _, v in pairs(detail) do
						if v.type then
							if PCheckList[v.type] then SelfCheckFunction[PCheckList[v.type]](v, RWConst.Hestia.IconSlot[PCheckList[v.type]], v.type) end
						elseif v.rune and PCheckList[v.rune] then 
							SelfCheckFunction[PCheckList[v.rune]](v, RWConst.Hestia.IconSlot[PCheckList[v.rune]], v.rune)
						end
					end
					end
				end	
			
				-- Update the status of the data if no update found --
				--for k = 1, RWConst.Hestia.FrameData.TotalIcon do 
				for k = 2, 13 do 
					if IconNeedUpdate[k] and SelfNoUpdateFunction[k] then SelfNoUpdateFunction[k](k) end
				end	
			else DeathDetected = true end
		end			
	end
	
	-- check raid ----------------
	while j > 0 do
		RWRoot.CheckMember(i)
		local Member = RWRoot.RaidMember[i]
		if Member and (Member.id ~= RWRoot.playerId) then
			nbMembers = nbMembers + 1
			if Member.name and Member.health and Member.coordX then
			RaidChecked = true
			if Member.health > 0 then
				RWRoot.Hestia.MemberLost[i] = false
				AllRaidDead = false
				MemberIndex = i
				if DoRaidScan then -- no update if the scan is disabled
				if Member.ready ~= nil then ReadyCheckDetected = true end
				IconNeedUpdate = {
					true,	true,	true,	true,	true,	true,	true,	true,
					true,	true,	true,	true,	true,	true,	true,	true				
				}	
				-- Check the data --
				-- vitality check
				if Member.vitality then UpdateRaidVitality(i) end
				-- planar check
				if Member.planar then UpdateRaidPlanar(i) end
				-- Buff & rune check
				if Member.calling then
					CheckList = RWData.Hestia.BuffList[RWConst.Hestia.ClassGroup[Member.calling]][RWConfig.Hestia.Mode]
					DataList = Inspect.Buff.List(Member.id)	
					if DataList then
					detail = Inspect.Buff.Detail(Member.id, DataList)
					for _, v in pairs(detail) do
						if v.type then 
							if CheckList[v.type] then RaidCheckFunction[CheckList[v.type]](i, v, RWConst.Hestia.IconSlot[CheckList[v.type]]) end
						elseif v.rune and CheckList[v.rune] then 
							RaidCheckFunction[CheckList[v.rune]](i, v, RWConst.Hestia.IconSlot[CheckList[v.rune]])
						end
					end 
					end
				end
			
				-- Update the status of the data if no update found --
				--for k = 1, RWConst.Hestia.FrameData.TotalIcon do 
				for k = 2, 13 do 
					if IconNeedUpdate[k] and RaidNoUpdateFunction[k] then RaidNoUpdateFunction[k](i, k) end
				end
				end
			else DeathDetected = true end
			else 
				MemberMissed = true
				if not RWRoot.Hestia.MemberLost[i] then
					RWRoot.Hestia.MemberLost[i] = true
					RemoveMemberData(i)
				end
			end
		end

		i = i + 1
		j = j - 1
		if i > 20 then 
			j = j - 1
			i = 1
			UpdateCycleDone()
			InitCheckLoopData()
		end		
	end

	RWRoot.Hestia.Index = i
end
	
local function Update2()

	-- check inventory ----------------
	if PCheckList then

	local j = RWRoot.Hestia.BagCheckPerFrame
	local i = RWRoot.Hestia.BagIndex
	local s = RWRoot.Hestia.CurrentBag
	local detail

	while j > 0 do
		if i > RWRoot.Hestia.nBagSize then
			RWRoot.Hestia.nBag = RWRoot.Hestia.nBag + 1
			if RWRoot.Hestia.nBag > 7 then
				UpdateBagCycleDone()
				InitBagLoopData()
				RWRoot.Hestia.nBag = 1
			end
			detail = Inspect.Item.Detail(("sibg.0"..MTools.strIndex[RWRoot.Hestia.nBag]))
			s = MTools.bagIndex[RWRoot.Hestia.nBag]
			RWRoot.Hestia.CurrentBag = s
			if detail and detail.slots then
				RWRoot.Hestia.nBagSize = detail.slots			
			else
				RWRoot.Hestia.nBagSize = 0
			end
			i = 1
			break -- dont do more than 1 bag per frame (and simplify the loop this way!)
		end	
		
		detail = Inspect.Item.Detail(s..MTools.strIndex[i])
		if detail then
			if detail.stack and PCheckList[detail.id] then BagCheckFunction[PCheckList[detail.id]](detail.stack) end
		else
			FreeBagSlot = FreeBagSlot + 1
		end
		
		i = i + 1
		j = j - 1
	end
	RWRoot.Hestia.BagIndex = i
	
	end
	
	-- Update Frame!
	if RWRoot.Hestia.Frame:GetVisible() then RWRoot.Hestia.Frame:Update() end
	if FlashWarnText then HWarnMessage:FlashText() end
end

local function UpdateFlashing()
	if RWRoot.Hestia.Frame:GetVisible() then RWRoot.Hestia.Frame:Update() end
	if FlashWarnText then HWarnMessage:FlashText() end
end

UpdateFunction[1] = Update1
UpdateFunction[2] = Update2
UpdateFunction[3] = nil
UpdateFunction[4] = UpdateFlashing
UpdateFunction[5] = nil
UpdateFunction[6] = UpdateFlashing

local function UpdateAll()
	if RWRoot.PlayerAvailable and (not RWConfig.Hestia.OffMode) then
		Update1()
		Update2()	
	end	
end

local function FrameSkipUpdate()
	if (not RWConfig.Hestia.OffMode) and UpdateFunction[FPSIndex] and RWRoot.PlayerAvailable then UpdateFunction[FPSIndex]() end
	FPSIndex = FPSIndex + 1
	if FPSIndex > RWRoot.Hestia.FrameSkip then FPSIndex = 1 end
end

local function InitUpdateFunction()
	RWRoot.Hestia.FrameSkip = RWConfig.Hestia.FrameSkip
	if RWConfig.Hestia.FrameSkip == 1 then
		RWRoot.Hestia.Update = UpdateAll	
	else
		RWRoot.Hestia.Update = FrameSkipUpdate
		FPSIndex = 1
	end
end


-- sqst.xxx objets de quete, xxx: numero du slot
-- swnn.xxx costumes, nn numero, xxx: slot
-- sinn.xxx slot d'un sac, nn == numero du sac, xxx = numero du slot
-- sibg.xxx slot des sacs d'inventaire, xxx = numero du slot.
-- sbnn.xxx slot d'un sac de banque, nn == numero du sac, xxx = numero du slot
-- seqp.xxx Equipement equipé, xxx = id du slot:
---- fet: pieds
---- hof: off hand
---- lgs: Pantalon
---- glv: gants
---- hmn: main hand   / category: "weapon twohand staff"

-- More functions! ---------------------------------------------------------

function RWRoot.Hestia.AvailabilityLow()
	bgScanAvailable = false
	scScanAvailable = false
end

function RWRoot.Hestia.AvailabilityFull()
	bgScanAvailable = true
	scScanAvailable = true
	InitCheck()
	InvalidateCycle = true
end

function SetHTextPos()
	MTools.ClearPoints(HWarnMessage)
	HWarnMessage:SetPoint("CENTER", UIParent, "CENTER", 0, -90)
end

-- Enter/leave combat ----
function RWRoot.Hestia.CombatStart()
	HWarnMessage:VisibleTo(false)
	RWRoot.Hestia.Frame:SetInCombatState()	
	SessionCombatStartTime = RWRoot.CurrentTime
	if RWRoot.Hestia.SessionReport.FirstCombatBeginTime == 0 then RWRoot.Hestia.SessionReport.FirstCombatBeginTime = RWRoot.CurrentTime	end	
end
	
function RWRoot.Hestia.CombatEnds()
	-- update the session report
	RWRoot.Hestia.SessionReport.LastCombatEndTime = RWRoot.CurrentTime	
	local fightTime = RWRoot.CurrentTime - SessionCombatStartTime
	if fightTime >= RWConst.Hestia.BattleTimeTTL then RWRoot.Hestia.SessionReport.nbCombats = RWRoot.Hestia.SessionReport.nbCombats + 1 end
	if fightTime >= RWConst.Hestia.LongFightTime then RWRoot.Hestia.SessionReport.nbLongCombats = RWRoot.Hestia.SessionReport.nbLongCombats + 1 end
	if fightTime >= RWRoot.Hestia.SessionReport.LongestFightTime then RWRoot.Hestia.SessionReport.LongestFightTime = fightTime end
	RWRoot.Hestia.SessionReport.TotalCombatTime = RWRoot.Hestia.SessionReport.TotalCombatTime + fightTime	

	-- Init the check!
	SetHTextPos()
	InitCheck()
	RWRoot.Hestia.Frame:SetStatus(RWConst.Hestia.FrameStatus["DeadInRead"]) -- to prevent popup!	
	DoRaidScan = false -- Disable the raid scan to check the dead first!
	if RWRoot.Hestia.FrameSkip > 2 then -- raid will not be checked, speed up the cycle then to update faster!
		RWRoot.Hestia.FrameSkip = 2
		FPSIndex = 1
	end 
	-- start bag check from the begining but with fast speed! (while we are not checking the raid! faster potion consumption check!)
	RWRoot.Hestia.BagCheckPerFrame = RWConst.Hestia.BagFastCheck
	
	-- Clear onHold state if needed
	if RWRoot.Hestia.Frame.led.state == RWConst.Hestia.ledState["OnHold"] then
		if RWConfig.Hestia.ReactivateCondition == 3 then
			ClearOnHold() 
		elseif (not SoloFightWarned) and RWConfig.Hestia.SoloFightReact and (GroupState == 0) then 
			ClearOnHold() 
			SoloFightWarned = true
			QueueCheck(CheckSoloFightTTL)
		end
	end	
end

-- InitData
local function InitData()

	RWRoot.Hestia.BuffTimeLimit = {
		0,
		RWConfig.Hestia.LongBuffWarnLimit,
		RWConfig.Hestia.LongBuffWarnLimit,
		RWConfig.Hestia.LongBuffWarnLimit,
		RWConfig.Hestia.LongBuffWarnLimit,
		RWConfig.Hestia.LongBuffWarnLimit,
		RWConfig.Hestia.ShortBuffWarnLimit,
		RWConfig.Hestia.ShortBuffWarnLimit,
		RWConfig.Hestia.ShortBuffWarnLimit,
		0,
		0,
		RWConfig.Hestia.LongBuffWarnLimit,
		RWConfig.Hestia.LongBuffWarnLimit,
		0,
		0,
		0
	}
	
	FrameCoord.height = math.floor(FrameData.height * RWConfig.Hestia.Scale)
	FrameCoord.width = math.floor(FrameData.width * RWConfig.Hestia.Scale)
	
	FrameCoord.DataHeight = math.floor(RWConst.Hestia.FrameData.DataHeight * RWConfig.Hestia.Scale)
	FrameCoord.DataWidth = math.floor(RWConst.Hestia.FrameData.DataWidth * RWConfig.Hestia.Scale)
	FrameCoord.DataDY = math.floor(RWConst.Hestia.FrameData.DataDY * RWConfig.Hestia.Scale)
	FrameCoord.DataTextSize = math.floor(RWConst.Hestia.FrameData.DataTextSize * RWConfig.Hestia.Scale)
	FrameCoord.IconSize = math.floor(RWConst.Hestia.FrameData.IconSize * RWConfig.Hestia.Scale)

	FrameCoord.btnWidth = math.floor(RWConst.Hestia.FrameData.btnWidth * RWConfig.Hestia.Scale)
	FrameCoord.btnHeight = math.floor(RWConst.Hestia.FrameData.btnHeight * RWConfig.Hestia.Scale)
	FrameCoord.bigBtnSize = math.floor(RWConst.Hestia.FrameData.bigBtnSize * RWConfig.Hestia.Scale)
	FrameCoord.smallBtnSize = math.floor(RWConst.Hestia.FrameData.smallBtnSize * RWConfig.Hestia.Scale)
	
	FrameCoord.InfoTextSize = math.floor(RWConst.Hestia.FrameData.InfoTextSize * RWConfig.Hestia.Scale)
	if FrameCoord.InfoTextSize < RWConst.Hestia.FrameData.InfoMinSize then FrameCoord.InfoTextSize = RWConst.Hestia.FrameData.InfoMinSize end
	FrameCoord.InfoFrameX0 = RWConst.Hestia.FrameData.InfoFrameX0
	FrameCoord.InfoFrame2X = FrameCoord.InfoFrameX0 * 2
	FrameCoord.InfoFrameY0 = RWConst.Hestia.FrameData.InfoFrameY0
	FrameCoord.InfoFrame3Y = FrameCoord.InfoFrameY0 * 3
	
	for i = 1, RWConst.Hestia.FrameData.TotalFrameBtn do
		FrameCoord.btnCoord[i][1] = math.floor(FrameData.btnCoord[i][1] * RWConfig.Hestia.Scale)
		FrameCoord.btnCoord[i][2] = math.floor(FrameData.btnCoord[i][2] * RWConfig.Hestia.Scale)
	end	
	for i = 1, RWConst.Hestia.FrameData.TotalIcon do
		FrameCoord.IconCoord[i][1] = math.floor(FrameData.Icon[i].Coord[1] * RWConfig.Hestia.Scale)
		FrameCoord.IconCoord[i][2] = math.floor(FrameData.Icon[i].Coord[2] * RWConfig.Hestia.Scale)
		FrameCoord.DataCoord[i][1] = math.floor(FrameData.Icon[i].DataCoord[1] * RWConfig.Hestia.Scale)
		FrameCoord.DataCoord[i][2] = math.floor(FrameData.Icon[i].DataCoord[2] * RWConfig.Hestia.Scale)
	end
	FrameCoord.StateIcon[1] = math.floor(FrameData.StateIcon[1] * RWConfig.Hestia.Scale)
	FrameCoord.StateIcon[2] = math.floor(FrameData.StateIcon[2] * RWConfig.Hestia.Scale)	
end

function RWRoot.Hestia.InitAddon()
	InitCheckLoopData()
	RWRoot.Hestia.Index = 1
	InitBagLoopData() 
	RWRoot.Hestia.BagIndex = 99
	RWRoot.Hestia.nBag = 0	
	DoGroupJoinWarn = RWConfig.Hestia.WarnIfNotFull
	
	InitUpdateFunction()
	RWRoot.Hestia.InitSessionReport()
	
	InitData()
	if not RWRoot.Hestia.Frame then buildHestiaFrame() end
	
	if RWConfig.Hestia.onHoldonSolo then
		if RWConfig.Hestia.ReactivateCondition ~= 4 then
			SetFrameOnHold()
		else
			SetFramePopupOff()
		end
	elseif RWRoot.Hestia.Frame.led.state == RWConst.Hestia.ledState["OnHold"] then 
		RWRoot.Hestia.Frame:SetLedOn() 
	end
	
	HWarnMessage = RWRoot.AssignRWText(1)
	SetHTextPos()

	InitGroupJoin(0)

	DoRaidScan = RWConfig.Hestia.DoRaidScan	
	QueueCheck(ScanPlayerCapabilities)
end

function RWRoot.Hestia.ShowFrame()
	if RWRoot.Hestia.Frame then RWRoot.Hestia.Frame:OpenFrame() end
end

local function UpdateConfigChanges()
	InitUpdateFunction()
	InitData()	
	InitWarningMessage()
	
	if RWRoot.Hestia.Frame and (not RWConfig.Hestia.OffMode) then
		RWRoot.Hestia.Frame:InitAll()
		SwitchToMode(RWConfig.Hestia.Mode)		
	end	
end	


-- Activate/Desactivate -----------------------------------------------------------

-- Activate
function RWRoot.Hestia.Activate(forceActivate)
	if (not RWConfig.Hestia.Active) or forceActivate then
		print(RWRoot.locTxt.Hestia.ModActivated)
		RWConfig.Hestia.Active = true
		RWRoot.Hestia.InitAddon()
	end
end

-- Desactivate
function RWRoot.Hestia.Desactivate(forceDesactivate)
	if RWConfig.Hestia.Active or forceDesactivate then
		if RWRoot.Hestia.Frame then 
			RWRoot.Hestia.Frame:CloseFrame() 
			RWRoot.Hestia.Frame:InitAll()
		end
		RWConfig.Hestia.Active = false
		print(RWRoot.locTxt.Hestia.ModDesactivated)
	end
end


-- Config Window ----------------------------------------------------------------------------


local function BuildConfigWindow()

	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)
		
	window:SetTitle(RWRoot.locTxt.Hestia.ModuleName)
	window:SetWidth(805)
	window:SetHeight(720)
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	window.BackImage = UI.CreateFrame("Texture", "BackImage", window)
	window.BackImage:SetLayer(-1)
	window.BackImage:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 61)
	window.BackImage:SetTexture(RWData.AddonIdentifier, "resources\\Hestia\\HestiaImg2.jpg")
	
	MTools.buildWindowMover("ConfigWindow", window)
	
	
	-- boutons
	window.bbClose =  MTools.buildButton("btClose", window, 50, 50, "x", "close")
	window.bbClose:SetPoint("TOPRIGHT", window, "TOPRIGHT", -8, 15)

	window.btOk =  MTools.buildButton("btOk", window, 110, 40, RWRoot.locTxt.buttonOk)
	window.btOk:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 40, -25)

	window.btCancel =  MTools.buildButton("btAnnuler", window, 110, 40, RWRoot.locTxt.buttonCancel)
	window.btCancel:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 160, -25)
		
	window.btHestia =  MTools.buildButton("btHestia", window, 110, 40, RWRoot.locTxt.Hestia.ModuleName)
	window.btHestia:SetPoint("BOTTOMRIGHT", window, "BOTTOMRIGHT", -40, -25)
		
	-- Comportement
	window.ttBehaviorTitle = MTools.buildShadowTitle("ttBehaviorTitle", window, 380, 25, RWRoot.locTxt.Behaviour)
	window.ttBehaviorTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 25, 70)
	
	window.autoIcon = UI.CreateFrame("Texture", "CFGautoIcon", window)
	window.autoIcon:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.btnPath[1])
	window.autoIcon:SetPoint("TOPLEFT", window.ttBehaviorTitle, "TOPLEFT", 10, 36)
		
	window.rgautoSwitchCfg = MTools.buildRadioGroup("rgautoSwitchCfg", window, 360, 20, RWRoot.locTxt.Hestia.cfgAutoSwitch, 1, 
		{ RWRoot.locTxt.Hestia.cfgAutoSwitchOpt1, RWRoot.locTxt.Hestia.cfgAutoSwitchOpt2, RWRoot.locTxt.Hestia.cfgAutoSwitchOpt3 }, 55)
	window.rgautoSwitchCfg:SetPoint("TOPLEFT", window.ttBehaviorTitle, "TOPLEFT", 65, 35)
	
	window.ckWarnIfNotFull = MTools.buildCheckBox("ckWarnIfNotFull", window, 360, 20, RWRoot.locTxt.Hestia.cfgCheckMaxatJoin)
	window.ckWarnIfNotFull:SetPoint("TOPLEFT", window.rgautoSwitchCfg, "TOPLEFT", -55, 100)
	
	window.ledIcon = UI.CreateFrame("Texture", "CFGledIcon", window)
	window.ledIcon:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.ledPath[4])
	window.ledIcon:SetPoint("TOPLEFT", window.ckWarnIfNotFull, "TOPLEFT", 00, 35)	

	window.txReactivateCondition1 = MTools.buildText("txReactivateCondition1", window, RWRoot.locTxt.Hestia.cfgForcedClose1, 15)
	window.txReactivateCondition1:SetPoint("TOPLEFT", window.ckWarnIfNotFull, "TOPLEFT", 40, 35)

	window.rgReactivateCondition = MTools.buildRadioGroup("rgReactivateCondition", window, 360, 20, RWRoot.locTxt.Hestia.cfgForcedClose2, 1, 
		{ RWRoot.locTxt.Hestia.cfgReactivateOpt1, RWRoot.locTxt.Hestia.cfgReactivateOpt2, RWRoot.locTxt.Hestia.cfgReactivateOpt3, RWRoot.locTxt.Hestia.cfgReactivateOpt4 },40)
	window.rgReactivateCondition:SetPoint("TOPLEFT", window.txReactivateCondition1, "TOPLEFT", 0, 20)
	
	window.ckonHoldonAuto = MTools.buildCheckBox("ckonHoldonAuto", window, 360, 20, RWRoot.locTxt.Hestia.cfgSameForAuto)
	window.ckonHoldonAuto:SetPoint("TOPLEFT", window.rgReactivateCondition, "TOPLEFT", -40, 120)

	window.ckCoolJoinReact = MTools.buildCheckBox("ckCoolJoinReact", window, 360, 20, RWRoot.locTxt.Hestia.cfgCoolJoinReact)
	window.ckCoolJoinReact:SetPoint("TOPLEFT", window.ckonHoldonAuto, "TOPLEFT", 0, 25)

	window.ckSoloFightReact = MTools.buildCheckBox("ckSoloFightReact", window, 360, 20, RWRoot.locTxt.Hestia.cfgSoloFightReact)
	window.ckSoloFightReact:SetPoint("TOPLEFT", window.ckCoolJoinReact, "TOPLEFT", 0, 25)

	window.ckonHoldonSolo = MTools.buildCheckBox("ckonHoldonSolo", window, 360, 20, RWRoot.locTxt.Hestia.cfgonHoldonSolo)
	window.ckonHoldonSolo:SetPoint("TOPLEFT", window.ckSoloFightReact, "TOPLEFT", 0, 25)

	window.WarnIcon = UI.CreateFrame("Texture", "CFGWarnIcon", window)
	window.WarnIcon:SetTexture(RWData.AddonIdentifier, RWConst.Hestia.FrameData.WarnIconPath.self)
	window.WarnIcon:SetPoint("TOPLEFT", window.ckonHoldonSolo, "TOPLEFT", 0, 40)
	
	window.ckDoMedicWarning = MTools.buildCheckBox("ckDoMedicWarning", window, 360, 20, RWRoot.locTxt.Hestia.cfgDoMedicWarning)
	window.ckDoMedicWarning:SetPoint("TOPLEFT", window.ckonHoldonSolo, "TOPLEFT", 55, 40)

	window.ckDoFoodWarning = MTools.buildCheckBox("ckDoFoodWarning", window, 360, 20, RWRoot.locTxt.Hestia.cfgDoFoodWarning)
	window.ckDoFoodWarning:SetPoint("TOPLEFT", window.ckDoMedicWarning, "TOPLEFT", 0, 25)

	window.ckPSpellWarnOnly = MTools.buildCheckBox("ckPSpellWarnOnly", window, 360, 20, RWRoot.locTxt.Hestia.cfgPSpellWarnOnly)
	window.ckPSpellWarnOnly:SetPoint("TOPLEFT", window.ckDoFoodWarning, "TOPLEFT", -55, 25)

	window.ckShowSessionReport = MTools.buildCheckBox("ckShowSessionReport", window, 360, 20, RWRoot.locTxt.Hestia.cfgShowReport)
	window.ckShowSessionReport:SetPoint("TOPLEFT", window.ckPSpellWarnOnly, "TOPLEFT", 0, 40)

	window.ckDontCloseOnFight = MTools.buildCheckBox("ckDontCloseOnFight", window, 360, 20, RWRoot.locTxt.Hestia.cfgDontClose)
	window.ckDontCloseOnFight:SetPoint("TOPLEFT", window.ckShowSessionReport, "TOPLEFT", 0, 25)

	-- Valeurs d'alerte
	window.ttOptionsTitle = MTools.buildShadowTitle("ttOptionsTitle", window, 360, 25, RWRoot.locTxt.Hestia.cfgWarnValue)
	window.ttOptionsTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 420, 70)
	
	window.slVitalityWarnLimit = MTools.buildIntegerSlider("slVitalityWarnLimit", window, 340, 20, RWRoot.locTxt.Hestia.cfgVitaLimit, 0, 0, 90, "%", 1)
	window.slVitalityWarnLimit:SetPoint("TOPLEFT", window.ttOptionsTitle, "TOPLEFT", 10, 60)

	window.slLongBuffWarnLimit = MTools.buildIntegerSlider("slLongBuffWarnLimit", window, 340, 20, RWRoot.locTxt.Hestia.cfgLongBuffLimit, 8, 0, 20, " min")
	window.slLongBuffWarnLimit:SetPoint("TOPLEFT", window.slVitalityWarnLimit, "TOPLEFT", 0, 60)

	window.slShortBuffWarnLimit = MTools.buildIntegerSlider("slShortBuffWarnLimit", window, 340, 20, RWRoot.locTxt.Hestia.cfgShortBuffLimit, 3, 0, 10, " min")
	window.slShortBuffWarnLimit:SetPoint("TOPLEFT", window.slLongBuffWarnLimit, "TOPLEFT", 0, 60)

	window.slPotionWarnLimit = MTools.buildIntegerSlider("slPotionWarnLimit", window, 340, 20, RWRoot.locTxt.Hestia.cfgPotionLimit, 5, 0, 30)
	window.slPotionWarnLimit:SetPoint("TOPLEFT", window.slShortBuffWarnLimit, "TOPLEFT", 0, 60)

	window.slBagWarnLimit = MTools.buildIntegerSlider("slBagWarnLimit", window, 340, 20, RWRoot.locTxt.Hestia.cfgFreeSpaceLimit, 5, 0, 50)
	window.slBagWarnLimit:SetPoint("TOPLEFT", window.slPotionWarnLimit, "TOPLEFT", 0, 60)

	-- performances
	window.ttPerfTitle = MTools.buildShadowTitle("ttPerfTitle", window, 360, 25, RWRoot.locTxt.Performance)
	window.ttPerfTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 420, 430)
		
	window.slFrameSkip = MTools.buildIntegerSlider("slFrameSkip", window, 340, 20, RWRoot.locTxt.Hestia.cfgFrameSkip, 2, 0, 5)
	window.slFrameSkip:SetPoint("TOPLEFT", window.ttPerfTitle, "TOPLEFT", 10, 60)
	
	window.lbBetterRefresh = MTools.buildText("lbBetterRefresh", window, RWRoot.locTxt.ProxyWarn.cfgBetterSpeed, 12)
	window.lbBetterRefresh:SetPoint("BOTTOMRIGHT", window.slFrameSkip, "BOTTOMRIGHT", 0, 7)
	
	window.lbBetterPerf = MTools.buildText("lbBetterPerf", window, RWRoot.locTxt.ProxyWarn.cfgBetterRefresh, 12)
	window.lbBetterPerf:SetPoint("BOTTOMLEFT", window.slFrameSkip, "BOTTOMLEFT", 0, 7)

	window.ckDoRaidScan = MTools.buildCheckBox("ckDoRaidScan", window, 360, 20, RWRoot.locTxt.Hestia.cfgDoRaidScan)
	window.ckDoRaidScan:SetPoint("TOPLEFT", window.slFrameSkip, "TOPLEFT", 0, 40)
	
	window.lbPerfHelp1 = MTools.buildText("lbPerfHelp1", window, RWRoot.locTxt.Hestia.cfgHelpNoteLine1, 12)
	window.lbPerfHelp1:SetPoint("BOTTOMLEFT", window.ckDoRaidScan, "BOTTOMLEFT", 0, 30)

	window.lbPerfHelp2 = MTools.buildText("lbPerfHelp2", window, RWRoot.locTxt.Hestia.cfgHelpNoteLine2, 12)
	window.lbPerfHelp2:SetPoint("BOTTOMLEFT", window.lbPerfHelp1, "BOTTOMLEFT", 0, 15)	

	
	function window:LoadData()
		-- Valeurs d'alerte
		window.slVitalityWarnLimit:SetDecimalValue(RWConfig.Hestia.VitalityWarnLimit)
		window.slLongBuffWarnLimit:SetValue(math.floor(RWConfig.Hestia.LongBuffWarnLimit/60))
		window.slShortBuffWarnLimit:SetValue(math.floor(RWConfig.Hestia.ShortBuffWarnLimit/60))
		window.slPotionWarnLimit:SetValue(RWConfig.Hestia.PotionWarnLimit)
		window.slBagWarnLimit:SetValue(RWConfig.Hestia.BagWarnLimit)
		-- Comportement
		window.rgautoSwitchCfg:SetValue(RWConfig.Hestia.autoSwitchCfg)
		window.ckWarnIfNotFull:SetChecked(RWConfig.Hestia.WarnIfNotFull)
		window.rgReactivateCondition:SetValue(RWConfig.Hestia.ReactivateCondition)
		window.ckonHoldonAuto:SetChecked(RWConfig.Hestia.onHoldonAuto)
		window.ckCoolJoinReact:SetChecked(RWConfig.Hestia.CoolJoinReact)
		window.ckSoloFightReact:SetChecked(RWConfig.Hestia.SoloFightReact)
		window.ckonHoldonSolo:SetChecked(RWConfig.Hestia.onHoldonSolo)
		window.ckPSpellWarnOnly:SetChecked(RWConfig.Hestia.PSpellWarnOnly)
		window.ckShowSessionReport:SetChecked(RWConfig.Hestia.ShowSessionReport)
		window.ckDoMedicWarning:SetChecked(RWConfig.Hestia.DoMedicWarning)
		window.ckDoFoodWarning:SetChecked(RWConfig.Hestia.DoFoodWarning)
		window.ckDontCloseOnFight:SetChecked(RWConfig.Hestia.DontCloseOnFight)
		-- performances
		window.slFrameSkip:SetValue(RWConfig.Hestia.FrameSkip-1)
		window.ckDoRaidScan:SetChecked(RWConfig.Hestia.DoRaidScan)
	end
	
	function window:SaveData()
		-- Valeurs d'alerte
		RWConfig.Hestia.VitalityWarnLimit = window.slVitalityWarnLimit:GetDecimalValue()
		RWConfig.Hestia.LongBuffWarnLimit = window.slLongBuffWarnLimit:GetValue()*60
		RWConfig.Hestia.ShortBuffWarnLimit = window.slShortBuffWarnLimit:GetValue()*60
		RWConfig.Hestia.PotionWarnLimit = window.slPotionWarnLimit:GetValue()
		RWConfig.Hestia.BagWarnLimit = window.slBagWarnLimit:GetValue()
		-- Comportement
		RWConfig.Hestia.autoSwitchCfg = window.rgautoSwitchCfg:GetValue()
		RWConfig.Hestia.WarnIfNotFull = window.ckWarnIfNotFull:GetChecked()
		RWConfig.Hestia.ReactivateCondition = window.rgReactivateCondition:GetValue()
		RWConfig.Hestia.onHoldonAuto = window.ckonHoldonAuto:GetChecked()
		RWConfig.Hestia.CoolJoinReact = window.ckCoolJoinReact:GetChecked()
		RWConfig.Hestia.SoloFightReact = window.ckSoloFightReact:GetChecked()
		RWConfig.Hestia.onHoldonSolo = window.ckonHoldonSolo:GetChecked()
		RWConfig.Hestia.PSpellWarnOnly = window.ckPSpellWarnOnly:GetChecked()
		RWConfig.Hestia.ShowSessionReport = window.ckShowSessionReport:GetChecked()
		RWConfig.Hestia.DoMedicWarning = window.ckDoMedicWarning:GetChecked()
		RWConfig.Hestia.DoFoodWarning = window.ckDoFoodWarning:GetChecked()
		RWConfig.Hestia.DontCloseOnFight = window.ckDontCloseOnFight:GetChecked()
		-- performances
		RWConfig.Hestia.FrameSkip = window.slFrameSkip:GetValue()+1
		RWConfig.Hestia.DoRaidScan = window.ckDoRaidScan:GetChecked()
		
		UpdateConfigChanges()
		print(RWRoot.locTxt.Hestia.cfgOptionsSaved)
	end
	
	function window.bbClose.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btCancel.Event:LeftPress()
		window.bbClose.Event:LeftPress()		
	end
	
	function window.btOk.Event:LeftPress()
		window:SaveData()
		window.bbClose.Event:LeftPress()		
	end
	
	function window.btHestia.Event:LeftPress()
		RWRoot.Hestia.ShowFrame()
	end

	RWRoot.Hestia.ConfigWindow = window
	return window
end
	

--	Button registration ----------------------

RWRoot.HermesButton.MainButton:RegisterMenuButton(RWRoot.locTxt.Hestia.abTitle, 
	"showhestia", RWRoot.locTxt.Hestia.abShowFrame, {
		"Resources\\Button\\btnHestiaUp.png",
		"Resources\\Button\\btnHestiaIn.png",
		"Resources\\Button\\btnHestiaDown.png"}):RegisterModButton(
	"hestiacfg", RWRoot.locTxt.Hestia.abConfig, {
		"Resources\\Button\\btnHestiaCfgUp.png",
		"Resources\\Button\\btnHestiaCfgIn.png",
		"Resources\\Button\\btnHestiaCfgDown.png"}):RegisterModButton(
	"hreport", RWRoot.locTxt.Hestia.abShowReport, {
		"Resources\\Button\\HestiaReportUp.png",
		"Resources\\Button\\HestiaReportIn.png",
		"Resources\\Button\\HestiaReportDown.png"}):RegisterModButton(
	"hinitrep", RWRoot.locTxt.Hestia.abInitReport, {
		"Resources\\Button\\HestiaNewReportUp.png",
		"Resources\\Button\\HestiaNewReportIn.png",
		"Resources\\Button\\HestiaNewReportDown.png"})


--	Config win registration ----------------------

RWRoot.ConfigWinManager:RegisterWindow("HestiaConfigWin", BuildConfigWindow)

