-------------------------------------------------
--                                             --
--                Events Scanner               --
--                                             --
--      Collect the data of an encouter!       --
--                                             --
-------------------------------------------------


-- Variables -----------------------------------------------------------

RWConfig.Scanner = {
	Active = false,
		
	IgnoreHostileCaster = false,
	IgnoreFriendlyCaster = true,
	LookForCaster = "",
	
	IgnoreHostileTarget = false,
	IgnoreFriendlyTarget = false,
	ShowFullTargetData = false,
	LookForTarget = "",
	
	ShowDebuffs = true,
	ShowGoodBuffs = false,
	ShowEmotes = true,
	ShowUnitDeath = true,
	ShowDamage = false,
	ShowHeal = false,
	
	ReportActivated = true,
	ShowReportOnly = false,
	ReportOnCasterOnly = true,
	RepShowExplorer = true,
	ReportDetailLevel = 2,
	
	RepExplorer = {
		Position = { x = 400, y = 200 },
		Height = 200,
		Width = 200	
	}
		
}

RWConst.Scanner = {
	MinRepTime = 2

}

RWData.Scanner = {
	RepExplorer = {
		BarHeight = 20,
		FontSize = 14,
		FrameX0 = 4,
		BarSep = 1,
		
		BackColor = { 0, 0, 0, 0.6 },
		TitleBackColor = { 0.7, 0.4, 0.1, 1 },
		FontColor = { 1, 1, 1, 1 },
		SelectColor = { 0.1, 0.1, 0.7, 1 },
		TableColor = { 0.5, 0.5, 0.1, 1 },
		DataColor = { 0.1, 0.5, 0.3, 1 },
		ValueColor = { 0.2, 0.2, 0.2, 0.1 }	
	}
}

RWData.Scanner.BannedBuffID = {
	-- Friendly debuffs
	--"B31FE0332B56C97A1",		-- Epuisement, bouclier clerc
	--"BFF0C7B01364359A9",		-- Epuisé par l'effort, (archon)
	--"B272789F15CF2CEA2" 		-- ne peut pas etre affecté par symbiose

}

RWData.Scanner.BannedBuffName = {

}


RWRoot.Scanner = {
	
	ConfigWindow = nil,
	ExplorerFrame = nil

}

local nbScanReport = 0
local ScanReportList = {}
local ScannerReport = {}
local ReportedEmote = {}


local IconPath = {
	Resize = "Resources\\ResizeIcon.png",
	Close = "Resources\\CloseIcon.png",
	Clean = "Resources\\TrashIcon.png",
	Help = "Resources\\HelpIcon.png",
	Up = "Resources\\ArrowUp.png",
	Down = "Resources\\ArrowDown.png",
	Print = "Resources\\PrintIcon.png",
	Edit = "Resources\\EditIcon.png",
	Add = "Resources\\AddIcon.png",
	Remove = "Resources\\RemoveIcon.png"
}


-- Report functions -----------------------------------------------------------


local function GetShowReportOnly()
	return RWConfig.Scanner.ReportActivated and RWConfig.Scanner.ShowReportOnly
end

local function ShowReport(Report)

	for k, v in pairs(Report) do 
		if (type(Report[k]) == "table") then
			print("Données pour : " .. k) 
			ShowReport(Report[k])
		else 
			print(k .. ": " .. v) 
		end
	end

end

local function ShowCombatReport(ScanRep)
	
	Command.Console.Display("general", true, "<font color=\"#0094ff\">===============================</font>", true)
	print("-- " .. RWRoot.locTxt.Scanner.RepCombatData .. " ---------------------------------------")
	dump(ScanRep.Info)
	
	if ScanRep.Hostile then
	Command.Console.Display("general", true, "<font color=\"#ff3300\">== " .. RWRoot.locTxt.Scanner.RepHostileUnits .. " ==========</font>", true)
	
	if ScanRep.hostile.Caster and ScanRep.hostile.Caster.Info then
	Command.Console.Display("general", true, "<font color=\"#AA2200\">-- " .. RWRoot.locTxt.Scanner.RepCasterGlobals .. " ----------</font>", true)

	if ScanRep.hostile.Caster.Info.Buffs then	
	print("-- " .. RWRoot.locTxt.Scanner.RepBuffs .. " -------------------")
	dump(ScanRep.hostile.Caster.Info.Buffs)
	end
	if ScanRep.hostile.Caster.Info.Debuffs then		
	print("-- " .. RWRoot.locTxt.Scanner.RepDebuffs .. " -----------------")
	dump(ScanRep.hostile.Caster.Info.Debuffs)
	end
	if ScanRep.hostile.Caster.Info.CombatSpells then	
	print("-- " .. RWRoot.locTxt.Scanner.RepCombatSpells .. " ------------")
	dump(ScanRep.hostile.Caster.Info.CombatSpells)
	end
	if ScanRep.hostile.Caster.Info.HealSpells then	
	print("-- " .. RWRoot.locTxt.Scanner.RepHealSpells .. " --------------")
	dump(ScanRep.hostile.Caster.Info.HealSpells)
	end
	Command.Console.Display("general", true, "<font color=\"#AA2200\">---------------------------</font>", true)
	end
	
	if RWConfig.Scanner.ReportDetailLevel >= 2 then
		if ScanRep.hostile.Caster.Units then	
		print("-- " .. RWRoot.locTxt.Scanner.RepCasterDetails .. " ----")
		dump(ScanRep.hostile.Caster.Units)
		end
	end
	if not RWConfig.Scanner.ReportOnCasterOnly then
		if ScanRep.hostile.Target then	
		print("-- " .. RWRoot.locTxt.Scanner.RepTargetData .. " ----")
		dump(ScanRep.hostile.Target)
		end
	end
	end	
	
	if ScanRep.friendly then
	Command.Console.Display("general", true, "<font color=\"#00ff94\">== " .. RWRoot.locTxt.Scanner.RepFriendlyUnits .. " ============</font>", true)
	if ScanRep.friendly.Caster then
	print("-- " .. RWRoot.locTxt.Scanner.RepCasterGlobals .. " ----")
	dump(ScanRep.friendly.Caster.Info)
	if RWConfig.Scanner.ReportDetailLevel >= 2 then
		if ScanRep.friendly.Caster.Units then	
		print("-- " .. RWRoot.locTxt.Scanner.RepCasterDetails .. " ----")
		dump(ScanRep.friendly.Caster.Units)
		end
	end
	end
	if not RWConfig.Scanner.ReportOnCasterOnly then
		if ScanRep.friendly.Target then	
		print("-- " .. RWRoot.locTxt.Scanner.RepTargetData .. " ----")
		dump(ScanRep.friendly.Target)
		end
	end
	end
	
	if ScanRep.unknown then
	Command.Console.Display("general", true, "<font color=\"#ffdb00\">== " .. RWRoot.locTxt.Scanner.RepUnknownUnits .. " =============</font>", true)
	if ScanRep.unknown.Caster then
	dump(ScanRep.unknown.Caster.Info)
	if RWConfig.Scanner.ReportDetailLevel >= 2 then
		if ScanRep.unknown.Caster.Units then	
		dump(ScanRep.unknown.Caster.Units)
		end
	end
	end
	if not RWConfig.Scanner.ReportOnCasterOnly then
		if ScanRep.unknown.Target then	
		dump(ScanRep.unknown.Target)
		end
	end
	end
	
	Command.Console.Display("general", true, "<font color=\"#0094ff\">== " .. RWRoot.locTxt.Scanner.RepEndofReport .. " =============</font>", true)
end

function RWRoot.Scanner.ReportDone()
	
	if RWConfig.Scanner.ReportActivated and ScannerReport and ScannerReport.Info then
		ScannerReport.Info.EndTime = Inspect.Time.Real()
		local t = ScannerReport.Info.EndTime - ScannerReport.Info.StartTime
		ScannerReport.Info.CombatTime = MTools.GetTimeString(t)
		nbScanReport = nbScanReport + 1
		MTools.PurgeTable(ScannerReport)
		if t >=	RWConst.Scanner.MinRepTime then
			ScannerReport.Info.Title = ScannerReport.Info.CombatTime .. "-" .. ScannerReport.Info.ZoneName
			ScanReportList[nbScanReport] = ScannerReport 
		end
		RWRoot.Scanner.InitData()
		if RWRoot.Scanner.ExplorerFrame then RWRoot.Scanner.ExplorerFrame:UpdateFrame()	end
		if RWConfig.Scanner.RepShowExplorer then RWRoot.Scanner.ShowReportExplorer() end
	end
end

-- Data Lines
-- Default line
local function GetDefaultReportTable()
	return {
		nbFound = 0
	}
end

-- Adding a new Emote/Chat report line
local function GetClassEmoteReportTable(info)
	return {
		Text = info.message,
		Sender = info.fromName,
		nbFound = 0
	}
end

local function GetEmoteReportTable(info)
	return {
		Text = info.message,
		nbFound = 0
	}
end

-- Adding a new Heal spell report line
local function GetClassHealSpellReportTable(info)
	return {
		ID = info.ability,
		IDNew = info.abilityNew,
		nbFound = 0,
		--heal = info.heal,
		--crit = info.crit
	}
end

local function GetUnitHealSpellReportTable(info)
	return {
		nbFound = 0
	}
end

-- Adding a new combat spell report line
local function GetClassCombatSpellReportTable(info)
	return {
		ID = info.ability,
		IDNew = info.abilityNew,
		FirstCaster = info.casterName,
		nbFound = 0,
		type = info.type
	}
end

local function GetUnitCombatSpellReportTable(info)
	return {
		nbFound = 0
	}
end

-- Adding a new buff report line
local function GetClassBuffReportTable(buff)
	return {
		ID = buff.type,
		duration = buff.duration,
		description = buff.description,
		nbFound = 0
	}
end

local function GetUnitBuffReportTable(buff)
	return {
		nbFound = 0
	}
end

-- Report structure
local function GetUnitReportTable()

	return {
		Buffs = {},
		Debuffs = {},
		CombatSpells = {},
		HealSpells = {}
	}
end

local function GetClassReportTable()

	return {
		Info = GetUnitReportTable(),
		Units = {}
	}
end

-- Init the report
function RWRoot.Scanner.InitData()

	local function GetReportBlock()
		return {
			Caster = GetClassReportTable(),
			Target = GetClassReportTable()
		}
	end

	ScannerReport = {
		Info = {
			ZoneName = RWRoot.player.locationName,
			CombatTime = "",
			StartTime = Inspect.Time.Real(),
			EndTime = nil
		},
		hostile = GetReportBlock(),
		friendly = GetReportBlock(),
		unknown = GetReportBlock()
	}

	ReportedEmote = {}
end

-- Reporting!
-- Data dumping!
local function AddDataReport(ReportDestination, UnitName, UnitID, 
							DataTable, DataID,
							GetClassDataFunction, GetUnitDataFunction, Arg)
	
	DataID = DataID or "unknown"

	-- Update Globals
	if not ReportDestination.Info[DataTable] then ReportDestination.Info[DataTable] = {} end
	local UnitGlobalReport = ReportDestination.Info[DataTable]
	if not UnitGlobalReport[DataID] then UnitGlobalReport[DataID] = GetClassDataFunction(Arg) end
	UnitGlobalReport[DataID].nbFound = UnitGlobalReport[DataID].nbFound + 1
		
	if RWConfig.Scanner.ReportDetailLevel >= 2 then
		-- update the class
		if not ReportDestination.Units[UnitName] then ReportDestination.Units[UnitName] = GetClassReportTable() end
		if not ReportDestination.Units[UnitName].Info[DataTable] then ReportDestination.Units[UnitName].Info[DataTable] = {} end
		local UnitClassReport = ReportDestination.Units[UnitName].Info[DataTable]
		if not UnitClassReport[DataID] then UnitClassReport[DataID] = GetUnitDataFunction(Arg) end
		UnitClassReport[DataID].nbFound = UnitClassReport[DataID].nbFound + 1

		if RWConfig.Scanner.ReportDetailLevel >= 3 then
			-- update the unit
			if not ReportDestination.Units[UnitName].Units[UnitID] then ReportDestination.Units[UnitName].Units[UnitID] = GetUnitReportTable() end
			if not ReportDestination.Units[UnitName].Units[UnitID][DataTable] then ReportDestination.Units[UnitName].Units[UnitID][DataTable] = {} end
			local UnitSelfReport = ReportDestination.Units[UnitName].Units[UnitID][DataTable]			
			if not UnitSelfReport[DataID] then UnitSelfReport[DataID] = GetUnitDataFunction(Arg) end			
			UnitSelfReport[DataID].nbFound = UnitSelfReport[DataID].nbFound + 1			
		end
	end		
end

-- Check unitID
local function GetUnitIDInfo(unitId)

	local Relation = "unknown"
	local unitName = "unknown"
	local UnitID = "unknown"
	
	if unitId then
		UnitID = unitId
		local unit = Inspect.Unit.Detail(unitId)
		if unit then 
			if unit.relation then Relation = unit.relation end
			if unit.name then unitName = unit.name end
		end
	end

	return Relation, unitName, UnitID
end

-- Reporting Buffs!
local function ReportAddBuff(CasterID, TargetID, buff)

	local BuffTable = "Buffs" if buff.debuff then BuffTable = "Debuffs" end	

	-- Add caster Data to the report
	local Relation, unitName, unitID = GetUnitIDInfo(CasterID)
	
	AddDataReport( ScannerReport[Relation].Caster, unitName, unitID, 
					BuffTable, buff.name, 
					GetClassBuffReportTable, GetUnitBuffReportTable, buff )
	
	if RWConfig.Scanner.ReportOnCasterOnly then return end -- leave if no data for the Target are desired
	
	-- Add target Data to the report
	Relation, unitName, unitID = GetUnitIDInfo(TargetID)
	
	AddDataReport( ScannerReport[Relation].Target, unitName, unitID, 
					BuffTable, buff.name, 
					GetClassBuffReportTable, GetUnitBuffReportTable, buff )	
end

-- Reporting Spells
local function ReportSpellDone(ReportDestination, info, ClassFunc, UnitFunc)
	
	-- Add caster Data to the report
	local Relation, unitName, unitID = GetUnitIDInfo(info.caster)
	local abilityID = info.abilityNew or unitName
	
	AddDataReport( ScannerReport[Relation].Caster, unitName, unitID, 
					ReportDestination, info.abilityName, 
					ClassFunc, UnitFunc, info )
	
	if RWConfig.Scanner.ReportOnCasterOnly then return end -- leave if no data for the Target are desired
	
	-- Add target Data to the report
	local Relation, unitName, unitID = GetUnitIDInfo(info.target)

	AddDataReport( ScannerReport[Relation].Target, unitName, unitID, 
					ReportDestination, info.abilityName, 
					ClassFunc, UnitFunc, info )	
end

-- Reporting Combat Spells
local function ReportCombatDamage(info)
	ReportSpellDone("CombatSpells", info, GetClassCombatSpellReportTable, GetUnitCombatSpellReportTable)
end

-- Reporting Heal Spells
local function ReportHealDone(info)
	ReportSpellDone("HealSpells", info, GetClassHealSpellReportTable, GetUnitHealSpellReportTable)
end

-- Reporting Emotes & Chat
-- Emotes & chat dont have IDs! let create one!
local function GetEmoteID(info)
	local i = 1
	while i <= #ReportedEmote do
		if ReportedEmote[i] == info.message then return ("E"..tostring(i)) end	
		i = i + 1
	end
	ReportedEmote[i] = info.message
	return ("E"..tostring(i))
end

-- Reporting Emotes
local function ReportEmote(info)

	-- General emote dont have sender! it can be generated by anything
	-- since this is done during boss encounter, and generally announce a boss bad doing, let consider it hostile!
	-- also, since no one seems to say this, let report it only on global data

	local save = RWConfig.Scanner.ReportDetailLevel
	RWConfig.Scanner.ReportDetailLevel = 1
	
	AddDataReport( ScannerReport.hostile.Caster, nil, nil, 
					"Emote", GetEmoteID(info),
					GetEmoteReportTable, nil, info )

	RWConfig.Scanner.ReportDetailLevel = save
end

-- Reporting Chat
local function ReportNPCChat(info)

	local Relation, unitName, unitID = GetUnitIDInfo(info.from)

	AddDataReport( ScannerReport[Relation].Caster, unitName, unitID, 
					"NPCChat", GetEmoteID(info), 
					GetClassEmoteReportTable, GetEmoteReportTable, info )
end

-- Reporting Death
local function ReportDeath(info)

	local Relation, unitName, unitID = GetUnitIDInfo(info.target)

	AddDataReport( ScannerReport[Relation].Caster, unitName, unitID, 
					"Death", "Info", 
					GetDefaultReportTable, GetDefaultReportTable )
end



-- Activate/Desactivate -----------------------------------------------------------

function RWRoot.Scanner.InitAddon()
	RWRoot.Scanner.InitData()
end

-- Activate
function RWRoot.Scanner.Activate(ForceActivation)
	if (not RWConfig.Scanner.Active) or ForceActivation then
		RWConfig.Scanner.Active = true
		RWRoot.Scanner.InitAddon()	
		print(RWRoot.locTxt.Scanner.ModActivated)
	end
end

-- Desactivate
function RWRoot.Scanner.Desactivate()
	if RWConfig.Scanner.Active then
	
	RWRoot.Scanner.InitData()
	RWConfig.Scanner.Active = false
	print(RWRoot.locTxt.Scanner.ModDesactivated)
	
	end
end


-- Utility functions -----------------------------------------------------------


local function ignoreCaster(casterID)

	if casterID then
		local caster = Inspect.Unit.Detail(casterID)
		if not caster then return false end
	
		if (RWConfig.Scanner.LookForCaster ~= "") and (RWConfig.Scanner.LookForCaster ~= caster.name) then return true end
		if (caster.relation == "friendly") and RWConfig.Scanner.IgnoreFriendlyCaster then return true end
		if (caster.relation == "hostile") and RWConfig.Scanner.IgnoreHostileCaster then return true end
	end
	
	return false
end

local function ignoreTarget(targetID)

	if targetID then
		local target = Inspect.Unit.Detail(targetID)
		if not target then return false end
	
		if (RWConfig.Scanner.LookForTarget ~= "") and (RWConfig.Scanner.LookForTarget ~= target.name) then return true end
		if (target.relation == "friendly") and RWConfig.Scanner.IgnoreFriendlyTarget then return true end
		if (target.relation == "hostile") and RWConfig.Scanner.IgnoreHostileTarget then return true end
	end
	
	return false
end

local function ShowTargetInfo(id)
	if id and RWConfig.Scanner.ShowFullTargetData then
		local target = Inspect.Unit.Detail(id)
		dump(target)
	end
end


function RWRoot.Scanner.ScanTargetBuff()

	if RWRoot.targetId then
	
		local detail = Inspect.Unit.Detail(RWRoot.targetId)
		if detail then dump(detail) end
	
		local DataList = Inspect.Buff.List(RWRoot.targetId)	
		if DataList then
			detail = Inspect.Buff.Detail(RWRoot.targetId, DataList)
			for k, v in pairs(detail) do
				dump(v)
			end
		else
			print(RWRoot.locTxt.Scanner.ScanNoBuffFound)
		end
	else
		print(RWRoot.locTxt.NoTarget)
	end
end

-- Handlers -----------------------------------------------------------


-- Buffs Added

function RWRoot.Scanner.BuffsAdded(handle, id, buffs)
	
	if ignoreTarget(id) then return end

	local PBuffs = Inspect.Buff.Detail(id, buffs)
  
	for k, v in pairs(PBuffs) do
		if ((v.debuff) and (RWConfig.Scanner.ShowDebuffs))
		or ((not v.debuff) and (RWConfig.Scanner.ShowGoodBuffs))
		then
			if not ignoreCaster(v.caster) then

				local BannedBuff = false			
				for i = 1, #RWData.Scanner.BannedBuffID do
					if RWData.Scanner.BannedBuffID[i] == v.type then
						BannedBuff = true
						break
					end
				end

				if not BannedBuff then
					for i = 1, #RWData.Scanner.BannedBuffName do
						if RWData.Scanner.BannedBuffName[i] == v.name then
							BannedBuff = true
							break
						end
					end
				
					if not BannedBuff then					
						local CasterName = "Unknown"
						if v.caster then
							local caster = Inspect.Unit.Detail(v.caster)
							if caster then CasterName = caster.name end
						end
					
						if RWConfig.Scanner.ReportActivated then ReportAddBuff(v.caster, id, v) end

						local player = Inspect.Unit.Detail(id)
						if not GetShowReportOnly() then
							dump(buffs)
							print("-- " .. CasterName .. RWRoot.locTxt.Scanner.ScannedBuff .. player.name)
							if RWConfig.Scanner.ShowFullTargetData then dump(player) end
							dump(v)
						end
					end
				end
			end
		end
	end
	
end


-- Event Chat Notify

function RWRoot.Scanner.EventChatNotify(handle, info)
	if RWConfig.Scanner.ShowEmotes then
	
	if RWConfig.Scanner.ReportActivated then 
		ReportEmote(info)
		if RWConfig.Scanner.ShowReportOnly then return end		
	end
	
	print(RWRoot.locTxt.Scanner.ScannedEmote)
	print('"' .. info.message .. '"')
	
	end
end

function RWRoot.Scanner.EventChatNpc(handle, info)

	if RWConfig.Scanner.ShowEmotes then
	
	if ignoreCaster(info.from) then return end
	
	if RWConfig.Scanner.ReportActivated then 
		ReportNPCChat(info)
		if RWConfig.Scanner.ShowReportOnly then return end		
	end
	
	print(RWRoot.locTxt.Scanner.ScannedNPCChat)
	print(RWRoot.locTxt.Scanner.ScannedChatSender .. info.fromName)
	print('"' .. info.message .. '"')
	
	end
end

function RWRoot.Scanner.EventCombatDeath(handle, info)
	if RWConfig.Scanner.ShowUnitDeath then
	
	if ignoreCaster(info.target) then return end
	
	if RWConfig.Scanner.ReportActivated then 
		ReportDeath(info)
		if RWConfig.Scanner.ShowReportOnly then return end		
	end
	
	print(RWRoot.locTxt.Scanner.ScannedDeath)
	print(info.targetName)
	ShowTargetInfo(info.target)
	
	end
end

function RWRoot.Scanner.EventCombatDamage(handle, info)

	if RWConfig.Scanner.ShowDamage then

	if ignoreCaster(info.caster) then return end
	if ignoreTarget(info.target) then return end
	
	if RWConfig.Scanner.ReportActivated then 
		ReportCombatDamage(info)
		if RWConfig.Scanner.ShowReportOnly then return end		
	end

	print(RWRoot.locTxt.Scanner.ScannedDamage)
	if info.abilityName then print(RWRoot.locTxt.Scanner.ScannedSpell .. info.abilityName) end
	if info.ability then print("ID: " .. info.ability) end
	if info.abilityNew then print("IDNew: " .. info.abilityNew) end
	if info.casterName then print(RWRoot.locTxt.Scanner.ScannedCaster .. info.casterName) end
	if info.targetName then print(RWRoot.locTxt.Scanner.ScannedTarget .. info.targetName) end
	ShowTargetInfo(info.target)
	
	end
end

function RWRoot.Scanner.EventCombatHeal(handle, info)
	
	if RWConfig.Scanner.ShowHeal then
	
	if ignoreCaster(info.caster) then return end
	if ignoreTarget(info.target) then return end
	
	if RWConfig.Scanner.ReportActivated then 
		ReportHealDone(info)
		if RWConfig.Scanner.ShowReportOnly then return end		
	end
	
	print(RWRoot.locTxt.Scanner.ScannedHeal)
	if info.abilityName then print(RWRoot.locTxt.Scanner.ScannedSpell .. info.abilityName) end
	if info.ability then print("ID: " .. info.ability) end
	if info.abilityNew then print("IDNew: " .. info.abilityNew) end
	if info.casterName then print(RWRoot.locTxt.Scanner.ScannedCaster .. info.casterName) end
	if info.targetName then print(RWRoot.locTxt.Scanner.ScannedTarget .. info.targetName) end
	ShowTargetInfo(info.target)
	
	end
end


-- Report explorer frame ----------------------------------------------------------

-- Import/Export window
local function BuildExportImportWindow()
	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)
	
	window:SetHeight(230)
	window:SetWidth(550)
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	-- boutons
	window.btOk =  MTools.buildButton("btOk", window, 110, 40, RWRoot.locTxt.buttonOk)

	window.btCancel =  MTools.buildButton("btAnnuler", window, 110, 40, RWRoot.locTxt.buttonCancel)
	window.btCancel:SetPoint("TOPRIGHT", window, "TOPRIGHT", -170, 170)
	
	-- Elements
	window.Line1 = MTools.buildText("ExportLine1", window, "", 17)
	window.Line1:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 50)	
	
	window.ebData = MTools.buildEditBox("ebData", window, 510, 22, RWRoot.locTxt.Data)
	window.ebData:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 80)
	
	window.Helper1 = MTools.buildText("ExportHelper1", window, "", 17)
	window.Helper1:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 110)	

	window.Helper2 = MTools.buildText("ExportHelper2", window, "", 17)
	window.Helper2:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 130)
	
	MTools.buildWindowMover("WindowMover", window)
	
	window.ExportMode = false
	
	function window:InitExport(s)
		window.btCancel:SetVisible(false)
		MTools.ClearPoints(window.btOk)
		window.btOk:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 170)
		window.ebData.text:SetText(s)
		window.ebData.text:SetSelection(1,string.len(s))
		window.ebData.text:SetKeyFocus(true)
		window:SetTitle(RWRoot.locTxt.Scanner.repExpExportTitle)
		window.Line1:SetText(RWRoot.locTxt.Scanner.repExpExpLine1)
		window.Helper1:SetText(RWRoot.locTxt.Scanner.repExpExpHelp1)
		window.Helper2:SetText(RWRoot.locTxt.Scanner.repExpExpHelp2)
		window.ExportMode = true
		window:SetVisible(true)
	end
	
	function window:InitImport()
		window.btCancel:SetVisible(true)
		MTools.ClearPoints(window.btOk)
		window.btOk:SetPoint("TOPLEFT", window, "TOPLEFT", 170, 170)
		window.ebData.text:SetText("")
		window.ebData.text:SetKeyFocus(true)
		window:SetTitle(RWRoot.locTxt.Scanner.repExpImportTitle)
		window.Line1:SetText(RWRoot.locTxt.Scanner.repExpImpLine1)
		window.Helper1:SetText(RWRoot.locTxt.Scanner.repExpImpHelp1)
		window.Helper2:SetText(RWRoot.locTxt.Scanner.repExpImpHelp2)
		window.ExportMode = false
		window:SetVisible(true)
	end
	
	function window:CloseWindow()
		window:SetVisible(false)
		window.ebData.text:SetKeyFocus(false)		
	end
	
	function window.btCancel.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btOk.Event:LeftPress()
		if not window.ExportMode then
			nbScanReport = nbScanReport + 1
			ScanReportList[nbScanReport] = MTools.StringToTable(window.ebData.text:GetText())
			if RWRoot.Scanner.ExplorerFrame then RWRoot.Scanner.ExplorerFrame:UpdateFrame()	end
		end		
		window.btCancel.Event:LeftPress()
	end
	
	return window
end


-- HelpWindow
local function BuildExplorerHelpWindow()
	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)
		
	window.bbClose =  MTools.buildButton("btClose", window, 50, 50, "x", "close")
	window.bbClose:SetPoint("TOPRIGHT", window, "TOPRIGHT", -8, 15)

	window.btOk =  MTools.buildButton("btOk", window, 110, 40, RWRoot.locTxt.buttonOk)
	window.btOk:SetPoint("BOTTOMCENTER", window, "BOTTOMCENTER", 0, -20)
	
	window.PrintIcon = UI.CreateFrame("Texture", "tPrintIcon", window)
	window.PrintIcon:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 270)
	window.PrintIcon:SetWidth(24)
	window.PrintIcon:SetHeight(24)
	window.PrintIcon:SetTexture(RWData.AddonIdentifier, IconPath.Print)
	
	window.EditIcon = UI.CreateFrame("Texture", "tEditIcon", window)
	window.EditIcon:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 300)
	window.EditIcon:SetWidth(24)
	window.EditIcon:SetHeight(24)
	window.EditIcon:SetTexture(RWData.AddonIdentifier, IconPath.Edit)
	
	window.AddIcon = UI.CreateFrame("Texture", "tAddIcon", window)
	window.AddIcon:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 330)
	window.AddIcon:SetWidth(24)
	window.AddIcon:SetHeight(24)
	window.AddIcon:SetTexture(RWData.AddonIdentifier, IconPath.Add)
	
	window.RemoveIcon = UI.CreateFrame("Texture", "tRemoveIcon", window)
	window.RemoveIcon:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 360)
	window.RemoveIcon:SetWidth(24)
	window.RemoveIcon:SetHeight(24)
	window.RemoveIcon:SetTexture(RWData.AddonIdentifier, IconPath.Remove)
	
	window.CleanIcon = UI.CreateFrame("Texture", "RepFrameClean", window)
	window.CleanIcon:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 390)
	window.CleanIcon:SetWidth(24)
	window.CleanIcon:SetHeight(24)
	window.CleanIcon:SetTexture(RWData.AddonIdentifier, IconPath.Clean)	

	window.Line1 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine1, 16)
	window.Line1:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 70)		

	window.Line2 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine2, 16)
	window.Line2:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 90)		
	
	window.Line3 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine3, 16)
	window.Line3:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 130)		

	window.Line4 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine4, 16)
	window.Line4:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 160)		

	window.Line5 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine5, 16)
	window.Line5:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 180)		

	window.Line6 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine6, 16)
	window.Line6:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 200)
	
	window.Line7 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine7, 16)
	window.Line7:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 240)

	window.Line8 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine8, 16)
	window.Line8:SetPoint("TOPLEFT", window, "TOPLEFT", 50, 270)
	
	window.Line9 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine9, 16)
	window.Line9:SetPoint("TOPLEFT", window, "TOPLEFT", 50, 300)
	
	window.Line10 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine10, 16)
	window.Line10:SetPoint("TOPLEFT", window, "TOPLEFT", 50, 330)
	
	window.Line11 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine11, 16)
	window.Line11:SetPoint("TOPLEFT", window, "TOPLEFT", 50, 360)
	
	window.Line12 = MTools.buildText("ExportLine1", window, RWRoot.locTxt.Scanner.repExpHlpLine12, 16)
	window.Line12:SetPoint("TOPLEFT", window, "TOPLEFT", 50, 390)
	
	window:SetTitle(RWRoot.locTxt.Help)
	window:SetHeight(500)
	window:SetWidth(math.max(200, 
	window.Line1:GetWidth()+40,
	window.Line2:GetWidth()+40,
	window.Line3:GetWidth()+40,
	window.Line4:GetWidth()+40,
	window.Line5:GetWidth()+40,
	window.Line6:GetWidth()+40,
	window.Line7:GetWidth()+40,
	window.Line8:GetWidth()+70,
	window.Line9:GetWidth()+70,
	window.Line10:GetWidth()+70,
	window.Line11:GetWidth()+70,
	window.Line12:GetWidth()+70))
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	MTools.buildWindowMover("ConfigWindow", window)
	
	function window.bbClose.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btOk.Event:LeftPress()
		window.bbClose.Event:LeftPress()		
	end	
	
	return window
end


-- Explorer bar!
local function CreateReportBar(Parent, k, v, i)

	ReportBar = UI.CreateFrame("Frame", "ReportBar", Parent)
	ReportBar:SetVisible(false)
	
	ReportBar:SetHeight(RWData.Scanner.RepExplorer.BarHeight - RWData.Scanner.RepExplorer.BarSep)
	
	ReportBar.Text = UI.CreateFrame("Text", "RepBarText", ReportBar)
	ReportBar.Text:SetHeight(RWData.Scanner.RepExplorer.BarHeight - RWData.Scanner.RepExplorer.BarSep)
	ReportBar.Text:SetPoint("CENTERRIGHT", ReportBar, "CENTERRIGHT", RWData.Scanner.RepExplorer.FrameX0, 0)
	ReportBar.Text:SetFontSize(RWData.Scanner.RepExplorer.FontSize)
	ReportBar.Text:SetFontColor(unpack(RWData.Scanner.RepExplorer.FontColor))
	
	ReportBar.Key = nil
	ReportBar.Value = nil
	ReportBar.Index = i
	ReportBar.SelectMode = false
	
	function ReportBar:InitBar(k, v)
		if type(k) == "number" and v then k = tostring(k) .. "-" .. v.Info.Title end
		self.Key = k
		self.Value = v
		self.SelectMode = false
		if v == nil then
			self.Text:SetText(k)
			self:SetBackgroundColor(unpack(RWData.Scanner.RepExplorer.ValueColor))				
		elseif type(v) == "table" then
			self.Text:SetText(k)
			self:SetBackgroundColor(unpack(RWData.Scanner.RepExplorer.TableColor))		
		else
			self.Text:SetText(k .. " = " .. v)
			self:SetBackgroundColor(unpack(RWData.Scanner.RepExplorer.DataColor))		
		end	
	end
	
	function ReportBar:CopyDataFrom(bar)
		self.Value = bar.Value
		self.Key = bar.Key
		self.Text:SetText(bar.Text:GetText())
	end
	
	function ReportBar:AdjustWidth()
		local x = self:GetParent():GetWidth() - 2*RWData.Scanner.RepExplorer.BarSep
		self:SetWidth(x)
		self.Text:SetWidth(x-RWData.Scanner.RepExplorer.FrameX0)
	end

	function ReportBar:SetSelectMode()
		self:SetBackgroundColor(unpack(RWData.Scanner.RepExplorer.SelectColor))
		if type(self.Value) ~= "table" then self.Text:SetText(self.Key) end
		self.SelectMode = true
	end
	
	function ReportBar:SetPosition()
		MTools.ClearPoints(self)
		self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", RWData.Scanner.RepExplorer.BarSep, 
						(self.Index - self:GetParent().FirstIndex + 1) * RWData.Scanner.RepExplorer.BarHeight + RWData.Scanner.RepExplorer.BarSep)
	end
	
	function ReportBar.Event:LeftDown()
		if self.Value ~= nil then self:GetParent():ClickedIndex(self.Index)	end
	end
	
	function ReportBar.Event:RightDown()
		local p = self:GetParent()
		p:ClickedIndex(p.SelectIndex - 1)
		--p.Event:RightDown()
	end
	
	ReportBar:InitBar(k, v)
	ReportBar:SetPosition()
	ReportBar:AdjustWidth()

	return ReportBar
end

-- Explorer Master Frame
local function BuildRepExplorerFrame()

	local Frame = UI.CreateFrame("Frame", "ReportExplorerFrame", RWRoot.context)
	Frame:SetVisible(false)
	
	-- Frame elements ----
	
	Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", RWConfig.Scanner.RepExplorer.Position.x, RWConfig.Scanner.RepExplorer.Position.y)
	Frame:SetBackgroundColor(unpack(RWData.Scanner.RepExplorer.BackColor))
	Frame:SetHeight(RWConfig.Scanner.RepExplorer.Height)
	Frame:SetWidth(RWConfig.Scanner.RepExplorer.Width)
	
	Frame.TitleBar = UI.CreateFrame("Frame", "ReportExplorerFrame", Frame)
	Frame.TitleBar:SetPoint("TOPCENTER", Frame, "TOPCENTER")
	Frame.TitleBar:SetBackgroundColor(unpack(RWData.Scanner.RepExplorer.TitleBackColor))
	Frame.TitleBar:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.TitleBar:SetWidth(RWConfig.Scanner.RepExplorer.Width)

	Frame.Title = UI.CreateFrame("Text", "RepFrameTitle", Frame.TitleBar)
	Frame.Title:SetPoint("CENTERLEFT", Frame.TitleBar, "CENTERLEFT", RWData.Scanner.RepExplorer.FrameX0, 0)
	Frame.Title:SetFontSize(RWData.Scanner.RepExplorer.FontSize)
	Frame.Title:SetFontColor(unpack(RWData.Scanner.RepExplorer.FontColor))
	Frame.Title:SetText(RWRoot.locTxt.Scanner.repExplorerTitle)
	
	Frame.UpIcon = UI.CreateFrame("Texture", "RepFrameUp", Frame)
	Frame.UpIcon:SetPoint("TOPRIGHT", Frame, "TOPRIGHT", 0, RWData.Scanner.RepExplorer.BarHeight)
	Frame.UpIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.UpIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.UpIcon:SetTexture(RWData.AddonIdentifier, IconPath.Up)
	Frame.UpIcon:SetVisible(false)
	Frame.UpIcon:SetLayer(99)
	
	Frame.DownIcon = UI.CreateFrame("Texture", "RepFrameDown", Frame)
	Frame.DownIcon:SetPoint("BOTTOMRIGHT", Frame, "BOTTOMRIGHT", 0, -RWData.Scanner.RepExplorer.BarHeight)
	Frame.DownIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.DownIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.DownIcon:SetTexture(RWData.AddonIdentifier, IconPath.Down)
	Frame.DownIcon:SetVisible(false)
	Frame.DownIcon:SetLayer(99)
	
	Frame.CloseIcon = UI.CreateFrame("Texture", "RepFrameClose", Frame.TitleBar)
	Frame.CloseIcon:SetPoint("CENTERRIGHT", Frame.TitleBar, "CENTERRIGHT", -RWData.Scanner.RepExplorer.FrameX0, 0)
	Frame.CloseIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.CloseIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.CloseIcon:SetTexture(RWData.AddonIdentifier, IconPath.Close)
	
	Frame.HelpIcon = UI.CreateFrame("Texture", "RepFrameHelp", Frame.TitleBar)
	Frame.HelpIcon:SetPoint("CENTERRIGHT", Frame.TitleBar, "CENTERRIGHT", -RWData.Scanner.RepExplorer.FrameX0-RWData.Scanner.RepExplorer.BarHeight, 0)
	Frame.HelpIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.HelpIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.HelpIcon:SetTexture(RWData.AddonIdentifier, IconPath.Help)
		
	Frame.PrintIcon = UI.CreateFrame("Texture", "tPrintIcon", Frame)
	Frame.PrintIcon:SetPoint("BOTTOMLEFT", Frame, "BOTTOMLEFT", RWData.Scanner.RepExplorer.FrameX0, 0)
	Frame.PrintIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.PrintIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.PrintIcon:SetTexture(RWData.AddonIdentifier, IconPath.Print)
	
	Frame.EditIcon = UI.CreateFrame("Texture", "tEditIcon", Frame)
	Frame.EditIcon:SetPoint("BOTTOMLEFT", Frame, "BOTTOMLEFT", RWData.Scanner.RepExplorer.FrameX0 + RWData.Scanner.RepExplorer.BarHeight, 0)
	Frame.EditIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.EditIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.EditIcon:SetTexture(RWData.AddonIdentifier, IconPath.Edit)
	
	Frame.AddIcon = UI.CreateFrame("Texture", "tAddIcon", Frame)
	Frame.AddIcon:SetPoint("BOTTOMLEFT", Frame, "BOTTOMLEFT", RWData.Scanner.RepExplorer.FrameX0 + RWData.Scanner.RepExplorer.BarHeight*2, 0)
	Frame.AddIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.AddIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.AddIcon:SetTexture(RWData.AddonIdentifier, IconPath.Add)
	
	Frame.RemoveIcon = UI.CreateFrame("Texture", "tRemoveIcon", Frame)
	Frame.RemoveIcon:SetPoint("BOTTOMLEFT", Frame, "BOTTOMLEFT", RWData.Scanner.RepExplorer.FrameX0 + RWData.Scanner.RepExplorer.BarHeight*3, 0)
	Frame.RemoveIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.RemoveIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.RemoveIcon:SetTexture(RWData.AddonIdentifier, IconPath.Remove)
	
	Frame.CleanIcon = UI.CreateFrame("Texture", "RepFrameClean", Frame)
	Frame.CleanIcon:SetPoint("BOTTOMLEFT", Frame, "BOTTOMLEFT", RWData.Scanner.RepExplorer.FrameX0 + RWData.Scanner.RepExplorer.BarHeight*4, 0)
	Frame.CleanIcon:SetWidth(RWData.Scanner.RepExplorer.BarHeight)
	Frame.CleanIcon:SetHeight(RWData.Scanner.RepExplorer.BarHeight)
	Frame.CleanIcon:SetTexture(RWData.AddonIdentifier, IconPath.Clean)
		
	Frame.FrameMover = MTools.buildWindowMover("RepExplorerMover", Frame, RWData.Scanner.RepExplorer.BarHeight, 40)
	MTools.buildWindowResizer("RepExplorerResizer", Frame, RWData.AddonIdentifier, IconPath.Resize, RWData.Scanner.RepExplorer.BarHeight, true, 150, 5)
	
	Frame.ImpExpWindow = nil
	Frame.HelpWindow = nil
	
	Frame.ReportBar = {}
	Frame.ActualMaxBar = 0
	Frame.MaxReportBar = 0
	
	Frame.SelectIndex = 0
	Frame.FirstIndex = 1
	Frame.BarShown = math.floor(RWConfig.Scanner.RepExplorer.Height/RWData.Scanner.RepExplorer.BarHeight) - 2
	
	Frame.ActualTable = ScanReportList
	
	-- Frame functions ----

	function Frame:HideAbove(i)
		for j = i+1, self.ActualMaxBar do
			self.ReportBar[j]:SetVisible(false)
		end
		self.ActualMaxBar = i
	end
	
	function Frame:ClickedIndex(i)
		if i < 0 then return end
		if i == 0 then
			self.SelectIndex = 0
			self.ActualTable = ScanReportList		
		else
			if not self.ReportBar[i].SelectMode then			
				self.SelectIndex = self.SelectIndex + 1
				if i ~= self.SelectIndex then
					self.ReportBar[self.SelectIndex]:CopyDataFrom(self.ReportBar[i])
				end
				self.ReportBar[self.SelectIndex]:SetSelectMode()
			else
				self.SelectIndex = i		
			end
			self.ActualTable = self.ReportBar[self.SelectIndex].Value
		end
		
		self:HideAbove(self.SelectIndex)
		self:FillList()	
	end	
	
	function Frame:AddBar(k, v)
		self.ActualMaxBar = self.ActualMaxBar + 1
		if self.ActualMaxBar <= self.MaxReportBar then
			self.ReportBar[self.ActualMaxBar]:InitBar(k, v)
			self.ReportBar[self.ActualMaxBar]:SetPosition()
		else
			self.ReportBar[self.ActualMaxBar] = CreateReportBar(self, k, v, self.ActualMaxBar)
			self.MaxReportBar = self.MaxReportBar + 1
		end			
	end
	
	function Frame:RedrawWindow()	
		local j = self.FirstIndex + self.BarShown - 1
		if self.FirstIndex > 1 then
			for i = 1, self.FirstIndex - 1 do self.ReportBar[i]:SetVisible(false) end
			self.UpIcon:SetVisible(true)
		else
			self.UpIcon:SetVisible(false)		
		end
		if self.ActualMaxBar > j then
			self.DownIcon:SetVisible(true)
			for i = j+1, self.ActualMaxBar do self.ReportBar[i]:SetVisible(false) end
		else
			j = self.ActualMaxBar
			self.DownIcon:SetVisible(false)		
		end

		for i = self.FirstIndex, j do
			self.ReportBar[i]:SetPosition()
			self.ReportBar[i]:SetVisible(true)
		end		
	end

	function Frame:UpdateWindow()	

		if self.ActualMaxBar >= self.FirstIndex + self.BarShown then
			local i = self.ActualMaxBar - self.BarShown + 1
			if i < self.SelectIndex then 
				self.FirstIndex = i
			else
				self.FirstIndex = self.SelectIndex
			end
		elseif self.FirstIndex > 1 then
			local i = self.ActualMaxBar - self.BarShown + 1
			if i < 1 then 
				self.FirstIndex = 1
			else
				self.FirstIndex = i
			end
		end
			
		if self.FirstIndex < 1 then self.FirstIndex = 1 end
		self:RedrawWindow()
	end
	
	function Frame:FillList()
	
		if type(self.ActualTable) == "table" then
			for k, v in pairs(self.ActualTable) do
				self:AddBar(k,v)		
			end
		else
			self:AddBar(self.ActualTable, nil)		
		end
				
		self:UpdateWindow()	
	end
	
	function Frame:InitFrame()
		self.SelectIndex = 0
		self.ActualTable = ScanReportList
		self:HideAbove(0)
		self:FillList()		
	end	
	
	function Frame:UpdateFrame()
		if self.SelectIndex == 0 then self:InitFrame() end
	end	
	
	function Frame:AdjustToSize()
		local width = self:GetWidth()
		self.FrameMover:SetWidth(width-40)
		self.TitleBar:SetWidth(width)
		for i = 1, self.MaxReportBar do
			self.ReportBar[i]:AdjustWidth()
		end		
		
		local y = math.floor(self:GetHeight()/RWData.Scanner.RepExplorer.BarHeight) - 2
		if y ~=	self.BarShown then
			self.BarShown = y
			self:UpdateWindow()
		end		
	end
	
	function Frame:ScrollBarUp()
		if self.FirstIndex > 1 then
			self.FirstIndex = self.FirstIndex - 1
			self:RedrawWindow()
		end
	end
	
	function Frame:ScrollBarDown()
		if self.ActualMaxBar >= self.FirstIndex + self.BarShown then
			self.FirstIndex = self.FirstIndex + 1
			self:RedrawWindow()
		end
	end
	
	-- Frame events ----

	function Frame.CloseIcon.Event:LeftUp()
		RWConfig.Scanner.RepExplorer.Position.x = Frame:GetLeft()
		RWConfig.Scanner.RepExplorer.Position.y = Frame:GetTop()
		RWConfig.Scanner.RepExplorer.Height = Frame:GetHeight()
		RWConfig.Scanner.RepExplorer.Width = Frame:GetWidth()
		Frame:SetVisible(false)
	end
	
	function Frame.HelpIcon.Event:LeftUp()
		self.HelpWindow = RWRoot.ConfigWinManager:ShowWindow("ScanExpHelpWin")
	end

	function Frame.AddIcon.Event:LeftUp()
		Frame.ImpExpWindow = RWRoot.ConfigWinManager:ShowWindow("ScanExpImpWin")
		Frame.ImpExpWindow:InitImport()
	end

	function Frame.EditIcon.Event:LeftUp()
		if Frame.SelectIndex == 0 then
			print(RWRoot.locTxt.Scanner.repExpNoSelection)
		else
			Frame.ImpExpWindow = RWRoot.ConfigWinManager:ShowWindow("ScanExpImpWin")
			Frame.ImpExpWindow:InitExport(MTools.TableToString(Frame.ReportBar[1].Value))
		end
	end

	function Frame.PrintIcon.Event:LeftUp()
		if Frame.SelectIndex == 0 then
			print(RWRoot.locTxt.Scanner.repExpNoSelection)
		elseif Frame.SelectIndex == 1 then
			ShowCombatReport(Frame.ActualTable)
		else
			print("-------------------------------")
			local s = Frame.ReportBar[1].Key
			for i = 2, Frame.SelectIndex do s = s .. "\\" .. Frame.ReportBar[i].Key end
			print(s)
			dump(Frame.ActualTable)
			print("-------------------------------")
		end
	end

	function Frame.RemoveIcon.Event:LeftUp()
		if Frame.SelectIndex == 0 then
			print(RWRoot.locTxt.Scanner.repExpNoSelection)
		else
			RWRoot.ShowYesNoWindow(RWRoot.Scanner.CleanActualFrameReport, RWRoot.locTxt.Scanner.repExpEraseActual)
		end	
	end
	
	function Frame.CleanIcon.Event:LeftUp()
		if nbScanReport > 0 then
			RWRoot.ShowYesNoWindow(RWRoot.Scanner.CleanAllReport, RWRoot.locTxt.Scanner.repExpEraseAll)
		end
	end	
	
	function Frame.Event:RightDown()
		self:ClickedIndex(self.SelectIndex - 1)
	end
	
	function Frame.Event:WheelBack()
		self:ScrollBarDown()
	end

	function Frame.Event:WheelForward()
		self:ScrollBarUp()
	end

	function Frame.UpIcon.Event:LeftDown()
		Frame:ScrollBarUp()
	end
	
	function Frame.DownIcon.Event:LeftDown()
		Frame:ScrollBarDown()
	end
	
	
	Frame:InitFrame()
	
	return Frame
end

function RWRoot.Scanner.CleanAllReport(confirmed)
	if not confirmed then return end
	nbScanReport = 0
	ScanReportList = {}
	if RWRoot.Scanner.ExplorerFrame then RWRoot.Scanner.ExplorerFrame:InitFrame() end		
end

function RWRoot.Scanner.CleanActualFrameReport(confirmed)
	if not confirmed or not RWRoot.Scanner.ExplorerFrame or RWRoot.Scanner.ExplorerFrame.SelectIndex == 0 then return end

	local i = 1
	while (i <= nbScanReport) and (ScanReportList[i] ~= RWRoot.Scanner.ExplorerFrame.ReportBar[1].Value) do i = i + 1 end
	if i > nbScanReport then return end

	for j = i, nbScanReport-1 do ScanReportList[j] = ScanReportList[j+1] end
	ScanReportList[nbScanReport] = nil
	nbScanReport = nbScanReport - 1
	RWRoot.Scanner.ExplorerFrame:InitFrame()	
end


function RWRoot.Scanner.ShowReportExplorer()
	if not RWRoot.Scanner.ExplorerFrame then RWRoot.Scanner.ExplorerFrame = BuildRepExplorerFrame() end
	RWRoot.Scanner.ExplorerFrame:InitFrame()
	RWRoot.Scanner.ExplorerFrame:SetVisible(true)
end


-- Config window -----------------------------------------------------------


local function BuildConfigWindow()

	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)

	window:SetTitle(RWRoot.locTxt.Scanner.ModuleName)
	window:SetHeight(660)
	window:SetWidth(770)
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	MTools.buildWindowMover("ConfigWindow", window)
	
	window.BackImage = 	UI.CreateFrame("Texture", "BackImage", window)
	window.BackImage:SetLayer(-1)
	window.BackImage:SetTexture(RWData.AddonIdentifier, "resources\\scanback.jpg")
	window.BackImage:SetPoint("TOPLEFT", window, "TOPLEFT", 30, 300)
	window.BackImage:SetAlpha(0.8)
	
	
	-- boutons
	window.bbClose =  MTools.buildButton("btClose", window, 50, 50, "x", "close")
	window.bbClose:SetPoint("TOPRIGHT", window, "TOPRIGHT", -8, 15)

	window.btOk =  MTools.buildButton("btOk", window, 110, 40, RWRoot.locTxt.buttonOk)
	window.btOk:SetPoint("TOPLEFT", window, "TOPLEFT", 30, 600)
	
	window.btCancel =  MTools.buildButton("btAnnuler", window, 110, 40, RWRoot.locTxt.buttonCancel)
	window.btCancel:SetPoint("TOPLEFT", window, "TOPLEFT", 145, 600)

	window.btApply =  MTools.buildButton("btApply", window, 110, 40, RWRoot.locTxt.buttonApply)
	window.btApply:SetPoint("TOPLEFT", window, "TOPLEFT", 630, 600)

	window.btRepExplorer =  MTools.buildButton("btRepExplorer", window, 140, 40, RWRoot.locTxt.Scanner.cfgBtnExplorer)
	window.btRepExplorer:SetPoint("TOPLEFT", window, "TOPLEFT", 480, 600)

	-- caster
	window.ttCasterTitle = MTools.buildShadowTitle("ttCasterTitle", window, 360, 25, RWRoot.locTxt.Scanner.cfgCasterTitle)
	window.ttCasterTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 390, 70)
	
	window.ckIgnoreHostileCaster = MTools.buildCheckBox("ckIgnoreHostileCaster", window, 360, 20, RWRoot.locTxt.Scanner.cfgIgnoreHCaster)
	window.ckIgnoreHostileCaster:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 100)
	
	window.ckIgnoreFriendlyCaster = MTools.buildCheckBox("ckIgnoreFriendlyCaster", window, 360, 20, RWRoot.locTxt.Scanner.cfgIgnoreFCaster)
	window.ckIgnoreFriendlyCaster:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 130)
	
	window.ebLookForCaster = MTools.buildEditBox("ebLookForCaster", window, 340, 22, RWRoot.locTxt.Scanner.cfgCheckCaster)
	window.ebLookForCaster:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 160)
	
	window.lbLookForCasterHelp = MTools.buildLabel("lbLookForCasterHelp", window, 360, 12, RWRoot.locTxt.Scanner.cfgCheckHelper)
	window.lbLookForCasterHelp:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 180)
	
	-- target
	window.ttTargetTitle = MTools.buildShadowTitle("ttTargetTitle", window, 360, 25, RWRoot.locTxt.Scanner.cfgTargetTitle)
	window.ttTargetTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 390, 210)
	
	window.ckIgnoreHostileTarget = MTools.buildCheckBox("ckIgnoreHostileTarget", window, 360, 20, RWRoot.locTxt.Scanner.cfgIgnoreHTarget)
	window.ckIgnoreHostileTarget:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 240)
	
	window.ckIgnoreFriendlyTarget = MTools.buildCheckBox("ckIgnoreFriendlyTarget", window, 360, 20, RWRoot.locTxt.Scanner.cfgIgnoreFTarget)
	window.ckIgnoreFriendlyTarget:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 270)
	
	window.ckShowFullTargetData = MTools.buildCheckBox("ckShowFullTargetData", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowFullTData)
	window.ckShowFullTargetData:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 300)

	window.ebLookForTarget = MTools.buildEditBox("ebLookForTarget", window, 340, 20, RWRoot.locTxt.Scanner.cfgCheckTarget)
	window.ebLookForTarget:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 330)
	
	window.lbLookForTargetHelp = MTools.buildLabel("lbLookForTargetHelp", window, 360, 12, RWRoot.locTxt.Scanner.cfgCheckHelper)
	window.lbLookForTargetHelp:SetPoint("TOPLEFT", window, "TOPLEFT", 400, 350)
	
	-- Options de rapport
	window.ttReportTitle = MTools.buildShadowTitle("ttReportTitle", window, 360, 25, RWRoot.locTxt.Scanner.cfgCombatReport)
	window.ttReportTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 390, 380)
	
	window.ckReportActivated = MTools.buildCheckBox("ckReportActivated", window, 360, 20, RWRoot.locTxt.Scanner.cfgActivateReport)
	window.ckReportActivated:SetPoint("TOPLEFT", window.ttReportTitle, "TOPLEFT", 10, 30)
	
	window.ckShowReportOnly = MTools.buildCheckBox("ckShowReportOnly", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowReportOnly)
	window.ckShowReportOnly:SetPoint("TOPLEFT", window.ckReportActivated, "TOPLEFT", 0, 30)
	
	window.ckReportOnCasterOnly = MTools.buildCheckBox("ckReportOnCasterOnly", window, 360, 20, RWRoot.locTxt.Scanner.cfgIgnoreRepTData)
	window.ckReportOnCasterOnly:SetPoint("TOPLEFT", window.ckShowReportOnly, "TOPLEFT", 0, 30)	
	
	window.ckRepShowExplorer = MTools.buildCheckBox("ckRepShowExplorer", window, 360, 20, RWRoot.locTxt.Scanner.cfgOpenExplorer)
	window.ckRepShowExplorer:SetPoint("TOPLEFT", window.ckReportOnCasterOnly, "TOPLEFT", 0, 30)	
	
	window.slReportDetailLevel = MTools.buildTextSlider("slReportDetailLevel", window, 340, 20, RWRoot.locTxt.Scanner.cfgRepDetailLvl, 1,
									{ RWRoot.locTxt.Scanner.cfgRepDetailLvl1, RWRoot.locTxt.Scanner.cfgRepDetailLvl2, RWRoot.locTxt.Scanner.cfgRepDetailLvl3}, 
									{ RWRoot.locTxt.Scanner.cfgRepLvlHelper1, RWRoot.locTxt.Scanner.cfgRepLvlHelper2, RWRoot.locTxt.Scanner.cfgRepLvlHelper3} )
	window.slReportDetailLevel:SetPoint("TOPLEFT", window.ckRepShowExplorer, "TOPLEFT", 0, 55)	
	
	-- options de scan
	window.ttScanActionTitle = MTools.buildShadowTitle("ttScanActionTitle", window, 360, 25, RWRoot.locTxt.Scanner.cfgScanActions)
	window.ttScanActionTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 70)
	
	window.ckShowDebuffs = MTools.buildCheckBox("ckShowDebuffs", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowDebuffs)
	window.ckShowDebuffs:SetPoint("TOPLEFT", window.ttScanActionTitle, "TOPLEFT", 10, 30)

	window.ckShowGoodBuffs = MTools.buildCheckBox("ckShowGoodBuffs", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowBuffs)
	window.ckShowGoodBuffs:SetPoint("TOPLEFT", window.ckShowDebuffs, "TOPLEFT", 0, 30)

	window.ckShowEmotes = MTools.buildCheckBox("ckShowEmotes", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowEmote)
	window.ckShowEmotes:SetPoint("TOPLEFT", window.ckShowGoodBuffs, "TOPLEFT", 0, 30)
	
	window.ckShowUnitDeath = MTools.buildCheckBox("ckShowUnitDeath", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowNPCChat)
	window.ckShowUnitDeath:SetPoint("TOPLEFT", window.ckShowEmotes, "TOPLEFT", 0, 30)
	
	window.ckShowDamage = MTools.buildCheckBox("ckShowDamage", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowDmgSpells)
	window.ckShowDamage:SetPoint("TOPLEFT", window.ckShowUnitDeath, "TOPLEFT", 0, 30)
	
	window.ckShowHeal = MTools.buildCheckBox("ckShowHeal", window, 360, 20, RWRoot.locTxt.Scanner.cfgShowHealSpells)
	window.ckShowHeal:SetPoint("TOPLEFT", window.ckShowDamage, "TOPLEFT", 0, 30)
	
		
	function window:LoadData()
	
		self.ckIgnoreHostileCaster:SetChecked(RWConfig.Scanner.IgnoreHostileCaster)
		self.ckIgnoreFriendlyCaster:SetChecked(RWConfig.Scanner.IgnoreFriendlyCaster)
		self.ebLookForCaster.text:SetText(RWConfig.Scanner.LookForCaster)		
	
		self.ckIgnoreHostileTarget:SetChecked(RWConfig.Scanner.IgnoreHostileTarget)
		self.ckIgnoreFriendlyTarget:SetChecked(RWConfig.Scanner.IgnoreFriendlyTarget)
		self.ckShowFullTargetData:SetChecked(RWConfig.Scanner.ShowFullTargetData)
		self.ebLookForTarget.text:SetText(RWConfig.Scanner.LookForTarget)	

		self.ckReportActivated:SetChecked(RWConfig.Scanner.ReportActivated)
		self.ckShowReportOnly:SetChecked(RWConfig.Scanner.ShowReportOnly)
		self.ckReportOnCasterOnly:SetChecked(RWConfig.Scanner.ReportOnCasterOnly)
		self.ckRepShowExplorer:SetChecked(RWConfig.Scanner.RepShowExplorer)
		self.slReportDetailLevel:SetValue(RWConfig.Scanner.ReportDetailLevel)
	
		self.ckShowDebuffs:SetChecked(RWConfig.Scanner.ShowDebuffs)
		self.ckShowGoodBuffs:SetChecked(RWConfig.Scanner.ShowGoodBuffs)
		self.ckShowEmotes:SetChecked(RWConfig.Scanner.ShowEmotes)
		self.ckShowUnitDeath:SetChecked(RWConfig.Scanner.ShowUnitDeath)
		self.ckShowDamage:SetChecked(RWConfig.Scanner.ShowDamage)
		self.ckShowHeal:SetChecked(RWConfig.Scanner.ShowHeal)		
	end
	
	function window:SaveData()
	
		RWConfig.Scanner.IgnoreHostileCaster = self.ckIgnoreHostileCaster:GetChecked()
		RWConfig.Scanner.IgnoreFriendlyCaster = self.ckIgnoreFriendlyCaster:GetChecked()
	
		RWConfig.Scanner.IgnoreHostileTarget = self.ckIgnoreHostileTarget:GetChecked()
		RWConfig.Scanner.IgnoreFriendlyTarget = self.ckIgnoreFriendlyTarget:GetChecked()
		RWConfig.Scanner.ShowFullTargetData = self.ckShowFullTargetData:GetChecked()
	
		RWConfig.Scanner.ReportActivated = self.ckReportActivated:GetChecked()
		RWConfig.Scanner.ShowReportOnly = self.ckShowReportOnly:GetChecked()
		RWConfig.Scanner.ReportOnCasterOnly = self.ckReportOnCasterOnly:GetChecked()
		RWConfig.Scanner.RepShowExplorer = self.ckRepShowExplorer:GetChecked()
		RWConfig.Scanner.ReportDetailLevel = self.slReportDetailLevel:GetValue()

		RWConfig.Scanner.ShowDebuffs = self.ckShowDebuffs:GetChecked()
		RWConfig.Scanner.ShowGoodBuffs = self.ckShowGoodBuffs:GetChecked()
		RWConfig.Scanner.ShowEmotes = self.ckShowEmotes:GetChecked()
		RWConfig.Scanner.ShowUnitDeath = self.ckShowUnitDeath:GetChecked()
		RWConfig.Scanner.ShowDamage = self.ckShowDamage:GetChecked()
		RWConfig.Scanner.ShowHeal = self.ckShowHeal:GetChecked()
		
		local FocusName = self.ebLookForCaster.text:GetText()
		if FocusName and FocusName:match("%a+") then
			RWConfig.Scanner.LookForCaster = FocusName
		else
			RWConfig.Scanner.LookForCaster = ""
		end		

		FocusName = self.ebLookForTarget.text:GetText()
		if FocusName and FocusName:match("%a+") then
			RWConfig.Scanner.LookForTarget = FocusName
		else
			RWConfig.Scanner.LookForTarget = ""
		end		
		
		print(RWRoot.locTxt.Scanner.cfgOptionsSaved)
	end
	
	function window:CloseWindow()
		window:SetVisible(false)
		window.ebLookForCaster.text:SetKeyFocus(false)
		window.ebLookForTarget.text:SetKeyFocus(false)
	end
	
	function window.bbClose.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btApply.Event:LeftPress()
		window:SaveData()		
	end	
	
	function window.btCancel.Event:LeftPress()
		window.bbClose.Event:LeftPress()		
	end
	
	function window.btOk.Event:LeftPress()
		window:SaveData()
		window.bbClose.Event:LeftPress()		
	end

	function window.btRepExplorer.Event:LeftPress()
		RWRoot.Scanner.ShowReportExplorer()
	end

	RWRoot.Scanner.ConfigWindow = window
	return window
end


--	Button registration ----------------------

RWRoot.HermesButton.MainButton:RegisterMenuButton(RWRoot.locTxt.Scanner.abTitle, 
	"scancfg", RWRoot.locTxt.Scanner.abScanConfig, {
		"Resources\\Button\\ScanCfgUp.png",
		"Resources\\Button\\ScanCfgIn.png",
		"Resources\\Button\\ScanCfgDown.png"}):RegisterModButton(
	"scanexplore", RWRoot.locTxt.Scanner.abShowExplorer, {
		"Resources\\Button\\ScanRepExpUp.png",
		"Resources\\Button\\ScanRepExpIn.png",
		"Resources\\Button\\ScanRepExpDown.png"}):RegisterModButton(
	"scanbuff", RWRoot.locTxt.Scanner.abScanTarget, {
		"Resources\\Button\\ScanPlayerUp.png",
		"Resources\\Button\\ScanPlayerIn.png",
		"Resources\\Button\\ScanPlayerDown.png"})


--	Config win registration ----------------------

RWRoot.ConfigWinManager:RegisterWindow("ScanExpImpWin", BuildExportImportWindow)
RWRoot.ConfigWinManager:RegisterWindow("ScanExpHelpWin", BuildExplorerHelpWindow)
RWRoot.ConfigWinManager:RegisterWindow("ScanConfigWin", BuildConfigWindow)
