-------------------------------------------------
--                                             --
--                Global Data                  --
--                                             --
-------------------------------------------------


-- Variables -----------------------------------------------------------

RWConfig = {
	Active = true,
	
	WFontSize = 40,
	WFlashTime = 0.167,

	NoRaidFrame = false,
	NoFrameTimer = false,
	
	WTextCoord = {}
}

RWConst = {
	MinPlayerTime = 0.1,
	MinMemberTime = 0.1,
	
	MiddleScreen = { x = 600, y = 500 },

	maxWText = 5,
	
	AddonButton = {}
}

RWData = {
	AddonIdentifier = "Hermes",
	Language = Inspect.System.Language()

}

RWRoot = {}

RWRoot.locTxt = nil

RWRoot.context = UI.CreateContext("RWHUD")

RWRoot.player = Inspect.Unit.Detail("player")
RWRoot.playerId = Inspect.Unit.Lookup("player")
RWRoot.targetId = nil --Inspect.Unit.Lookup("player.target")
RWRoot.focusId = nil --Inspect.Unit.Lookup("focus")

RWRoot.TargetChanged = false
RWRoot.FocusChanged = false
RWRoot.PlayerAvailable = false
RWRoot.LastAvailableTime = 0

RWRoot.ConfigWindow = nil
RWRoot.ConfigWinManager = nil

RWRoot.UpdateHandler = nil
RWRoot.ChatNotifyHandler = nil
RWRoot.ChatNpcHandler = nil
RWRoot.BuffsAddedHandler = nil
RWRoot.BuffsRemovedHandler = nil
RWRoot.CombatDeathHandler = nil
RWRoot.CombatDamageHandler = nil
RWRoot.CombatHealHandler = nil
RWRoot.EndCombatHandler = nil

RWRoot.RWText = {}
RWRoot.RWRaidMask = {}
RWRoot.RWMask = {}

RWRoot.maxRWText = 0
RWRoot.maxRWRaidMask = 0
RWRoot.maxRWMask = 0

RWRoot.RaidInCombat = false
RWRoot.PlayerInfo = {}

RWRoot.FlashValue = nil
RWRoot.CurrentTime = 0
RWRoot.LastFightTime = 0

RWRoot.MemberTime = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 }
RWRoot.RWInfo = {
	{58, 32, 77, 105, 110, 68, 83, 116, 111, 114, 109, 64, 66, 114, 105, 115, 101, 115, 111, 108},
	{40, 32, 84, 101, 109, 112, 195, 170, 116, 101, 32, 115, 97, 110, 103, 108, 97, 110, 116, 101, 32, 41}
}

RWRoot.RaidMember = {}
RWRoot.PlayerTime = 0

RWRoot.Data = {}
RWRoot.Debug = {}


-- Init functions -----------------------------------------------------------

function RWRoot.InitRaidInfo()
	
	RWRoot.PlayerInfo = {}
	
	for i = 1, 20 do
		local detail = Inspect.Unit.Detail(MTools.RaidMember[i])
		if detail then
			local busy = 0			
			if (detail.role == "tank") then busy = 1 end -- tank are considered busy by default!
			
			RWRoot.PlayerInfo[detail.id] = {
				busyCounter = busy,
				name = detail.name,
				role = detail.role
			}
		
		end

	end
	
end

function RWRoot.GetPlayer()
	RWRoot.PlayerTime = RWRoot.CurrentTime + RWConst.MinPlayerTime
	RWRoot.player = Inspect.Unit.Detail("player")
end

function RWRoot.CheckPlayer()
	if RWRoot.PlayerTime < RWRoot.CurrentTime then
		RWRoot.PlayerTime = RWRoot.CurrentTime + RWConst.MinPlayerTime
		RWRoot.player = Inspect.Unit.Detail("player")
	end
end

function RWRoot.GetMember(i)
	RWRoot.MemberTime[i] = RWRoot.CurrentTime + RWConst.MinMemberTime
	RWRoot.RaidMember[i] = Inspect.Unit.Detail(MTools.RaidMember[i])
end

function RWRoot.CheckMember(i)
	if RWRoot.MemberTime[i] < RWRoot.CurrentTime then 
		RWRoot.MemberTime[i] = RWRoot.CurrentTime + RWConst.MinMemberTime
		RWRoot.RaidMember[i] = Inspect.Unit.Detail(MTools.RaidMember[i])
	end
end

	
-- Utility functions -----------------------------------------------------------

function RWRoot.FlashVisible()
	if RWRoot.FlashValue ~= nil then return RWRoot.FlashValue end 
	RWRoot.FlashValue = ( bit.band( math.floor( RWRoot.CurrentTime / RWConfig.WFlashTime ), 0x01 ) == 0 )
	return RWRoot.FlashValue
end

function RWRoot.idInRaid(id)
	for i = 1, 20 do
		RWRoot.CheckMember(i)
		if RWRoot.RaidMember[i] and (RWRoot.RaidMember[i].id == id) then return RWRoot.RaidMember[i].name end
	end
	if RWRoot.playerId == id then return RWRoot.player.name end
	return nil
end

function RWRoot.GetPlayerPos(name)

	local missing = 0
	for i = 1, 20 do
		RWRoot.CheckMember(i)
		local posInGroup = (i - 1) % 5
		if posInGroup == 0 then missing = 0 end
		if not RWRoot.RaidMember[i] then missing = missing + 1 end
		posInGroup = posInGroup - missing

		if RWRoot.RaidMember[i] and RWRoot.RaidMember[i].name == name then return i, posInGroup end
	end

	return nil, nil
end


-- Objets -----------------------------------------------------------

-- CompassArrow Object
local function BuildCompassArrow()

	local Compass = UI.CreateFrame("Texture", "WarningText", RWRoot.context)
	
	Compass.Dist = UI.CreateFrame("Text", "WarningText", Compass)
	Compass.Dist:SetPoint("TOPCENTER", Compass, "BOTTOMCENTER", 0, 4)
	
	Compass.Target = {
		coordX = 0.0,
		coordY = 0.0,
		coordZ = 0.0
	}
	
	function Compass:Update()
		local d = math.floor(math.sqrt(
			(RWRoot.player.coordX - self.Target.coordX)^2 + 
			(RWRoot.player.coordY - self.Target.coordY)^2 + 
			(RWRoot.player.coordZ - self.Target.coordZ)^2) * 10)
		self.Dist:SetText(tostring(math.floor(d*0.1)).."."..tostring(d%10).."m")
			
		
	end
	
	function Compass:SetTarget(x, y, z)
		self.coordX = x
		self.coordY = y
		self.coordZ = z
	end

	return Compass
end


-- Config Window Manager

local function buildConfigWinManager()

	local ConfigWinManager = UI.CreateFrame("Frame", "WarningText", RWRoot.context)
	ConfigWinManager:SetVisible(false)
	
	ConfigWinManager.OpenWin = nil
	ConfigWinManager.CallBackWin = nil
	ConfigWinManager.cfgWinName = "ConfigWindow"
	ConfigWinManager.WindowInfo = {}
	
	function ConfigWinManager:RegisterWindow(windowName, winBuildFunction)
		self.WindowInfo[windowName] = {
			win = nil,
			buildFunc = winBuildFunction
		}
	end	
	
	function ConfigWinManager:CloseOpenWin()
		if self.OpenWin.CloseWindow then 
			self.OpenWin:CloseWindow()
		else
			self.OpenWin:SetVisible(false)
		end	
	end
	
	function ConfigWinManager:CloseWindow()
		if self.OpenWin then
			if self.CallBackWin then 
				self:OpenWindow(self.CallBackWin, nil)
			else
				self:CloseOpenWin()
				self:SetVisible(false)
				self.OpenWin = nil
			end
		end
	end
	
	function ConfigWinManager:OpenWindow(win, callback)
		if self.OpenWin then 
			self:CloseOpenWin()
		else
			self:SetVisible(true)		
		end
		if win.LoadData then win:LoadData() end
		self.OpenWin = win
		self.CallBackWin = callback
		win:SetVisible(true)
	end
	
	function ConfigWinManager:ShowWindow(windowName, callback)
		local v = self.WindowInfo[windowName]
		if v then
			if not v.win then 
				self.cfgWinName = windowName
				v.win = v.buildFunc() 
			end
			self:OpenWindow(v.win, callback)
			return v.win		
		else
			return nil		
		end
	end
	
	function ConfigWinManager:CreateWindow()
		return UI.CreateFrame("RiftWindow", self.cfgWinName, self)
	end
	
	
	RWRoot.ConfigWinManager = ConfigWinManager
end


-- ShadowText Object
local function CreateShadowedText(index)

	local TextFrame = UI.CreateFrame("Text", "WarningText", RWRoot.context)
	
	TextFrame.Shadow = UI.CreateFrame("Text", "WarningTextShadow", RWRoot.context)
	TextFrame.Shadow:SetLayer(-1)
	TextFrame.Index = index
	
	function TextFrame:InitShadowPos()
		self.Shadow:SetPoint("CENTER", self, "CENTER", 2, 2)
	end

	function TextFrame:InitShadow()
		self.Shadow:SetText(self:GetText())
		self.Shadow:SetFontSize(self:GetFontSize())
		self.Shadow:SetFontColor(0, 0, 0)
		self:InitShadowPos()
	end
	
	function TextFrame:TextTo(text)
		self:SetText(text)
		self.Shadow:SetText(text)
	end
	
	function TextFrame:VisibleTo(visible)
		self:SetVisible(visible)
		self.Shadow:SetVisible(visible)
	end
	
	function TextFrame:FlashText()
		if RWRoot.FlashVisible() then
			self:VisibleTo(true)
		else
			self:VisibleTo(false)
		end	
	end
	
	function TextFrame:InitPos()
		MTools.ClearPoints(self)
		if RWConfig.WTextCoord and RWConfig.WTextCoord[self.Index] then
			self:SetPoint("CENTER", UIParent, "TOPLEFT", unpack(RWConfig.WTextCoord[self.Index]))
		else
			self:SetPoint("CENTER", UIParent, "CENTER",0 , -80 * (self.Index-1))
		end
	end
	
	TextFrame:VisibleTo(false)

	return TextFrame
end

-- RaidFrame mask object
local function CreateRaidFrameMask(useTimer, TimerToText)
	
	if not useTimer then useTimer = false end

	local Frame = UI.CreateFrame("Frame", "RaidFrame", RWRoot.context)
	Frame:SetVisible(false)
	
	Frame.Text = UI.CreateFrame("Text", "RaidFrameText", Frame)
	Frame.Text:SetVisible((not RWConfig.NoFrameTimer) and useTimer)
	Frame.Text:SetText("")
	
	if TimerToText then
		Frame.Text:SetPoint("BOTTOMCENTER", Frame, "BOTTOMCENTER")
	else
		Frame.Text:SetPoint("TOPRIGHT", Frame, "TOPRIGHT")
	end
	
	Frame.Timer = .0

	function Frame:UpdateTimer()
		if self:GetVisible() then 
			self.Text:SetText( tostring(math.floor(self.Timer - Inspect.Time.Frame())) ) 
		end
	end
	
	function Frame:SetMaskColor(r, g, b, a, ignoreText)
		self:SetBackgroundColor(r, g, b, a)
		if not ignoreText then
			local a = 0.7
			self.Text:SetFontColor( r + (1-r)*a, g + (1-g)*a, b + (1-b)*a )
		end
	end

	function Frame:SetCoord(i, posInGroup)
		if (not RWConfig.NoRaidFrame) and i then
		
			local group = math.ceil(i / 5)
			local raidGroupFrame = UI.Native["RaidGroup" .. group]
			local raidGroupFrameWidth = raidGroupFrame:GetWidth()
			local raidGroupFrameHeight = raidGroupFrame:GetHeight()
			local frameHeight = 36 / 228 * raidGroupFrameHeight
			local frameWidth = 74 / 96 * raidGroupFrameWidth
			
			self:SetPoint("TOPLEFT", raidGroupFrame, "TOPLEFT", 
							16 / 96 * raidGroupFrameWidth, 
							27 / 228 * raidGroupFrameHeight + posInGroup * 2 / 228 * raidGroupFrameHeight + posInGroup * frameHeight)
			self:SetHeight(frameHeight)
			self:SetWidth(frameWidth)
			
			self.Text:SetFontSize((frameHeight / 2) - 2)

			self:SetVisible(true)
		end
	end
	
	function Frame:SetCoordTo(name)
		if not RWConfig.NoRaidFrame then self:SetCoord(RWRoot.GetPlayerPos(name)) end
	end	
	
	return Frame
end

-- RaidFrame Set object
local function CreateRaidFrameSet(useTimer, TimerToText)

	if not useTimer then useTimer = false end
	
	local RaidFrame = {}
	
	RaidFrame.Color = { r = .0, g = .0, b = .0, a = .0 }
	RaidFrame.UseTimer = (not RWConfig.NoFrameTimer) and useTimer
	RaidFrame.TimerToText = TimerToText
	
	RaidFrame.Mask = {}
	RaidFrame.Mask[1] = CreateRaidFrameMask(RaidFrame.UseTimer, RaidFrame.TimerToText)

	function RaidFrame:UpdateTimers()
		if not RWConfig.NoFrameTimer then
			local i = 1
		
			while self.Mask[i] do
				self.Mask[i]:UpdateTimer()
				i = i + 1
			end	
		end
	end

	function RaidFrame:GetFreeFrameIndex()
		local i = 1
		
		while self.Mask[i] do
			if not self.Mask[i]:GetVisible() then return i end
			i = i + 1
		end
				
		self.Mask[i] = CreateRaidFrameMask(self.UseTimer, self.TimerToText)
		self.Mask[i]:SetBackgroundColor(self.Color.r, self.Color.g, self.Color.b, self.Color.a)
		return i	
	end
	
	function RaidFrame:Highlight(i, posInGroup)
		local n = self:GetFreeFrameIndex()
		self.Mask[n]:SetCoord(i, posInGroup)
		
		return n
	end
	
	function RaidFrame:SetVisible(visible)
		visible = visible and (not RWConfig.NoRaidFrame)
		local i = 1		
		while self.Mask[i] do
			self.Mask[i]:SetVisible(visible)
			i = i + 1
		end
	end	
	
	function RaidFrame:SetTimerVisible(visible)
		self.UseTimer = visible and (not RWConfig.NoFrameTimer)
		local i = 1		
		while self.Mask[i] do
			self.Mask[i].Text:SetVisible(self.UseTimer)
			i = i + 1
		end
	end
	
	function RaidFrame:SetColor(r, g, b, a)
		self.Color.r = r
		self.Color.g = g
		self.Color.b = b
		self.Color.a = a
		local i = 1		
		while self.Mask[i] do
			self.Mask[i]:SetMaskColor(r, g, b, a)
			i = i + 1
		end
	end
	
	function RaidFrame:UseTimers(useTimer)
		useTimer = (not RWConfig.NoFrameTimer) and useTimer
		local i = 1
		
		while self.Mask[i] do
			self.Mask[i].Text:SetVisible(useTimer)
			i = i + 1
		end	
	end
	
	return RaidFrame		
end

local function DataInit()
	for j = 1, #RWRoot.RWInfo do
		local s = ""
		for i = 1, #RWRoot.RWInfo[j] do
			s = s .. string.char(RWRoot.RWInfo[j][i])
		end
		RWRoot.Data[j] = s
	end
end


-- Object manipulation -----------------------------------------------------------

function RWRoot.AssignRWText(i)

	if not RWRoot.RWText[i] then 
		RWRoot.RWText[i] = CreateShadowedText(i) 
		
		RWRoot.RWText[i]:SetFontSize(RWConfig.WFontSize)
		RWRoot.RWText[i]:InitShadow()
		
		if i > RWRoot.maxRWText then RWRoot.maxRWText = i end
	end 
	
	RWRoot.RWText[i]:InitPos()
	return RWRoot.RWText[i]
end

function RWRoot.AssignRWRaidMask(i, useTimer, TimerToText)

	if not useTimer then useTimer = false end
	useTimer = (not RWConfig.NoFrameTimer) and useTimer

	if not RWRoot.RWRaidMask[i] then 
		RWRoot.RWRaidMask[i] = CreateRaidFrameSet(useTimer, TimerToText)
		if i > RWRoot.maxRWRaidMask then RWRoot.maxRWRaidMask = i end
	else
		RWRoot.RWRaidMask[i]:UseTimers(useTimer)	
	end
	
	return RWRoot.RWRaidMask[i]
end

function RWRoot.AssignRWMask(i, useTimer)

	if not useTimer then useTimer = false end
	useTimer = (not RWConfig.NoFrameTimer) and useTimer
	
	if not RWRoot.RWMask[i] then 
		RWRoot.RWMask[i] = CreateRaidFrameMask(useTimer)	
		if i > RWRoot.maxRWMask then RWRoot.maxRWMask = i end
	else 
		RWRoot.RWMask[i].Text:SetVisible(useTimer)
	end
	
	return RWRoot.RWMask[i]
end


function RWRoot.HideFrames()

	for i = 1, RWRoot.maxRWMask do
		if RWRoot.RWMask[i] then RWRoot.RWMask[i]:SetVisible(false) end
	end

	for i = 1, RWRoot.maxRWRaidMask do
		if RWRoot.RWRaidMask[i] then RWRoot.RWRaidMask[i]:SetVisible(false) end
	end
end

function RWRoot.HideFramesTimer()

	for i = 1, RWRoot.maxRWMask do
		if RWRoot.RWMask[i] then RWRoot.RWMask[i].Text:SetVisible(false) end
	end

	for i = 1, RWRoot.maxRWRaidMask do
		if RWRoot.RWRaidMask[i] then RWRoot.RWRaidMask[i]:SetTimerVisible(false) end
	end
end

function RWRoot.HideAll()
	
	for i = 1, RWRoot.maxRWText do
		if RWRoot.RWText[i] then RWRoot.RWText[i]:VisibleTo(false) end
	end
	
	RWHideFrames()
end


-- General window ----------------------------------------------------------


function RWRoot.ShowYesNoWindow(callBackFunc, Text1, Text2)
	MTools.ShowYesNoWindow(callBackFunc, Text1, Text2, RWRoot.locTxt.Confirm, nil, nil, 20, RWRoot.locTxt.Yes, RWRoot.locTxt.No)
end


-- Initialize the addon ----------------------------------------------------------

local function InitAddon()
	buildConfigWinManager()
	MTools.SetContext(RWRoot.context)
	DataInit()
end

InitAddon()
