----------------------------------------------------------
--                                                      --
--                        Hermes                        --
--                    The patron God                    --
--                                                      --
--              Author: MinDStorm@Brisesol              --
--                   Tempête Sanglante                  --
--                                                      --
----------------------------------------------------------

RWData.version = "0.25a"

-------------------------------------------------------------------------

RWConfig.Version = MTools.GetVersionNumbers(RWData.version)
DefaultRWConfig = MTools.CopyTable( RWConfig )

local UpdateRWConfig = {}
--local UpdateRWConfig[1] = {}


-- Handlers -----------------------------------------------------------


local function EventCombatDamage(handle, info)
	
	if RWConfig.Active then
		if RWRoot.CombatDamageHandler then RWRoot.CombatDamageHandler(handle, info) end
		if (info.caster == RWRoot.playerId) and (info.target ~= RWRoot.playerId) and RWConfig.MindEye.Active then RWRoot.MindEye.MindEyeFrame:UpdateID(info) end
		if not RWConfig.Scanner.Active then return end
		RWRoot.Scanner.EventCombatDamage(handle, info)
	end
end

local function EventCombatHeal(handle, info)
	
	if RWConfig.Active then
		if RWRoot.CombatHealHandler then RWRoot.CombatHealHandler(handle, info) end
		if not RWConfig.Scanner.Active then return end
		RWRoot.Scanner.EventCombatHeal(handle, info)
	end
end

local function EventCombatDeath(handle, info)
	
	if RWConfig.Active then
		if RWRoot.CombatDeathHandler then RWRoot.CombatDeathHandler(handle, info) end
		if RWConfig.MindEye.Active and RWRoot.MindEye.MindEyeFrame.ActiveFocus[info.target] then RWRoot.MindEye.MindEyeFrame.ActiveFocus[info.target]:SetDead() end
		if not RWConfig.Scanner.Active then return end
		RWRoot.Scanner.EventCombatDeath(handle, info)
	end
end

local function EventChatNpc(handle, info)

	if RWConfig.Active then
		if RWRoot.ChatNpcHandler then RWRoot.ChatNpcHandler(handle, info) end
		if not RWConfig.Scanner.Active then return end
		RWRoot.Scanner.EventChatNpc(handle, info)
	end	
end

local function EventChatNotify(handle, info)

	if RWConfig.Active then
		if RWRoot.ChatNotifyHandler then RWRoot.ChatNotifyHandler(handle, info) end
		if not RWConfig.Scanner.Active then return end
		RWRoot.Scanner.EventChatNotify(handle, info)
	end
end

local function BuffsAdded(handle, id, buffs)

	if RWConfig.Active then
		if RWRoot.BuffsAddedHandler then RWRoot.BuffsAddedHandler(handle, id, buffs) end
		if (not RWRoot.RaidInCombat) and RWConfig.Hestia.Active then RWRoot.Hestia.BuffsAdded(handle, id, buffs) end
		if not RWConfig.Scanner.Active then return end
		RWRoot.Scanner.BuffsAdded(handle, id, buffs)
	end
end

local function BuffsRemoved(handle, id, buffs)

	if RWConfig.Active and RWRoot.BuffsRemovedHandler then 
		RWRoot.BuffsRemovedHandler(handle, id, buffs) 
	end
end

local function Update(handle)

	if RWConfig.Active then

		RWRoot.FlashValue = nil
		RWRoot.CurrentTime = Inspect.Time.Frame()
		local unitID = Inspect.Unit.Lookup("player.target")
		RWRoot.TargetChanged = (unitID ~= RWRoot.targetId)
		RWRoot.targetId = unitID
		unitID = Inspect.Unit.Lookup("focus")
		RWRoot.FocusChanged = (unitID ~= RWRoot.focusId)
		RWRoot.focusId = unitID

		-- all time modules
		if RWRoot.HermesButton.NeedUpdate then RWRoot.HermesButton.MainButton:Update() end
		if RWConfig.MindEye.Active then RWRoot.MindEye.MindEyeFrame:Update() end
		if RWConfig.ProxyWarn.Active then RWRoot.ProxyWarn.Update() end

		-- combat only modules
		if RWRoot.RaidInCombat then
			if RWRoot.UpdateHandler then RWRoot.UpdateHandler(handle) end
			return
		end	
		
		-- out of combat modules		
		if RWConfig.Hestia.Active then RWRoot.Hestia.Update() end
		
	end
end

local function StartCombat()

	if RWConfig.Hestia.Active then RWRoot.Hestia.CombatStart() end
	if RWConfig.Scanner.Active then RWRoot.Scanner.InitData() end
		
	if RWConfig.Crucia.Active and (RWRoot.player.locationName == RWData.Crucia.ZoneName) then
		RWRoot.Crucia.StartCombat()

	elseif RWConfig.Matriarche.Active and (RWRoot.player.locationName == RWData.Matriarche.ZoneName) then
		RWRoot.Matriarche.StartCombat()
		
	end
	
end

local function EndCombat()
	RWRoot.LastFightTime = RWRoot.CurrentTime
	if RWRoot.EndCombatHandler then RWRoot.EndCombatHandler(handle) end
	if RWConfig.ProxyWarn.Active then RWRoot.ProxyWarn.InitData() end	
	if RWConfig.Hestia.Active then RWRoot.Hestia.CombatEnds() end
	if RWConfig.Scanner.Active then RWRoot.Scanner.ReportDone() end
end

local function CheckCombat()
	
	RWRoot.GetPlayer()
	local inCombat = (RWRoot.player and RWRoot.player.combat) or false
		
	if (not inCombat) and RWRoot.player then
		for i = 1, 20 do
			RWRoot.GetMember(i)
			if RWRoot.RaidMember[i] and RWRoot.RaidMember[i].combat and (RWRoot.RaidMember[i].zone == RWRoot.player.zone) then inCombat = true break end
		end
	end
	
	if RWRoot.RaidInCombat ~= inCombat then 
		RWRoot.RaidInCombat = inCombat
		if inCombat then
			StartCombat()
		else
			EndCombat()
		end
	end	
end

local function UnitDetailCombat()
	if RWConfig.Active then CheckCombat() end
end

local function SystemSecureLeave()	
	if RWRoot.RaidInCombat then CheckCombat() end
end

local function SystemSecureEnter()
	
	if RWConfig.Active and (not RWRoot.RaidInCombat) then
		RWRoot.GetPlayer()
		if RWRoot.player.combat then
			RWRoot.RaidInCombat = true
			StartCombat()
		end	
	end
end

local function UnitAvailabilityFull(handle, units)
	for k, _ in pairs(units) do
		if k == RWRoot.playerId then 
			RWRoot.LastAvailableTime = RWRoot.CurrentTime
			RWRoot.PlayerAvailable = true 
			if RWRoot.Hestia.Active then RWRoot.Hestia.AvailabilityFull() end
			if RWRoot.RaidInCombat then CheckCombat() end
			break 
		end
	end	
end

local function UnitAvailabilityNone(handle, units)
	for k, _ in pairs(units) do
		if k == RWRoot.playerId then 
			RWRoot.PlayerAvailable = false 
			if RWRoot.Hestia.Active then RWRoot.Hestia.AvailabilityLow() end
			break 
		end
	end	
end

local function UnitAvailabilityPartial(handle, units)
	for k, _ in pairs(units) do
		if k == RWRoot.playerId then 
			RWRoot.PlayerAvailable = false 
			if RWRoot.Hestia.Active then RWRoot.Hestia.AvailabilityLow() end
			break 
		end
	end	
end


-- Activate/Desactivate -----------------------------------------------------------

-- Activate
function RWRoot.Activate()
	if not RWConfig.Active then
	
	RWConfig.Active = true
	RWRoot.MindEye.Awake()
	print(RWRoot.locTxt.Activated)
	
	end
end

-- Desactivate
function RWRoot.Desactivate()
	if RWConfig.Active then
	
	RWRoot.MindEye.Sleep()
	EndCombat()
	RWConfig.Active = false
	print(RWRoot.locTxt.Desactivated)
	
	end
end


-- Command line function -----------------------------------------------------------

function RWRoot.CommandLine(handle, commandline)
    
	-- MinD's Eye
	if commandline == "keep" then 
		if RWRoot.MindEye.MindEyeFrame then RWRoot.MindEye.MindEyeFrame:KeepPlayerTarget() end
	
	elseif commandline == "forget" then
		if RWRoot.MindEye.MindEyeFrame then RWRoot.MindEye.MindEyeFrame:RemovePlayerTarget() end
	
	elseif commandline == "forgetall" then
		if RWRoot.MindEye.MindEyeFrame then RWRoot.MindEye.MindEyeFrame:unkeepAll() end
	
	elseif commandline == "mindeyecfg" then RWRoot.ConfigWinManager:ShowWindow("MindEyeCfgWin")

	-- scanner	
	elseif commandline == "scancfg" then RWRoot.ConfigWinManager:ShowWindow("ScanConfigWin")

	elseif commandline == "scanexplore" then RWRoot.Scanner.ShowReportExplorer()

	elseif commandline == "scanbuff" then RWRoot.Scanner.ScanTargetBuff()

	elseif commandline == "scanon" then RWRoot.Scanner.Activate()
	
	elseif commandline == "scanoff" then RWRoot.Scanner.Desactivate()
	
	-- Hestia
	elseif commandline == "showhestia" then RWRoot.Hestia.ShowFrame()
	
	elseif commandline == "hreport" then RWRoot.Hestia.PrintSessionReport(true)
	
	elseif commandline == "hinitrep" then RWRoot.Hestia.InitSessionReport(true)

	elseif commandline == "hestiacfg" then RWRoot.ConfigWinManager:ShowWindow("HestiaConfigWin")
	
	-- ProxyWarn
	elseif commandline == "proxycfg" then RWRoot.ConfigWinManager:ShowWindow("ProxyWarnCfgWin")

	-- Core	
	elseif commandline == "on" then RWRoot.Activate()
	
	elseif commandline == "off" then RWRoot.Desactivate()
  
	elseif commandline == "test" then RWRoot.ProxyWarn.Test()

	else
		RWRoot.ConfigWinManager:ShowWindow("HermesMainCfgWin")

	end
 
end


-- Saved variables -----------------------------------------------------------

local function SavedVariablesLoadBegin(handle, addonidentifier)

	if addonidentifier == HermesAddonIdentifier then

	end
end

local function SavedVariablesLoadEnd(handle, addonidentifier)

	if addonidentifier == RWData.AddonIdentifier then
		
		-- adjust modified value through versions if needed
		for i = 1, #UpdateRWConfig do
			if (not RWConfig.Version) or MTools.CheckLowerVersion(RWConfig.Version, UpdateRWConfig[i].Version) then
				MTools.CopyData( RWConfig, UpdateRWConfig[i])
			end			
		end
		
		-- adjust fields (remove unused ones and add new ones)
		MTools.AdjustFields(RWConfig, DefaultRWConfig)
		
		-- update the version
		RWConfig.Version = MTools.CopyTable( DefaultRWConfig.Version )

		--RWConfig.Hestia = MTools.CopyTable( DefaultRWConfig.Hestia )
		--RWConfig.HermesButton = MTools.CopyTable( DefaultRWConfig.HermesButton )
		
		-- Init the activated module
		RWRoot.CurrentTime = Inspect.Time.Frame()
		RWRoot.HermesButton.InitButton()
		if RWConfig.Scanner.Active then RWRoot.Scanner.Activate(true) end		
		if RWConfig.ProxyWarn.Active then RWRoot.ProxyWarn.Activate(true) end		
		if RWConfig.MindEye.Active then RWRoot.MindEye.Activate(true) end
		if RWConfig.Hestia.Active then RWRoot.Hestia.Activate(true) end
		
		--RWRoot.Hestia.ShowFrame()
		
		print(RWRoot.locTxt.AddonInitialized .. " - v" .. MTools.GetVersionString(RWConfig.Version))
	end
end

-- launching ! -----------------------------------------------------------

--Command.Event.Attach(Event.Addon.SavedVariables.Load.Begin, SavedVariablesLoadBegin, "SavedVariablesLoadBegin")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, SavedVariablesLoadEnd, "SavedVariablesLoadEnd")

Command.Event.Attach(Event.Combat.Damage, EventCombatDamage, "EventCombatDamage")
Command.Event.Attach(Event.Combat.Heal, EventCombatHeal, "EventCombatHeal")

Command.Event.Attach(Event.Combat.Death, EventCombatDeath, "EventCombatDeath")
Command.Event.Attach(Event.Chat.Npc, EventChatNpc, "EventChatNpc")
Command.Event.Attach(Event.Chat.Notify, EventChatNotify, "EventChatNotify")

Command.Event.Attach(Event.System.Update.Begin, Update, "Update")

Command.Event.Attach(Event.Buff.Add, BuffsAdded, "BuffsAdded")
Command.Event.Attach(Event.Buff.Remove, BuffsRemoved, "BuffsRemoved")

Command.Event.Attach(Event.Unit.Detail.Combat, UnitDetailCombat, "CombatStatusChange")
Command.Event.Attach(Event.System.Secure.Enter, SystemSecureEnter, "StartCombat")
Command.Event.Attach(Event.System.Secure.Leave, SystemSecureLeave, "EndCombat")

Command.Event.Attach(Event.Unit.Availability.Full, UnitAvailabilityFull, "UnitAvailabilityFull")
Command.Event.Attach(Event.Unit.Availability.None, UnitAvailabilityNone, "UnitAvailabilityNone")
Command.Event.Attach(Event.Unit.Availability.Partial, UnitAvailabilityPartial, "UnitAvailabilityPartial")

Command.Event.Attach(Command.Slash.Register("Hermes"), RWRoot.CommandLine, "config")
