----------------------------------------------
--            Hermes main frames            --
----------------------------------------------


RWRoot.AboutWindow = nil
RWRoot.SelfConfigWindows = nil


-- Hermes self config -----------------------------------------------------------

local function buildMovableText(index)

	local Frame = UI.CreateFrame("Frame", "wtext", RWRoot.ConfigWinManager)
	
	Frame.Index = index
	
	Frame.text = UI.CreateFrame("Text", "wtext", Frame)
	Frame.text:SetText(RWRoot.locTxt.cfgWarningMsg .. tostring(index))
	Frame.text:SetPoint("CENTER", Frame, "CENTER")
	Frame.text:SetFontSize(RWConfig.WFontSize)

	Frame:SetHeight(Frame.text:GetHeight()+20)
	Frame:SetWidth(Frame.text:GetWidth()+40)
	Frame:SetBackgroundColor(0, 0, 0, 0.7)
	Frame:SetLayer(-1)
	
	MTools.makeMovable(Frame)
	
	function Frame:InitPos()
		MTools.ClearPoints(self)
		if RWConfig.WTextCoord and RWConfig.WTextCoord[self.Index] then
			self:SetPoint("CENTER", UIParent, "TOPLEFT", unpack(RWConfig.WTextCoord[self.Index]))
		else
			self:SetPoint("CENTER", UIParent, "CENTER",0 , -80 * (self.Index-1))
		end	
	end
	
	function Frame:SavePos()
		if not RWConfig.WTextCoord[self.Index] then RWConfig.WTextCoord[self.Index] = {} end
		RWConfig.WTextCoord[self.Index][1] = math.floor(self:GetLeft() + self:GetWidth()/2)
		RWConfig.WTextCoord[self.Index][2] = math.floor(self:GetTop() + self:GetHeight()/2)	
	end
	
	Frame:InitPos()
	
	return Frame
end


local function BuildSelfConfigWindow()

	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)

	window:SetTitle(RWRoot.locTxt.cfgGeneralOptions)
	window:SetHeight(480)
	window:SetWidth(330)
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	MTools.buildWindowMover("ConfigWindow", window)
		
	window.WText = {}
		
	-- boutons
	window.bbClose =  MTools.buildButton("btClose", window, 50, 50, "x", "close")
	window.bbClose:SetPoint("TOPRIGHT", window, "TOPRIGHT", -8, 15)

	window.btOk =  MTools.buildButton("btOk", window, 100, 40, RWRoot.locTxt.buttonOk)
	window.btOk:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 65, -30)
	
	window.btCancel =  MTools.buildButton("btAnnuler", window, 100, 40, RWRoot.locTxt.buttonCancel)
	window.btCancel:SetPoint("BOTTOMRIGHT", window, "BOTTOMRIGHT", -65, -30)

	-- Addon button
	window.ttAddonButton = MTools.buildShadowTitle("ttAddonButton", window, 290, 25, RWRoot.locTxt.cfgButtonTitle)
	window.ttAddonButton:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 70)

	window.ckButtonActive = MTools.buildCheckBox("ckButtonActive", window, 360, 20, RWRoot.locTxt.cfgActiveButton)
	window.ckButtonActive:SetPoint("TOPLEFT", window.ttAddonButton, "TOPLEFT", 10, 30)

	window.ckLocked = MTools.buildCheckBox("ckLocked", window, 360, 20, RWRoot.locTxt.cfgLockPosition)
	window.ckLocked:SetPoint("TOPLEFT", window.ckButtonActive, "TOPLEFT", 0, 30)

	window.ckOpenAllMenu = MTools.buildCheckBox("ckOpenAllMenu", window, 360, 20, RWRoot.locTxt.cfgOpenAllMenu)
	window.ckOpenAllMenu:SetPoint("TOPLEFT", window.ckLocked, "TOPLEFT", 0, 30)

	window.ckCloseOnClick = MTools.buildCheckBox("ckCloseOnClick", window, 360, 20, RWRoot.locTxt.cfgCloseAfterClic)
	window.ckCloseOnClick:SetPoint("TOPLEFT", window.ckOpenAllMenu, "TOPLEFT", 0, 30)

	window.ckOpenOnMouseOver = MTools.buildCheckBox("ckOpenOnMouseOver", window, 360, 20, RWRoot.locTxt.cfgOpenOnMouseIn)
	window.ckOpenOnMouseOver:SetPoint("TOPLEFT", window.ckCloseOnClick, "TOPLEFT", 0, 30)

	window.ckuseSmallicon = MTools.buildCheckBox("ckuseSmallicon", window, 360, 20, RWRoot.locTxt.cfguseSmallicon)
	window.ckuseSmallicon:SetPoint("TOPLEFT", window.ckOpenOnMouseOver, "TOPLEFT", 0, 30)

	window.ckshowHelp = MTools.buildCheckBox("ckshowHelp", window, 360, 20, RWRoot.locTxt.cfgShowInfoFrame)
	window.ckshowHelp:SetPoint("TOPLEFT", window.ckuseSmallicon, "TOPLEFT", 0, 30)

	-- Frame
	window.ttRaidFrame = MTools.buildShadowTitle("ttRaidFrame", window, 290, 25, RWRoot.locTxt.cfgRaidFilter)
	window.ttRaidFrame:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 310)

	window.ckNoRaidFrame = MTools.buildCheckBox("ckNoRaidFrame", window, 360, 20, RWRoot.locTxt.cfgDisableFilters)
	window.ckNoRaidFrame:SetPoint("TOPLEFT", window.ttRaidFrame, "TOPLEFT", 10, 30)

	window.ckNoFrameTimer = MTools.buildCheckBox("ckNoFrameTimer", window, 360, 20, RWRoot.locTxt.cfgDisableTimers)
	window.ckNoFrameTimer:SetPoint("TOPLEFT", window.ckNoRaidFrame, "TOPLEFT", 00, 30)
	
	
	function window:LoadData()
		for i = 1, RWConst.maxWText do
			self.WText[i]:InitPos()
			self.WText[i]:SetVisible(true)
		end
		-- Addon button
		window.ckButtonActive:SetChecked(RWConfig.HermesButton.Active)
		window.ckLocked:SetChecked(RWConfig.HermesButton.Locked)
		window.ckOpenAllMenu:SetChecked(RWConfig.HermesButton.OpenAllMenu)
		window.ckCloseOnClick:SetChecked(RWConfig.HermesButton.CloseOnClick)
		window.ckOpenOnMouseOver:SetChecked(RWConfig.HermesButton.OpenOnMouseOver)
		window.ckuseSmallicon:SetChecked(RWConfig.HermesButton.useSmallicon)
		window.ckshowHelp:SetChecked(RWConfig.HermesButton.showHelp)
		-- Frame
		window.ckNoRaidFrame:SetChecked(RWConfig.NoRaidFrame)
		window.ckNoFrameTimer:SetChecked(RWConfig.NoFrameTimer)	
	end
	
	function window:SaveData()
		for i = 1, RWConst.maxWText do
			self.WText[i]:SavePos()
		end
		if window.ckButtonActive:GetChecked() ~= RWConfig.HermesButton.Active then
			if RWConfig.HermesButton.Active then
				RWRoot.HermesButton.Desactivate()
			else
				RWRoot.HermesButton.Activate()
			end		
		end		
		-- Addon button
		RWConfig.HermesButton.Locked = window.ckLocked:GetChecked()
		RWConfig.HermesButton.OpenAllMenu = window.ckOpenAllMenu:GetChecked()
		RWConfig.HermesButton.CloseOnClick = window.ckCloseOnClick:GetChecked()
		RWConfig.HermesButton.OpenOnMouseOver = window.ckOpenOnMouseOver:GetChecked()
		RWConfig.HermesButton.useSmallicon = window.ckuseSmallicon:GetChecked()
		RWConfig.HermesButton.showHelp = window.ckshowHelp:GetChecked()
		RWRoot.HermesButton.MainButton:UpdateChanges()
		-- Frame
		RWConfig.NoRaidFrame = window.ckNoRaidFrame:GetChecked()
		RWConfig.NoFrameTimer = window.ckNoFrameTimer:GetChecked()
		print(RWRoot.locTxt.cfgGOptSaved)
	end

	function window:CloseWindow()
		for i = 1, RWConst.maxWText do
			self.WText[i]:SetVisible(false)
		end
		window:SetVisible(false)
	end

	function window.bbClose.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btCancel.Event:LeftPress()
		window.bbClose.Event:LeftPress()		
	end
	
	function window.btOk.Event:LeftPress()
		window:SaveData()
		window.bbClose.Event:LeftPress()		
	end
	
	function window:InitWText()
		for i = 1, RWConst.maxWText do
			self.WText[i] = buildMovableText(i)
		end
	end
	
	window:InitWText()
	
	RWRoot.SelfConfigWindows = window
	return window
end
	

-- About window -----------------------------------------------------------


local function BuildAboutWindow()

	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)

	window:SetTitle(RWRoot.locTxt.About)
	window:SetHeight(632)
	window:SetWidth(632)
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	MTools.buildWindowMover("ConfigWindow", window)
	
	
	window.bbClose =  MTools.buildButton("btClose", window, 50, 50, "x", "close")
	window.bbClose:SetPoint("TOPRIGHT", window, "TOPRIGHT", -8, 15)

	window.btOk =  MTools.buildButton("btOk", window, 130, 40, RWRoot.locTxt.buttonOk)
	window.btOk:SetPoint("BOTTOMCENTER", window, "BOTTOMCENTER", 0, -20)
	
	window.txLine1 = MTools.buildText("txLine1", window, RWRoot.locTxt.aboutWinLine1, 16)
	window.txLine1:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 200)	

	window.txLine2 = MTools.buildText("txLine2", window, RWRoot.locTxt.aboutWinLine2, 16)
	window.txLine2:SetPoint("TOPCENTER", window.txLine1, "TOPCENTER", 0, 25)	

	window.txLine3 = MTools.buildText("txLine3", window, RWRoot.locTxt.aboutWinLine3, 16)
	window.txLine3:SetPoint("TOPCENTER", window.txLine2, "TOPCENTER", 0, 25)	

	window.txLine4 = MTools.buildText("txLine4", window, RWRoot.locTxt.Author .. RWRoot.Data[1], 16)
	window.txLine4:SetPoint("TOPCENTER", window.txLine3, "TOPCENTER", 0, 40)	

	window.txLine5 = MTools.buildText("txLine5", window, RWRoot.Data[2], 16)
	window.txLine5:SetPoint("TOPCENTER", window.txLine4, "TOPCENTER", 0, 25)	

	window.txLine6 = MTools.buildText("txLine6", window, RWRoot.locTxt.aboutWinLine4, 20, {0.80, 0.65, 0.50})
	window.txLine6:SetPoint("TOPCENTER", window.txLine5, "TOPCENTER", 0, 40)	

	window.txLine7 = MTools.buildText("txLine7", window, RWRoot.locTxt.aboutWinLine5, 16)
	window.txLine7:SetPoint("TOPCENTER", window.txLine6, "TOPCENTER", 0, 35)	

	window.txLine8 = MTools.buildText("txLine8", window, RWRoot.locTxt.aboutWinLine6, 16)
	window.txLine8:SetPoint("TOPCENTER", window.txLine7, "TOPCENTER", 0, 25)	

	window.txLine9 = MTools.buildText("txLine9", window, RWRoot.locTxt.aboutWinLine7, 16)
	window.txLine9:SetPoint("TOPCENTER", window.txLine8, "TOPCENTER", 0, 25)		

	window.txLine10 = MTools.buildText("txLine10", window, RWRoot.locTxt.aboutWinLine8, 16)
	window.txLine10:SetPoint("TOPCENTER", window.txLine9, "TOPCENTER", 0, 25)		

	window.txLine12 = MTools.buildText("txLine12", window, RWRoot.locTxt.aboutWinLine9, 16)
	window.txLine12:SetPoint("TOPCENTER", window.txLine10, "TOPCENTER", 0, 35)	

	window.txLine13 = MTools.buildText("txLine13", window, RWRoot.locTxt.aboutWinLine10, 16)
	window.txLine13:SetPoint("TOPCENTER", window.txLine12, "TOPCENTER", 0, 25)	

	window.BackImage = UI.CreateFrame("Texture", "BackImage", window)
	window.BackImage:SetPoint("TOPLEFT", window, "TOPLEFT", 16, 61)
	window.BackImage:SetTexture(RWData.AddonIdentifier, "Resources\\About\\HermesTitle.jpg")

	window.Column1 = UI.CreateFrame("Texture", "Column1", window)
	window.Column1:SetPoint("TOPLEFT", window, "TOPLEFT", 16, 189)
	window.Column1:SetTexture(RWData.AddonIdentifier, "Resources\\About\\clmg1.jpg")

	window.Column1u = UI.CreateFrame("Texture", "Column1u", window)
	window.Column1u:SetPoint("TOPLEFT", window, "TOPLEFT", 84, 189)
	window.Column1u:SetTexture(RWData.AddonIdentifier, "Resources\\About\\clmgu1.png")

	window.Column1d = UI.CreateFrame("Texture", "Column1d", window)
	window.Column1d:SetPoint("TOPLEFT", window, "TOPLEFT", 84, 572)
	window.Column1d:SetTexture(RWData.AddonIdentifier, "Resources\\About\\clmgd1.png")

	window.Column1 = UI.CreateFrame("Texture", "Column1", window)
	window.Column1:SetPoint("TOPRIGHT", window, "TOPRIGHT", -16, 189)
	window.Column1:SetTexture(RWData.AddonIdentifier, "Resources\\About\\clmd1.jpg")

	window.Column1u = UI.CreateFrame("Texture", "Column1u", window)
	window.Column1u:SetPoint("TOPRIGHT", window, "TOPRIGHT", -74, 189)
	window.Column1u:SetTexture(RWData.AddonIdentifier, "Resources\\About\\clmdu1.png")

	window.Column1d = UI.CreateFrame("Texture", "Column1d", window)
	window.Column1d:SetPoint("TOPRIGHT", window, "TOPRIGHT", -74, 572)
	window.Column1d:SetTexture(RWData.AddonIdentifier, "Resources\\About\\clmdd1.png")


	function window.bbClose.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btOk.Event:LeftPress()
		window.bbClose.Event:LeftPress()		
	end
	
	RWRoot.AboutWindow = window	
	return window
end


-- Config window -----------------------------------------------------------


RWConst.AddonButton.LedState = {
	green = "Resources\\ledgreen32.png",
	red = "Resources\\ledred32.png"
}
RWConst.AddonButton.btnConfig = {
	"Resources\\ConfigbtnUp.png",
	"Resources\\ConfigbtnIn.png",
	"Resources\\Configbtndown.png"	
}
RWConst.AddonButton.btnOnOff = {
	"Resources\\onoffUp.png",
	"Resources\\onoffIn.png",
	"Resources\\onoffdown.png"
}


local function buildModuleLine(name, parent, width, height, label, status, CfgWinName)

	local ModuleFrame = UI.CreateFrame("Frame", name, parent)
	
	status = status or false
	
	ModuleFrame:SetHeight(height)
	ModuleFrame:SetWidth(width)
	
	ModuleFrame.ConfigWinName = CfgWinName
	ModuleFrame.Parent = parent
	ModuleFrame.Activated = status
	
	ModuleFrame:SetBackgroundColor( 0, 0, 0, 0.4)

	ModuleFrame.StatusIcon = UI.CreateFrame("Texture", name, ModuleFrame)
	ModuleFrame.StatusIcon:SetPoint("CENTERLEFT", ModuleFrame, "CENTERLEFT", 6, 0)
	
	ModuleFrame.Label = MTools.buildLabel("ModuleLabel", ModuleFrame, width - 200, 20, label)
	ModuleFrame.Label:SetPoint("CENTERLEFT", ModuleFrame, "CENTERLEFT", 40, 0)
	
	ModuleFrame.btOnOff =  MTools.buildIconButton(ModuleFrame, RWConst.AddonButton.btnOnOff)
	ModuleFrame.btOnOff:SetPoint("CENTERLEFT", ModuleFrame, "CENTERLEFT", width - 40, 0)
	
	ModuleFrame.btConfig =  MTools.buildIconButton(ModuleFrame, RWConst.AddonButton.btnConfig)
	ModuleFrame.btConfig:SetPoint("CENTERLEFT", ModuleFrame, "CENTERLEFT", width - 80, 0)
	
	if not CfgWinName then ModuleFrame.btConfig:SetVisible(false) end
	
	function ModuleFrame:UpdateStatus()
		if ModuleFrame.Activated then			
			ModuleFrame.StatusIcon:SetTexture(RWData.AddonIdentifier, RWConst.AddonButton.LedState.green)
		else
			ModuleFrame.StatusIcon:SetTexture(RWData.AddonIdentifier, RWConst.AddonButton.LedState.red)
		end
	end
	
	function ModuleFrame:SetStatus(MStatus)
		ModuleFrame.Activated = MStatus
		ModuleFrame:UpdateStatus()
	end
	
	function ModuleFrame.btConfig:LeftUpHandler()
		RWRoot.ConfigWinManager:ShowWindow(ModuleFrame.ConfigWinName, ModuleFrame:GetParent())
	end

	function ModuleFrame.btOnOff:LeftUpHandler()
		ModuleFrame.Activated = not ModuleFrame.Activated
		ModuleFrame:UpdateStatus()
	end
	
	ModuleFrame:UpdateStatus()
	
	return ModuleFrame
end


local function BuildConfigWindow()

	local window = RWRoot.ConfigWinManager:CreateWindow()
	window:SetVisible(false)

	window:SetTitle("Hermes")
	window:SetHeight(710)
	window:SetWidth(500)
	window:SetPoint("CENTER", UIParent, "CENTER")
	
	MTools.buildWindowMover("ConfigWindow", window)
		
	window.BackImage = 	UI.CreateFrame("Texture", "BackImage", window)
	window.BackImage:SetLayer(-1)
	window.BackImage:SetPoint("TOPCENTER", window, "TOPCENTER", 0, 61)
	window.BackImage:SetTexture(RWData.AddonIdentifier, "resources\\backmain.jpg")
		
	-- boutons
	window.bbClose =  MTools.buildButton("btClose", window, 50, 50, "x", "close")
	window.bbClose:SetPoint("TOPRIGHT", window, "TOPRIGHT", -8, 15)

	window.btOk =  MTools.buildButton("btOk", window, 130, 40, RWRoot.locTxt.buttonOk)
	window.btOk:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 25, -70)
	
	window.btCancel =  MTools.buildButton("btAnnuler", window, 130, 40, RWRoot.locTxt.buttonCancel)
	window.btCancel:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 150, -70)

	window.btAbout =  MTools.buildButton("btAbout", window, 130, 40, RWRoot.locTxt.About)
	window.btAbout:SetPoint("BOTTOMRIGHT", window, "BOTTOMRIGHT", -25, -70)

	-- version!
	window.ckLoadDefault = MTools.buildCheckBox("ckLoadDefault", window, 260, 17, RWRoot.locTxt.cfgRestoreDefault)
	window.ckLoadDefault:SetPoint("BOTTOMLEFT", window, "BOTTOMLEFT", 26, -45)
	
	window.lbVersion = MTools.buildText("lbVersion", window, "v"..RWData.version, 12)
	window.lbVersion:SetPoint("BOTTOMRIGHT", window, "BOTTOMRIGHT", -25, -45)
	
	-- Hermes
	window.ttHermesTitle = MTools.buildShadowTitle("ttHermesTitle", window, 460, 25, RWRoot.locTxt.cfgCoreModTitle, 
		{0.2, 0.4, 0.75, 0.4}, {0.7, 0.8, 1.0})
	window.ttHermesTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 95)

	window.HermesModule = buildModuleLine("HermesModule", window, 460, 40, "Hermes", RWConfig.Active, "HermesSelfCfgWin")
	window.HermesModule:SetPoint("TOPLEFT", window.ttHermesTitle, "TOPLEFT", 0, 30)
	
	-- Modules generaux
	window.ttModulesTitle = MTools.buildShadowTitle("ttModulesTitle", window, 460, 25, RWRoot.locTxt.cfgGeneralMod, 
		{0.75, 0.4, 0.2, 0.4}, {1.0, 0.8, 0.7})
	window.ttModulesTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 200)

	window.ScannerModule = buildModuleLine("HermesScanner", window, 460, 40, RWRoot.locTxt.Scanner.ModuleName, RWConfig.Scanner.Active, "ScanConfigWin")
	window.ScannerModule:SetPoint("TOPLEFT", window.ttModulesTitle, "TOPLEFT", 0,30)

	window.ProxyWarnModule = buildModuleLine("HermesProxyWarn", window, 460, 40, RWRoot.locTxt.ProxyWarn.ModuleName, RWConfig.ProxyWarn.Active, "ProxyWarnCfgWin")
	window.ProxyWarnModule:SetPoint("TOPLEFT", window.ScannerModule, "TOPLEFT", 0, 45)

	window.MindEyeModule = buildModuleLine("HermesMindEye", window, 460, 40, RWRoot.locTxt.MindEye.ModuleName, RWConfig.MindEye.Active, "MindEyeCfgWin")
	window.MindEyeModule:SetPoint("TOPLEFT", window.ProxyWarnModule, "TOPLEFT", 0, 45)

	-- Modules Hors Combat
	window.ttOffCombatTitle = MTools.buildShadowTitle("ttOffCombatTitle", window, 460, 25, RWRoot.locTxt.cfgOffCombatMod, 
		{0.75, 0.4, 0.2, 0.4}, {1.0, 0.8, 0.7})
	window.ttOffCombatTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 365)

	window.HestiaModule = buildModuleLine("HermesHestia", window, 460, 40, RWRoot.locTxt.Hestia.ModuleName, RWConfig.Hestia.Active, "HestiaConfigWin")
	window.HestiaModule:SetPoint("TOPLEFT", window.ttOffCombatTitle, "TOPLEFT", 0, 30)
	
	-- Modules de boss
	window.ttBossModTitle = MTools.buildShadowTitle("ttBossTitle", window, 460, 25, RWRoot.locTxt.cfgBossMod, 
		{0.5, 0.65, 0.2, 0.4}, {0.7, 1.0, 0.7})
	window.ttBossModTitle:SetPoint("TOPLEFT", window, "TOPLEFT", 20, 470)

	window.CruciaModule = buildModuleLine("HermesCrucia", window, 460, 40, RWRoot.locTxt.Crucia.ModuleName, RWConfig.Crucia.Active)
	window.CruciaModule:SetPoint("TOPLEFT", window.ttBossModTitle, "TOPLEFT", 0, 30)
	
	window.MatriarcheModule = buildModuleLine("HermesMatriarche", window, 460, 40, RWRoot.locTxt.Matriarche.ModuleName, RWConfig.Matriarche.Active)
	window.MatriarcheModule:SetPoint("TOPLEFT", window.CruciaModule, "TOPLEFT", 0, 45)

	
	function window:LoadData()
		window.HermesModule:SetStatus(RWConfig.Active)
		window.ScannerModule:SetStatus(RWConfig.Scanner.Active)
		window.ProxyWarnModule:SetStatus(RWConfig.ProxyWarn.Active)
		window.MindEyeModule:SetStatus(RWConfig.MindEye.Active)
		window.HestiaModule:SetStatus(RWConfig.Hestia.Active)
		window.CruciaModule:SetStatus(RWConfig.Crucia.Active)
		window.MatriarcheModule:SetStatus(RWConfig.Matriarche.Active)
		window.ckLoadDefault:SetChecked(false)
	end
	
	function window:SaveData()
		local HermesActivated = window.HermesModule.Activated
		local ScannerActivated = window.ScannerModule.Activated
		local ProxyWarnActivated = window.ProxyWarnModule.Activated
		local MindEyeActivated = window.MindEyeModule.Activated
		local HestiaActivated = window.HestiaModule.Activated
		local CruciaActivated = window.CruciaModule.Activated
		local MatriarcheActivated = window.MatriarcheModule.Activated

		if window.ckLoadDefault:GetChecked() then
			HermesActivated = DefaultRWConfig.Active
			ScannerActivated = DefaultRWConfig.Scanner.Active
			ProxyWarnActivated = DefaultRWConfig.ProxyWarn.Active
			MindEyeActivated = DefaultRWConfig.MindEye.Active
			HestiaActivated = DefaultRWConfig.Hestia.Active
			CruciaActivated = DefaultRWConfig.Crucia.Active
			MatriarcheActivated = DefaultRWConfig.Matriarche.Active
		end
		
		if HermesActivated then RWRoot.Activate() else RWRoot.Desactivate() end
		if ScannerActivated then RWRoot.Scanner.Activate() else RWRoot.Scanner.Desactivate() end
		if ProxyWarnActivated then RWRoot.ProxyWarn.Activate() else RWRoot.ProxyWarn.Desactivate() end
		if MindEyeActivated then RWRoot.MindEye.Activate() else RWRoot.MindEye.Desactivate() end
		if HestiaActivated then RWRoot.Hestia.Activate() else RWRoot.Hestia.Desactivate() end
		if CruciaActivated then RWRoot.Crucia.Activate() else RWRoot.Crucia.Desactivate() end
		if MatriarcheActivated then RWRoot.Matriarche.Activate() else RWRoot.Matriarche.Desactivate() end
		
		if window.ckLoadDefault:GetChecked() then
			RWConfig = MTools.CopyTable( DefaultRWConfig )
			print(RWRoot.locTxt.cfgDefaultLoaded)
		end
	end
	

	function window.btAbout.Event:LeftPress()
		RWRoot.ConfigWinManager:ShowWindow("HermesAboutWin", window)
	end
	
	function window.bbClose.Event:LeftPress()
		RWRoot.ConfigWinManager:CloseWindow()
	end
	
	function window.btCancel.Event:LeftPress()
		window.bbClose.Event:LeftPress()		
	end
	
	function window.btOk.Event:LeftPress()
		window:SaveData()
		window.bbClose.Event:LeftPress()		
	end
	
	RWRoot.ConfigWindow = window
	return window
end


--	Config win registration ----------------------

RWRoot.ConfigWinManager:RegisterWindow("HermesMainCfgWin", BuildConfigWindow)
RWRoot.ConfigWinManager:RegisterWindow("HermesAboutWin", BuildAboutWindow)
RWRoot.ConfigWinManager:RegisterWindow("HermesSelfCfgWin", BuildSelfConfigWindow)
